Package: MBASED
Type: Package
Title: Package containing functions for ASE analysis using
        Meta-analysis Based Allele-Specific Expression Detection
Version: 1.46.0
Date: 2014-08-27
Author: Oleg Mayba, Houston Gilbert
Maintainer: Oleg Mayba <mayba.oleg@gene.com>
Description: The package implements MBASED algorithm for detecting
        allele-specific gene expression from RNA count data, where
        allele counts at individual loci (SNVs) are integrated into a
        gene-specific measure of ASE, and utilizes simulations to
        appropriately assess the statistical significance of observed
        ASE.
biocViews: Sequencing, GeneExpression, Transcription
Depends: RUnit, BiocGenerics, BiocParallel, GenomicRanges,
        SummarizedExperiment
Suggests: BiocStyle
License: Artistic-2.0
git_url: https://git.bioconductor.org/packages/MBASED
git_branch: RELEASE_3_23
git_last_commit: ca73ae8
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 22:42:18 UTC; biocbuild
Built: R 4.6.0; ; 2026-04-29 04:49:01 UTC; unix

### R code from vignette source 'MBASED.Rnw'

###################################################
### code chunk number 1: style-Sweave
###################################################
BiocStyle::latex()


###################################################
### code chunk number 2: example1s_sim_phased
###################################################
set.seed(988482)
library(MBASED)
##a quick look at the main function
args(runMBASED)
## create GRanges object for SNVs of interest.
## note: the only required column is 'aseID'
mySNVs <- GRanges(
  seqnames=c('chr1', 'chr2', 'chr2', 'chr2'),
  ranges=IRanges(start=c(100, 1000, 1100, 1200), width=1),
  aseID=c('gene1', rep('gene2', 3)),
  allele1=c('G', 'A', 'C', 'A'),
  allele2=c('T', 'C', 'T', 'G')	
)
names(mySNVs) <- c('gene1_SNV1', 'gene2_SNV1', 'gene2_SNV2', 'gene2_SNV3')
## create input RangedSummarizedExperiment object
mySample <- SummarizedExperiment(
  assays=list(
    lociAllele1Counts=matrix(
      c(25, 10, 22, 14),
      ncol=1,
      dimnames=list(
       names(mySNVs), 
       'mySample'
      )
    ),
    lociAllele2Counts=matrix(
      c(20,16,15,16),
      ncol=1, 
      dimnames=list(
       names(mySNVs), 
       'mySample'
      )
    )
  ),
  rowRanges=mySNVs
)

##example of use
ASEresults_1s_haplotypesKnown <- runMBASED(
  ASESummarizedExperiment=mySample,
  isPhased=TRUE,
  numSim=10^6,
  BPPARAM = SerialParam()
)

## explore the return object
class(ASEresults_1s_haplotypesKnown)
names(assays(ASEresults_1s_haplotypesKnown))
assays(ASEresults_1s_haplotypesKnown)$majorAlleleFrequency
assays(ASEresults_1s_haplotypesKnown)$pValueASE
assays(ASEresults_1s_haplotypesKnown)$pValueHeterogeneity
rowRanges(ASEresults_1s_haplotypesKnown)
names(metadata(ASEresults_1s_haplotypesKnown))
class(metadata(ASEresults_1s_haplotypesKnown)$locusSpecificResults)
names(assays(metadata(ASEresults_1s_haplotypesKnown)$locusSpecificResults))
assays(metadata(ASEresults_1s_haplotypesKnown)$locusSpecificResults)$allele1IsMajor
assays(metadata(ASEresults_1s_haplotypesKnown)$locusSpecificResults)$MAF
rowRanges(metadata(ASEresults_1s_haplotypesKnown)$locusSpecificResults)

## define function to print out the summary of ASE results
summarizeASEResults_1s <- function(MBASEDOutput) {
  geneOutputDF <- data.frame(
   majorAlleleFrequency=assays(MBASEDOutput)$majorAlleleFrequency[,1],
   pValueASE=assays(MBASEDOutput)$pValueASE[,1],  
   pValueHeterogeneity=assays(MBASEDOutput)$pValueHeterogeneity[,1]
  )   
  lociOutputGR <- rowRanges(metadata(MBASEDOutput)$locusSpecificResults)
  lociOutputGR$allele1IsMajor <- assays(metadata(MBASEDOutput)$locusSpecificResults)$allele1IsMajor[,1]
  lociOutputGR$MAF <- assays(metadata(MBASEDOutput)$locusSpecificResults)$MAF[,1]
  lociOutputList <- split(lociOutputGR, factor(lociOutputGR$aseID, levels=unique(lociOutputGR$aseID))) 
  return(
   list(
     geneOutput=geneOutputDF,
     locusOutput=lociOutputList
   )
  )
}
summarizeASEResults_1s(ASEresults_1s_haplotypesKnown)


###################################################
### code chunk number 3: example1s_sim_unphased
###################################################
summarizeASEResults_1s(
  runMBASED(
    ASESummarizedExperiment=mySample,
    isPhased=FALSE,
    numSim=10^6,
    BPPARAM = SerialParam()
  )
)


###################################################
### code chunk number 4: example1s_noSim
###################################################

##re-run analysis without simulations
summarizeASEResults_1s(
  runMBASED(
    ASESummarizedExperiment=mySample,
    isPhased=FALSE,
    numSim=0,
    BPPARAM = SerialParam()
  )
)$geneOutput



###################################################
### code chunk number 5: example1s_parallel (eval = FALSE)
###################################################
## ##re-run analysis while parallelizing computations
## ## results are same as before 
## ## with some random flactuations due to simulations
## summarizeASEResults_1s(
##   runMBASED(
##     ASESummarizedExperiment=mySample,
##     isPhased=FALSE,
##     numSim=10^6,
##     BPPARAM = MulticoreParam()
##   )
## )$geneOutput
## 
## ## Number of seconds it takes to run results without parallelizing:
## system.time(runMBASED(
##   ASESummarizedExperiment=mySample,
##   isPhased=FALSE,
##   numSim=10^6,
##   BPPARAM = SerialParam()
## ))['elapsed'] ## ~ 15 sec on our machine
## ## Number of seconds it takes to run results with parallelizing:
## system.time(runMBASED(
##  ASESummarizedExperiment=mySample,
##   isPhased=FALSE,
##   numSim=10^6,                        
##   BPPARAM = MulticoreParam()
## ))['elapsed'] ## ~9 sec on our machine
## 


###################################################
### code chunk number 6: binomTestIllustration
###################################################
binom.test(25, 45, 0.5, 'two.sided')$p.value


###################################################
### code chunk number 7: isoform_specific
###################################################
isoSpecificExampleSNVs <- mySNVs[2:4,]	
## create input RangedSummarizedExperiment object
isoSpecificExample <- SummarizedExperiment(
  assays=list(
    lociAllele1Counts=matrix(
      c(23, 65, 30),
      ncol=1,
      dimnames=list(
       names(isoSpecificExampleSNVs), 
       'mySample'
      )
    ),
    lociAllele2Counts=matrix(
      c(26,25,70),
      ncol=1, 
      dimnames=list(
       names(isoSpecificExampleSNVs), 
       'mySample'
      )
    )
  ),
  rowRanges=isoSpecificExampleSNVs
)

summarizeASEResults_1s(
  runMBASED(
    ASESummarizedExperiment=isoSpecificExample,
    isPhased=FALSE,
    numSim=10^6,
    BPPARAM = MulticoreParam()
  )
)



###################################################
### code chunk number 8: example2s
###################################################
mySNVs_2s <- GRanges(
  seqnames=c('chr1', 'chr2', 'chr2', 'chr2', 'chr3'),
  ranges=IRanges(start=c(100, 1000, 1100, 1200, 2000), width=1),
  aseID=c('gene1', rep('gene2', 3), 'gene3'),
  allele1=c('G', 'A', 'C', 'A', 'T'),
  allele2=c('T', 'C', 'T', 'G', 'G')	
)
names(mySNVs_2s) <- c('gene1_SNV1', 'gene2_SNV1', 'gene2_SNV2', 'gene2_SNV3', 'gene3_SNV1')
## create input RangedSummarizedExperiment object
myTumorNormalExample <- SummarizedExperiment(
  assays=list(
    lociAllele1Counts=matrix(
      c(
        c(25,10,35,14,35),
        c(18,17,21,25,40)
      ),
      ncol=2,
      dimnames=list(
       names(mySNVs_2s), 
       c('tumor', 'normal')
      )
    ),
    lociAllele2Counts=matrix(
      c(
        c(20,29,15,40,9),
        c(23,19,24,31,10)
      ),
      ncol=2, 
      dimnames=list(
       names(mySNVs_2s), 
       c('tumor', 'normal')
      )
    )
  ),
  rowRanges=mySNVs_2s
)

##example of use
ASEresults_2s <- runMBASED(
  ASESummarizedExperiment=myTumorNormalExample,
  isPhased=FALSE,
  numSim=10^6,
  BPPARAM = SerialParam()
)

## explore the return object
class(ASEresults_2s)
names(assays(ASEresults_2s))
assays(ASEresults_2s)$majorAlleleFrequencyDifference
assays(ASEresults_2s)$pValueASE
assays(ASEresults_2s)$pValueHeterogeneity
rowRanges(ASEresults_2s)
names(metadata(ASEresults_2s))
class(metadata(ASEresults_2s)$locusSpecificResults)
names(assays(metadata(ASEresults_2s)$locusSpecificResults))
assays(metadata(ASEresults_2s)$locusSpecificResults)$allele1IsMajor
assays(metadata(ASEresults_2s)$locusSpecificResults)$MAFDifference
rowRanges(metadata(ASEresults_2s)$locusSpecificResults)

## define function to print out the summary of ASE results
summarizeASEResults_2s <- function(MBASEDOutput) {
  geneOutputDF <- data.frame(
   majorAlleleFrequencyDifference=assays(MBASEDOutput)$majorAlleleFrequencyDifference[,1],
   pValueASE=assays(MBASEDOutput)$pValueASE[,1],  
   pValueHeterogeneity=assays(MBASEDOutput)$pValueHeterogeneity[,1]
  )   
  lociOutputGR <- rowRanges(metadata(MBASEDOutput)$locusSpecificResults)
  lociOutputGR$allele1IsMajor <- assays(metadata(MBASEDOutput)$locusSpecificResults)$allele1IsMajor[,1]
  lociOutputGR$MAFDifference <- assays(metadata(MBASEDOutput)$locusSpecificResults)$MAFDifference[,1]
  lociOutputList <- split(lociOutputGR, factor(lociOutputGR$aseID, levels=unique(lociOutputGR$aseID))) 
  return(
   list(
     geneOutput=geneOutputDF,
     locusOutput=lociOutputList
   )
  )
}
summarizeASEResults_2s(ASEresults_2s)



###################################################
### code chunk number 9: two_sample_asymmetric
###################################################
## single-SNV gene with strong ASE in tumor (25 vs. 5 reads) 
## and no ASE in normal (22 vs. 23 reads):
mySNV <- GRanges(
  seqnames=c('chr1'),
  ranges=IRanges(start=c(100), width=1),
  aseID=c('gene1'),
  allele1=c('G'),
  allele2=c('T')	
)
names(mySNV) <- c('gene1_SNV1')
summarizeASEResults_2s(
  runMBASED(
    ASESummarizedExperiment=SummarizedExperiment(
      assays=list(
        lociAllele1Counts=matrix(
          c(
            c(25),
            c(22)
          ),
          ncol=2,
          dimnames=list(
           names(mySNV), 
           c('tumor', 'normal')
          )
        ),
        lociAllele2Counts=matrix(
          c(
            c(5),
            c(23)
          ),
          ncol=2, 
          dimnames=list(
           names(mySNV), 
           c('tumor', 'normal')
          )
        )
      ),
      rowRanges=mySNV
    ),
    isPhased=FALSE,
    numSim=10^6,
    BPPARAM=SerialParam()
  )
)
## MBASED detects highly significant ASE.
##
## Now, suppose that the normal sample had the two allele counts 
## exchanged (due to chance variation), :
summarizeASEResults_2s(
  runMBASED(
    ASESummarizedExperiment=SummarizedExperiment(
      assays=list(
        lociAllele1Counts=matrix(
          c(
            c(25),
            c(23) ## used to be 22
          ),
          ncol=2,
          dimnames=list(
           names(mySNV), 
           c('tumor', 'normal')
          )
        ),
        lociAllele2Counts=matrix(
          c(
            c(5),
            c(22) ## used to be 23
          ),
          ncol=2, 
          dimnames=list(
           names(mySNV), 
           c('tumor', 'normal')
          )
        )
      ),
      rowRanges=mySNV
    ),
    isPhased=FALSE,
    numSim=10^6,
    BPPARAM=SerialParam()
  )
)
## We get virtually the same results
##
## Now, suppose we treated normal as sample1 and tumor as sample2
## Let's use original normal sample allele counts
summarizeASEResults_2s(
  runMBASED(
    ASESummarizedExperiment=SummarizedExperiment(
      assays=list(
        lociAllele1Counts=matrix(
          c(
            c(22),
            c(25) 
          ),
          ncol=2,
          dimnames=list(
           names(mySNV), 
           c('normal', 'tumor')
          )
        ),
        lociAllele2Counts=matrix(
          c(
            c(23),
            c(5) 
          ),
          ncol=2, 
          dimnames=list(
           names(mySNV), 
           c('normal', 'tumor')
          )
        )
      ),
      rowRanges=mySNV
    ),
    isPhased=FALSE,
    numSim=10^6,
    BPPARAM=SerialParam()
  )
)
## We appear to have recovered the same result: highly significant MAF difference
## (but note that allele2 is now 'major', since allele classification into 
## major/minor is based entirely on sample1)
## BUT: consider what happens if by chance the allelic
## ratio in the normal was 23/22 instead of 22/23:
summarizeASEResults_2s(
  runMBASED(
    ASESummarizedExperiment=SummarizedExperiment(
      assays=list(
        lociAllele1Counts=matrix(
          c(
            c(23), ## used to be 22
            c(25) 
          ),
          ncol=2,
          dimnames=list(
           names(mySNV), 
           c('normal', 'tumor')
          )
        ),
        lociAllele2Counts=matrix(
          c(
            c(22), ## used to be 23
            c(5) 
          ),
          ncol=2, 
          dimnames=list(
           names(mySNV), 
           c('normal', 'tumor')
          )
        )
      ),
      rowRanges=mySNV
    ),
    isPhased=FALSE,
    numSim=10^6,
    BPPARAM=SerialParam()
  )
)
## MAF difference is large in size but negative and the finding is no longer 
## significant (MBASED uses a 1-tailed significance test).
##
## We therefore strongly emphasize that the proper way to detect normal-specific ASE
## would be to treat normal sample as sample1 and tumor sample as sample2.


###################################################
### code chunk number 10: example1s_refBias_no_adjustment
###################################################
mySNVs
## run MBASED with default values:
summarizeASEResults_1s(
  runMBASED(
    SummarizedExperiment(
      assays=list(
        lociAllele1Counts=matrix(
          c(20,17,15,20),
          ncol=1,
          dimnames=list(
           names(mySNVs), 
           'mySample'
          )
        ),
        lociAllele2Counts=matrix(
          c(25,9,22,10),
          ncol=1, 
          dimnames=list(
           names(mySNVs), 
           'mySample'
          )
        )
      ),
      rowRanges=mySNVs
    ),
    isPhased=FALSE,
    numSim=10^6,
    BPPARAM=SerialParam()
  )
)
## we get the same results by explicitly specifying 50/50 pre-existing allelic probability
summarizeASEResults_1s(
  runMBASED(
    SummarizedExperiment(
      assays=list(
        lociAllele1Counts=matrix(
          c(20,17,15,20),
          ncol=1,
          dimnames=list(
           names(mySNVs), 
           'mySample'
          )
        ),
        lociAllele2Counts=matrix(
          c(25,9,22,10),
          ncol=1, 
          dimnames=list(
           names(mySNVs), 
           'mySample'
          )
        ),
        lociAllele1CountsNoASEProbs=matrix(
          rep(0.5, 4),
          ncol=1, 
          dimnames=list(
           names(mySNVs), 
           'mySample'
          )
        )
      ),
      rowRanges=mySNVs
    ),
    isPhased=FALSE,
    numSim=10^6,
    BPPARAM=SerialParam()
  )
)
 


###################################################
### code chunk number 11: example1s_refBias_adjustment
###################################################
##run the analysis adjusting for pre-existing allelic bias
summarizeASEResults_1s(
  runMBASED(
    SummarizedExperiment(
      assays=list(
        lociAllele1Counts=matrix(
          c(20,17,15,20),
          ncol=1,
          dimnames=list(
           names(mySNVs), 
           'mySample'
          )
        ),
        lociAllele2Counts=matrix(
          c(25,9,22,10),
          ncol=1, 
          dimnames=list(
           names(mySNVs), 
           'mySample'
          )
        ),
        lociAllele1CountsNoASEProbs=matrix(
          c(0.6, 0.6, 0.4, 0.6),
          ncol=1, 
          dimnames=list(
           names(mySNVs), 
           'mySample'
          )
        )
      ),
      rowRanges=mySNVs
    ),
    isPhased=FALSE,
    numSim=10^6,
    BPPARAM=SerialParam()
  )
)



###################################################
### code chunk number 12: overdispersion_example
###################################################
set.seed(5) ## we chose this seed to get a 'significant' result
totalAlleleCounts=c(45, 26, 37, 30)
## simulate allele1 counts
allele1Counts <- MBASED:::vectorizedRbetabinomMR(
  n=4,
  size=totalAlleleCounts,
  mu=rep(0.5, 4), 
  rho=rep(0.02, 4)
)
## run MBASED without accounting for overdispersion
summarizeASEResults_1s(
  runMBASED(
    SummarizedExperiment(
      assays=list(
        lociAllele1Counts=matrix(
          allele1Counts,
          ncol=1,
          dimnames=list(
           names(mySNVs), 
           'mySample'
          )
        ),
        lociAllele2Counts=matrix(
          totalAlleleCounts-allele1Counts,
          ncol=1, 
          dimnames=list(
           names(mySNVs), 
           'mySample'
          )
        )
      ),
      rowRanges=mySNVs
    ),
    isPhased=FALSE,
    numSim=10^6,
    BPPARAM=SerialParam()
  )
)

## this is the same as explicitly setting dispersion parameters to 0.
summarizeASEResults_1s(
  runMBASED(
    SummarizedExperiment(
      assays=list(
        lociAllele1Counts=matrix(
          allele1Counts,
          ncol=1,
          dimnames=list(
           names(mySNVs), 
           'mySample'
          )
        ),
        lociAllele2Counts=matrix(
          totalAlleleCounts-allele1Counts,
          ncol=1, 
          dimnames=list(
           names(mySNVs), 
           'mySample'
          )
        ),
        lociCountsDispersions=matrix(
          rep(0, 4),
          ncol=1, 
          dimnames=list(
           names(mySNVs), 
           'mySample'
          )
        )
      ),
      rowRanges=mySNVs
    ),
    isPhased=FALSE,
    numSim=10^6,
    BPPARAM=SerialParam()
  )
)


## now re-run MBASED supplying the correct dispersion values:
summarizeASEResults_1s(
  runMBASED(
    SummarizedExperiment(
      assays=list(
        lociAllele1Counts=matrix(
          allele1Counts,
          ncol=1,
          dimnames=list(
           names(mySNVs), 
           'mySample'
          )
        ),
        lociAllele2Counts=matrix(
          totalAlleleCounts-allele1Counts,
          ncol=1, 
          dimnames=list(
           names(mySNVs), 
           'mySample'
          )
        ),
        lociCountsDispersions=matrix(
          rep(0.02, 4),
          ncol=1, 
          dimnames=list(
           names(mySNVs), 
           'mySample'
          )
        )
      ),
      rowRanges=mySNVs
    ),
    isPhased=FALSE,
    numSim=10^6,
    BPPARAM=SerialParam()
  )
)



###################################################
### code chunk number 13: session_info
###################################################
sessionInfo()

## size of round-off error I'm tolerating 
## (quantities with differences of this much or smaller 
## are considered the same)

myPrecision <- .Machine$double.eps^0.5 
FULLTESTING <- FALSE
if (FULLTESTING) {
    myBPPARAM <- MulticoreParam(workers=24)
} else {
    myBPPARAM <- SerialParam()
}

## test getSimulationPvalue() function
test_getSimulationPvalue <- function() {
    testVals <- c(1:10, 2)
    manualPvalsLess <- sapply(0:11, function(tVal) {
        if (tVal<2) {
            max(0,tVal/11)
        } else {
            min(1,(tVal+1)/11)
        }
    })
    manualPvalsGreater <- sapply(0:11, function(tVal) {
        if (tVal<=2) {
            min(1,(11-tVal+1)/11)
        } else {
            max(0,(11-tVal)/11)
        }
    })
    automatedPvalsLess <- sapply(0:11, function(tVal) {
        MBASED:::getSimulationPvalue(
            observedVal=tVal, 
            simulatedVals=testVals, 
            direction='less'
        )
    })
    automatedPvalsGreater <- sapply(0:11, function(tVal) {
        MBASED:::getSimulationPvalue(
            observedVal=tVal, 
            simulatedVals=testVals, 
            direction='greater'
        )
    })
    checkEqualsNumeric(
        manualPvalsLess, 
        automatedPvalsLess,
        msg='test_getSimulationPvalue: fail p-values less test'
    )
    checkEqualsNumeric(
        manualPvalsGreater, 
        automatedPvalsGreater,
        msg='test_getSimulationPvalue: fail p-values greater test'
    )
    
    return(TRUE)
}

## test shiftAndAttenuateProportions() function
test_shiftAndAttenuateProportions <- function() {
    ## check1: I will simply check that it does what it's meant to 
    ## for the case of no bias, no over-dispersion
    set.seed(312003)
    numCases <- 100
    for (testInd in numCases) {
        for (numLoci in c(1,2)) {
            for (numCols in 1:2) {
                totalCounts <- sample(10:100, numLoci*numCols) 
                allele1Counts <- rbinom(
                    n=length(totalCounts), 
                    size=totalCounts, 
                    prob=0.5
                )
                countsMat=matrix(
                    allele1Counts, 
                    ncol=numCols
                )
                totalsMat=matrix(
                    totalCounts, 
                    ncol=numCols
                )
                probsMat=matrix(
                    rep(0.5, length(totalCounts)), 
                    ncol=numCols
                )
                rhosMat=matrix(
                    rep(0, length(totalCounts)), 
                    ncol=numCols
                )
                output <- MBASED:::shiftAndAttenuateProportions(
                    countsMat=countsMat, 
                    totalsMat=totalsMat, 
                    probsMat=probsMat,  
                    rhosMat=rhosMat
                ) 
                propsShiftedManual <- countsMat/totalsMat
                propsAttenuatedManual <- (countsMat+0.5)/(totalsMat+1)
                propsShiftedVarsManual <- 
                    propsAttenuatedManual*(1-propsAttenuatedManual)/(totalsMat+1)
                checkEqualsNumeric(
                    propsShiftedManual,
                    output$propsShifted,
                    msg='test shiftAndAttenuateProportions: fail manual comparison test'
                )
                checkEqualsNumeric(
                    dim(propsShiftedManual),
                    dim(output$propsShifted),
                    msg='test shiftAndAttenuateProportions: fail manual comparison test'
                )
                checkEqualsNumeric(
                    propsShiftedVarsManual,
                    output$propsShiftedVars,
                    msg='test shiftAndAttenuateProportions: fail manual comparison test'
                )
                checkEqualsNumeric(
                    dim(propsShiftedVarsManual),
                    dim(output$propsShiftedVars),
                    msg='test shiftAndAttenuateProportions: fail manual comparison test'
                )
            }
        }
    }
    
    return(TRUE)
}
    
## test getPFinal() function
test_getPFinal <- function() {
    ## check1: if true AF is 1, pFinal should also be 1
    always1 <- MBASED:::getPFinal(
        trueAF=1, 
        noASEAF=seq(0.1, 0.9, by=0.1)
    )
    checkTrue(
        all(always1==1),
        msg='test_getPFinal: fail all equal to 1 test'
    )
    
    ## check2: if true AF is 0, pFinal should also be 0
    always0 <- MBASED:::getPFinal(
        trueAF=0, 
        noASEAF=seq(0.1, 0.9, by=0.1)
    )
    checkTrue(
        all(always0==0),
        msg='test_getPFinal: fail all equal to 0 test'
    )
    
    ## check3: if no pre-existing alleic bias, pFinal should be trueAF
    noBiasInitialProbs <- seq(0.1, 0.9, by=0.1)
    noBiasFinalProbs <- sapply(noBiasInitialProbs, function(prob) {
        MBASED:::getPFinal(
            trueAF=prob, 
            noASEAF=0.5
        )
    })
    checkEqualsNumeric(
        noBiasInitialProbs,
        noBiasFinalProbs,
        msg='test_getPFinal: fail no bias test'
    )
    
    ## check4: one manual check for pre-existing allelic bias
    test_trueAF <- 0.3
    test_noASEAFs  <- c(0.2, 0.9)
    biasProbsManual <- sapply(
        test_noASEAFs, 
        function(test_noASEAF) {
            test_noASEAF*test_trueAF/
                (test_noASEAF*test_trueAF + (1-test_noASEAF)*(1-test_trueAF))
        }
    )
    biasProbsAutomated <- MBASED:::getPFinal(
        trueAF=test_trueAF, 
        noASEAF=test_noASEAFs
    )
    checkEqualsNumeric(
        biasProbsManual,
        biasProbsAutomated,
        msg='test_getPFinal: fail manual test'
    )
    
    return(TRUE)
}


## test logLikelihoodCalculator1s() function
test_logLikelihoodCalculator1s <- function() {
    ## rudimentary manual check
    test_noASEProbs <- c(0.2, 0.5)
    test_rhos <- c(0.01, 0.1)
    test_trueHapA <- 0.8
    test_generatingProbs <- MBASED:::getPFinal(
        trueAF=test_trueHapA,
        noASEAF=test_noASEProbs
    ) ## this particular combination gives 0.5 and 0.8 as return probs
    totalCounts <- c(200, 1000) ## high counts lead to greater confidence
    meanCounts <- test_generatingProbs*totalCounts
    LLC <- MBASED:::logLikelihoodCalculator1s(
        lociHapACounts=meanCounts, 
        lociTotalCounts=totalCounts, 
        lociHapANoASEProbs=test_noASEProbs, 
        lociRhos=test_rhos
    )
    neighborhoodRange <- 0.01
    probsToTest <- test_trueHapA + 
        c(
            -neighborhoodRange, 
            0, 
            neighborhoodRange
        )
    neighborhoodLLCVals <- sapply(probsToTest, LLC)
    checkTrue(
        which.max(neighborhoodLLCVals)==2,
        msg='test_logLikelihoodCalculator1s: fail manual test'
    )
    
    return(TRUE)
}

    

## test maxLogLikelihoodCalculator1s() function
test_maxLogLikelihoodCalculator1s <- function() {
    ## rudimentary manual check
    test_noASEProbs <- c(0.2, 0.5)
    test_rhos <- c(0.01, 0.1)
    test_trueHapA <- 0.8
    test_generatingProbs <- MBASED:::getPFinal(
        trueAF=test_trueHapA,
        noASEAF=test_noASEProbs
    ) ## this particular combination gives 0.5 and 0.8 as return probs
    ## high counts lead to greater confidence
    totalCounts <- c(200, 1000) 
    meanCounts <- test_generatingProbs*totalCounts
    MLL <- MBASED:::maxLogLikelihoodCalculator1s(
        lociHapACounts=meanCounts, 
        lociTotalCounts=totalCounts, 
        lociHapANoASEProbs=test_noASEProbs, 
        lociRhos=test_rhos
    )
    neighborhoodRange <- 0.01
    probsToTest <- test_trueHapA + 
        c(
            -neighborhoodRange, 
            0, 
            neighborhoodRange
        )
    distMLEEstimateToProbs <- abs(probsToTest-MLL$maximum)
    checkTrue(
        which.min(distMLEEstimateToProbs)==2,
        msg='maxLogLikelihoodCalculator1s: fail manual test'
    )
    MBASED:::testNumericDiff(
        MLL$maximum, 
        test_trueHapA, 
        cutoff=0.01 ## within 1% of true hapA frequency
    )
    
    return(TRUE)
}

    
## test estimateMAF1s() function
test_estimateMAF1s <- function() {
    ## generate data: both phased and non-phased analysis 
    ## should be performed on my toy example.
    test_trueHapA <- 0.8
    test_trueHapB <- 1-test_trueHapA
    test_noASEProbsHapA <- c(0.25, 0.5)
    test_noASEProbsHapB <- 1-test_noASEProbsHapA
    test_rhos <- c(0.01, 0.1)
    test_generatingProbsHapA <- MBASED:::getPFinal(
        trueAF=test_trueHapA,
        noASEAF=test_noASEProbsHapA
    ) 
    ## high counts lead to greater confidence
    totalCounts <- c(200, 1000) 
    meanCountsHapA <- round(test_generatingProbsHapA*totalCounts)
    ## define phased and non-phased counts
    hapACountsPhased <- meanCountsHapA
    hapBCountsPhased <- totalCounts-meanCountsHapA
    allele1CountsUnphased <- c(
        hapACountsPhased[1], 
        hapBCountsPhased[2]
    )
    allele2CountsUnphased <- totalCounts-allele1CountsUnphased
    test_noASEProbsAllele1 <- c(
        test_noASEProbsHapA[1], 
        test_noASEProbsHapB[2]
    )
    test_noASEProbsAllele2 <- 1-test_noASEProbsAllele1
    outputEstimates <- vector('list')
    outputEstimates[['hapA']] <- lapply(
        c(TRUE, FALSE), 
        function(test_isPhased) {
            MBASED:::estimateMAF1s(
                lociAllele1Counts=hapACountsPhased, 
                lociTotalCounts=totalCounts, 
                lociAllele1NoASEProbs=test_noASEProbsHapA, 
                lociRhos=test_rhos,
                isPhased=test_isPhased
            )
        }
    )
    outputEstimates[['hapB']] <- lapply(
        c(TRUE, FALSE), 
        function(test_isPhased) {
            MBASED:::estimateMAF1s(
                lociAllele1Counts=hapBCountsPhased, 
                lociTotalCounts=totalCounts, 
                lociAllele1NoASEProbs=test_noASEProbsHapB, 
                lociRhos=test_rhos,
                isPhased=test_isPhased
            )
        }
    )
    outputEstimates[['allele1']] <- lapply(
        c(TRUE, FALSE), 
        function(test_isPhased) {
            MBASED:::estimateMAF1s(
                lociAllele1Counts=allele1CountsUnphased, 
                lociTotalCounts=totalCounts, 
                lociAllele1NoASEProbs=test_noASEProbsAllele1, 
                lociRhos=test_rhos,
                isPhased=test_isPhased
           )
        }
    )
    outputEstimates[['allele2']] <- lapply(
        c(TRUE, FALSE), 
        function(test_isPhased) {
            MBASED:::estimateMAF1s(
                lociAllele1Counts=allele2CountsUnphased, 
                lociTotalCounts=totalCounts, 
                lociAllele1NoASEProbs=test_noASEProbsAllele2, 
                lociRhos=test_rhos,
                isPhased=test_isPhased
            )
        }
    )
    for (outputInd in 1:length(outputEstimates)) {
        names(outputEstimates[[outputInd]]) <- c('phased', 'nonPhased')
    }

    ## check1: when data is unphased, all MAF estimates 
    ## should be identical, and major haplotype should be haplotypeA
    for (outputInd in 2:length(outputEstimates)) {
        checkEqualsNumeric(
            outputEstimates[[1]]$nonPhased$MAF,
            outputEstimates[[outputInd]]$nonPhased$MAF,
            msg='test_estimateMAF1s: fail unphased MAF test'
        )
    }
    checkIdentical(
        outputEstimates$hapA$nonPhased$allele1IsMajor,
        c(TRUE, TRUE),
        msg='test_estimateMAF1s: fail unphased MAF test'
    )
    checkIdentical(
        outputEstimates$hapB$nonPhased$allele1IsMajor,
        c(FALSE, FALSE),
        msg='test_estimateMAF1s: fail unphased MAF test'
    )
    checkIdentical(
        outputEstimates$allele1$nonPhased$allele1IsMajor,
        c(TRUE, FALSE),
        msg='test_estimateMAF1s: fail unphased MAF test'
    )
    checkIdentical(
        outputEstimates$allele2$nonPhased$allele1IsMajor,
        c(FALSE, TRUE),
        msg='test_estimateMAF1s: fail unphased MAF test'
    )

    ## check2: when data is phased, hapA and hapB results 
    #3 are the same as when it's unphased
    for (outputName in c('hapA', 'hapB')) {
        checkEquals(
            outputEstimates[[outputName]]$nonPhased,
            outputEstimates[[outputName]]$phased,
            msg='test_estimateMAF1s: fail unphased equals to phased for known haplotypes test'
        )
    }
    
    ## check3: when data is phased, allele1 and allele2 results 
    ## are different from before
    for (outputName in c('allele1', 'allele2')) {
        checkTrue(
            (outputEstimates[[outputName]]$nonPhased$MAF) != 
            (outputEstimates[[outputName]]$phased$MAF),
            msg='test_estimateMAF1s: fail unphased different from phased for unknown haplotypes test'
        )
    }
    
    ## check4: when data is phased, allele1 and allele2 results are 
    ## opposites of each other in terms of haplotype assignment 
    ## but show same MAF
    checkEqualsNumeric(
        outputEstimates$allele1$nonPhased$MAF,
        outputEstimates$allele2$nonPhased$MAF,
        msg='test_estimateMAF1s: fail unphased test'
    )
    checkIdentical(
        outputEstimates$allele1$nonPhased$allele1IsMajor,
        !(outputEstimates$allele2$nonPhased$allele1IsMajor),
        msg='test_estimateMAF1s: fail unphased test'
    )
    
    return(TRUE)
}    
    
    
## test logLikelihoodCalculator2s() function
test_logLikelihoodCalculator2s <- function() {
    ## rudimentary manual check
    test_noASEProbs1s <- c(0.2, 0.5)
    test_noASEProbs2s <- c(0.3, 0.7)
    test_rhos1s <- c(0.01, 0.1)
    test_rhos2s <- c(0.005, 0.05)
    test_trueHapA <- 0.8
    test_generatingProbs1s <- MBASED:::getPFinal(
        trueAF=test_trueHapA,
        noASEAF=test_noASEProbs1s
    ) 
    test_generatingProbs2s <- MBASED:::getPFinal(
        trueAF=test_trueHapA,
        noASEAF=test_noASEProbs2s
    ) 
    ## high counts lead to greater confidence
    totalCounts1s <- c(200, 1000) 
    totalCounts2s <- c(900, 600) 
    meanCounts1s <- round(test_generatingProbs1s*totalCounts1s)
    meanCounts2s <- round(test_generatingProbs2s*totalCounts2s)
    LLC <- MBASED:::logLikelihoodCalculator2s(
        lociHapACountsSample1=meanCounts1s, 
        lociTotalCountsSample1=totalCounts1s, 
        lociHapANoASEProbsSample1=test_noASEProbs1s, 
        lociRhosSample1=test_rhos1s,
        lociHapACountsSample2=meanCounts2s, 
        lociTotalCountsSample2=totalCounts2s, 
        lociHapANoASEProbsSample2=test_noASEProbs2s, 
        lociRhosSample2=test_rhos2s
    )
    neighborhoodRange <- 0.01
    probsToTest <- test_trueHapA + 
        c(
            -neighborhoodRange, 
            0, 
            neighborhoodRange
        )
    neighborhoodLLCVals <- sapply(probsToTest, LLC)
    checkTrue(
        which.max(neighborhoodLLCVals)==2,
        msg='test_logLikelihoodCalculator2s: fail manual test'
    )
    
    return(TRUE)
}
    
## test maxLogLikelihoodCalculator2s() function
test_maxLogLikelihoodCalculator2s <- function() {
    ## rudimentary manual check
    test_noASEProbs1s <- c(0.2, 0.5)
    test_noASEProbs2s <- c(0.3, 0.7)
    test_rhos1s <- c(0.01, 0.1)
    test_rhos2s <- c(0.005, 0.05)
    test_trueHapA <- 0.8
    test_generatingProbs1s <- MBASED:::getPFinal(
        trueAF=test_trueHapA,
        noASEAF=test_noASEProbs1s
    ) 
    test_generatingProbs2s <- MBASED:::getPFinal(
        trueAF=test_trueHapA,
        noASEAF=test_noASEProbs2s
    ) 
    ## high counts lead to greater confidence
    totalCounts1s <- c(200, 1000) 
    totalCounts2s <- c(900, 600) 
    meanCounts1s <- round(test_generatingProbs1s*totalCounts1s)
    meanCounts2s <- round(test_generatingProbs2s*totalCounts2s)
    MLL <- MBASED:::maxLogLikelihoodCalculator2s(
        lociHapACountsSample1=meanCounts1s, 
        lociTotalCountsSample1=totalCounts1s, 
        lociHapANoASEProbsSample1=test_noASEProbs1s, 
        lociRhosSample1=test_rhos1s,
        lociHapACountsSample2=meanCounts2s, 
        lociTotalCountsSample2=totalCounts2s, 
        lociHapANoASEProbsSample2=test_noASEProbs2s, 
        lociRhosSample2=test_rhos2s
    )
    neighborhoodRange <- 0.01
    probsToTest <- test_trueHapA + 
        c(
            -neighborhoodRange, 
            0, 
            neighborhoodRange
        )
    distMLEEstimateToProbs <- abs(probsToTest-MLL$maximum)
    checkTrue(
        which.min(distMLEEstimateToProbs)==2,
        msg='maxLogLikelihoodCalculator2s: fail manual test'
    )
    MBASED:::testNumericDiff(
        MLL$maximum, 
        test_trueHapA, 
        cutoff=0.01 ## within 1% of true hapA frequency
    )
    
    return(TRUE)
}





## test estimateMAF2s() function
test_estimateMAF2s <- function() {
    ## generate data: both phased and non-phased analysis 
    ## should be performed on my toy example.
    test_trueHapA <- 0.8
    test_trueHapB <- 1-test_trueHapA
    test_noASEProbsHapA1s <- c(0.25, 0.5)
    test_noASEProbsHapA2s <- c(0.3, 0.7)
    test_noASEProbsHapB1s <- 1-test_noASEProbsHapA1s
    test_noASEProbsHapB2s <- 1-test_noASEProbsHapA2s
    test_rhos1s <- c(0.01, 0.1)
    test_rhos2s <- c(0.005, 0.05)
    test_generatingProbsHapA1s <- MBASED:::getPFinal(
        trueAF=test_trueHapA,
        noASEAF=test_noASEProbsHapA1s
    ) 
    test_generatingProbsHapA2s <- MBASED:::getPFinal(
        trueAF=test_trueHapA,
        noASEAF=test_noASEProbsHapA2s
    ) 
    ## high counts lead to greater confidence
    totalCounts1s <- c(200, 1000) 
    totalCounts2s <- c(900, 600) 
    meanCountsHapA1s <- round(
        test_generatingProbsHapA1s*totalCounts1s
    )
    meanCountsHapA2s <- round(
        test_generatingProbsHapA2s*totalCounts2s
    )
    ## define phased and non-phased counts
    hapACountsPhased1s <- meanCountsHapA1s
    hapACountsPhased2s <- meanCountsHapA2s
    hapBCountsPhased1s <- totalCounts1s-meanCountsHapA1s
    hapBCountsPhased2s <- totalCounts2s-meanCountsHapA2s
    allele1CountsUnphased1s <- c(
        hapACountsPhased1s[1], 
        hapBCountsPhased1s[2]
    )
    allele1CountsUnphased2s <- c(
        hapACountsPhased2s[1], 
        hapBCountsPhased2s[2]
    )
    allele2CountsUnphased1s <- totalCounts1s-allele1CountsUnphased1s
    allele2CountsUnphased2s <- totalCounts2s-allele1CountsUnphased2s
    test_noASEProbsAllele11s <- c(
        test_noASEProbsHapA1s[1], 
        test_noASEProbsHapB1s[2]
    )
    test_noASEProbsAllele12s <- c(
        test_noASEProbsHapA2s[1], 
        test_noASEProbsHapB2s[2]
    )
    test_noASEProbsAllele21s <- 1-test_noASEProbsAllele11s
    test_noASEProbsAllele22s <- 1-test_noASEProbsAllele12s
    outputEstimates <- vector('list')
    outputEstimates[['hapA']] <- lapply(
        c(TRUE, FALSE), 
        function(test_isPhased) {
            MBASED:::estimateMAF2s(
                lociAllele1CountsSample1=hapACountsPhased1s, 
                lociTotalCountsSample1=totalCounts1s, 
                lociAllele1NoASEProbsSample1=test_noASEProbsHapA1s, 
                lociRhosSample1=test_rhos1s,
                lociAllele1CountsSample2=hapACountsPhased2s, 
                lociTotalCountsSample2=totalCounts2s, 
                lociAllele1NoASEProbsSample2=test_noASEProbsHapA2s, 
                lociRhosSample2=test_rhos2s,
                isPhased=test_isPhased
            )
        }
    )
    outputEstimates[['hapB']] <- lapply(
        c(TRUE, FALSE), 
        function(test_isPhased) {
            MBASED:::estimateMAF2s(
                lociAllele1CountsSample1=hapBCountsPhased1s, 
                lociTotalCountsSample1=totalCounts1s, 
                lociAllele1NoASEProbsSample1=test_noASEProbsHapB1s, 
                lociRhosSample1=test_rhos1s,
                lociAllele1CountsSample2=hapBCountsPhased2s, 
                lociTotalCountsSample2=totalCounts2s, 
                lociAllele1NoASEProbsSample2=test_noASEProbsHapB2s, 
                lociRhosSample2=test_rhos2s,
                isPhased=test_isPhased
            )
        }
    )
    outputEstimates[['allele1']] <- lapply(
        c(TRUE, FALSE), 
        function(test_isPhased) {
            MBASED:::estimateMAF2s(
                lociAllele1CountsSample1=allele1CountsUnphased1s, 
                lociTotalCountsSample1=totalCounts1s, 
                lociAllele1NoASEProbsSample1=test_noASEProbsAllele11s, 
                lociRhosSample1=test_rhos1s,
                lociAllele1CountsSample2=allele1CountsUnphased2s, 
                lociTotalCountsSample2=totalCounts2s, 
                lociAllele1NoASEProbsSample2=test_noASEProbsAllele12s, 
                lociRhosSample2=test_rhos2s,
                isPhased=test_isPhased
            )
        }
    )
    outputEstimates[['allele2']] <- lapply(
        c(TRUE, FALSE), 
        function(test_isPhased) {
            MBASED:::estimateMAF2s(
                lociAllele1CountsSample1=allele2CountsUnphased1s, 
                lociTotalCountsSample1=totalCounts1s, 
                lociAllele1NoASEProbsSample1=test_noASEProbsAllele21s, 
                lociRhosSample1=test_rhos1s,
                lociAllele1CountsSample2=allele2CountsUnphased2s, 
                lociTotalCountsSample2=totalCounts2s, 
                lociAllele1NoASEProbsSample2=test_noASEProbsAllele22s, 
                lociRhosSample2=test_rhos2s,
                isPhased=test_isPhased
            )
        }
    )
    for (outputInd in 1:length(outputEstimates)) {
        names(outputEstimates[[outputInd]]) <- c('phased', 'nonPhased')
    }

    ## check1: when data is unphased, all MAF estimates 
    ## should be identical, and major haplotype should be haplotypeA
    for (outputInd in 2:length(outputEstimates)) {
        checkEqualsNumeric(
            outputEstimates[[1]]$nonPhased$MAF,
            outputEstimates[[outputInd]]$nonPhased$MAF,
            msg='test_estimateMAF1s: fail unphased MAF test'
        )
    }
    checkIdentical(
        outputEstimates$hapA$nonPhased$allele1IsMajor,
        c(TRUE, TRUE),
        msg='test_estimateMAF1s: fail unphased MAF test'
    )
    checkIdentical(
        outputEstimates$hapB$nonPhased$allele1IsMajor,
        c(FALSE, FALSE),
        msg='test_estimateMAF1s: fail unphased MAF test'
    )
    checkIdentical(
        outputEstimates$allele1$nonPhased$allele1IsMajor,
        c(TRUE, FALSE),
        msg='test_estimateMAF1s: fail unphased MAF test'
    )
    checkIdentical(
        outputEstimates$allele2$nonPhased$allele1IsMajor,
        c(FALSE, TRUE),
        msg='test_estimateMAF1s: fail unphased MAF test'
    )

    ## check2: when data is phased, hapA and hapB results are 
    ## the same as when it's unphased
    for (outputName in c('hapA', 'hapB')) {
        checkEquals(
            outputEstimates[[outputName]]$nonPhased,
            outputEstimates[[outputName]]$phased,
            msg='test_estimateMAF1s: fail unphased equals to phased for known haplotypes test'
        )
    }
    
    ## check3: when data is phased, allele1 and allele2 results are 
    ## different from before
    for (outputName in c('allele1', 'allele2')) {
        checkTrue(
            (outputEstimates[[outputName]]$nonPhased$MAF) != 
            (outputEstimates[[outputName]]$phased$MAF),
            msg='test_estimateMAF1s: fail unphased different from phased for unknown haplotypes test'
        )
    }
    
    ## check4: when data is phased, allele1 and allele2 results are 
    ## opposites of each other in terms of haplotype assignment 
    ## but show same MAF
    checkEqualsNumeric(
        outputEstimates$allele1$nonPhased$MAF,
        outputEstimates$allele2$nonPhased$MAF,
        msg='test_estimateMAF1s: fail unphased test'
    )
    checkIdentical(
        outputEstimates$allele1$nonPhased$allele1IsMajor,
        !(outputEstimates$allele2$nonPhased$allele1IsMajor),
        msg='test_estimateMAF1s: fail unphased test'
    )
    
    return(TRUE)
}    

## size of round-off error I'm tolerating 
##(quantities with differences of this much or smaller are considered the same)
myPrecision <- .Machine$double.eps^0.5 
FULLTESTING <- FALSE ## whether everything should be tested
if (FULLTESTING) {
    myBPPARAM <- MulticoreParam(workers=24)
} else {
    myBPPARAM <- SerialParam()
}

## test getMuRho() function
test_getMuRho <- function() {
    ## check1: we get expected values for known case: uniform distribution
    checkEqualsNumeric(
        MBASED:::getMuRho(a=1, b=1)$mu, 
        1/2, 
        msg='test_getMuRho: fail getMuRho uniform distribution test'
    )
    checkEqualsNumeric(
        MBASED:::getMuRho(a=1, b=1)$rho, 
        1/3, 
        msg='test_getMuRho: fail getMuRho uniform distribution test'
    )
    
    ## check2: vectorization works:
    testCasesMat <- expand.grid(
        test_a=10^(-4:4),
        test_b=10^(-4:4)
    )
    testCasesMat$test_mu=with(testCasesMat, 
        test_a/(test_a+test_b)
    )
    testCasesMat$test_rho=with(testCasesMat, 
        1/(1+test_a+test_b)
    )    
    testCasesMat_getMuRho <- with(testCasesMat, 
        MBASED:::getMuRho(a=test_a, b=test_b)
    )
    checkEqualsNumeric(
        testCasesMat$test_mu, 
        testCasesMat_getMuRho$mu, 
        msg='test_getMuRho: fail getMuRho vectorization test'
    )
    checkEqualsNumeric(
        testCasesMat$test_rho, 
        testCasesMat_getMuRho$rho, 
        msg='test_getMuRho: fail getMuRho vectorization test'
    )
    
    return(TRUE)
}

## test getAB() function
test_getAB <- function() {
    ## check1: we get expected values for known case: uniform distribution
    checkEqualsNumeric(
        MBASED:::getAB(mu=1/2, rho=1/3)$a, 
        1, 
        msg='test_getAB: fail getAB uniform distribution test'
    )
    checkEqualsNumeric(
        MBASED:::getAB(mu=1/2, rho=1/3)$b, 
        1, 
        msg='test_getAB: fail getAB uniform distribution test'
    )
    
    ## check2: vectorization works:
    testCasesMat <- expand.grid(
        test_a=10^(-4:4),
        test_b=10^(-4:4)
    )
    testCasesMat$test_mu=with(testCasesMat, 
        test_a/(test_a+test_b)
    )
    testCasesMat$test_rho=with(testCasesMat, 
        1/(1+test_a+test_b)
    )    
    testCasesMat_getAB <- with(testCasesMat, 
        MBASED:::getAB(mu=test_mu, rho=test_rho)
    )
    checkEqualsNumeric(
        testCasesMat$test_a, 
        testCasesMat_getAB$a, 
        msg='test_getAB: fail getAB vectorization test'
    )
    checkEqualsNumeric(
        testCasesMat$test_b, 
        testCasesMat_getAB$b, 
        msg='test_getAB: fail getAB vectorization test'
    )
    
    return(TRUE)
}
    
## test wheter getMuRho and getAB are inverses of each other.
test_getMuRho_getAB <- function() {
    ## check1: functions are inverses of each other:
    testCasesMat <- expand.grid(
        test_a=10^(-4:4),
        test_b=10^(-4:4)
    )
    testCasesMat$test_mu=with(testCasesMat, 
        test_a/(test_a+test_b)
    )
    testCasesMat$test_rho=with(testCasesMat, 
        1/(1+test_a+test_b)
    )
    testResults <- bplapply(1:nrow(testCasesMat), function(testInd) { 
        testCase <- testCasesMat[testInd,]
        testCase_getMuRho <- with(testCase, 
            MBASED:::getMuRho(a=test_a, b=test_b)
        )
        testCase_getAB <- with(testCase, 
            MBASED:::getAB(mu=test_mu, rho=test_rho)
        )
        checkEqualsNumeric(
            testCase$test_mu, 
            testCase_getMuRho$mu, 
            msg=paste('test_getMuRho_getAB: fail getMuRho is inverse of getAB test case #', testInd, sep='')
        )                                                                                                                 
        checkEqualsNumeric(
            testCase$test_rho, 
            testCase_getMuRho$rho, 
            msg=paste('test_getMuRho_getAB: fail getMuRho is inverse of getAB test case #',testInd, sep='')
        )
        checkEqualsNumeric(
            testCase$test_a, 
            testCase_getAB$a, 
            msg=paste('test_getMuRho_getAB: fail getMuRho is inverse of getAB test case #', testInd, sep='')
        )
        checkEqualsNumeric(
            testCase$test_b, 
            testCase_getAB$b, 
            msg=paste('test_getMuRho_getAB: fail getMuRho is inverse of getAB test case #', testInd, sep='')
        )
    }, BPPARAM=myBPPARAM)
    
    return(TRUE)
}

## don't want to require package VGAM, unless full testing should be done
if (FULLTESTING) { 
    library(VGAM)
    ## test vectorizedRbetabinomAB() function
    test_vectorizedRbetabinomAB <- function() {
        ## check1: generated counts have quantiles close to what we expect    
        set.seed(15775)
        quantilesToCheck <- seq(0.1, 0.9, by=0.1)
        numCountsToGenerate <- 10^6
        ## will compare to see if observed quantile is within 
        ## this many standard errors of the true value
        numSEsToCheck=5 
        testCasesMat <- expand.grid(
            test_mu=c(0.001, 0.3, 0.5, 0.7, 0.999),
            test_rho=c(0.001, 0.1, 1/3, 0.7, 0.999),
            test_size=c(1,2,10,100)
        )
        testCasesMat$test_a <- with(testCasesMat, 
            MBASED:::getAB(
                mu=test_mu, 
                rho=test_rho
            )$a
        )
        testCasesMat$test_b <- with(testCasesMat, 
            MBASED:::getAB(
                mu=test_mu, 
                rho=test_rho
            )$b
        )
        testResults <- bplapply(1:nrow(testCasesMat), function(testInd) { 
            testCase <- testCasesMat[testInd,]
            countsAB <- with(testCase, 
                MBASED:::vectorizedRbetabinomAB(
                    n=numCountsToGenerate, 
                    size=rep(test_size, numCountsToGenerate),
                    a=rep(test_a, numCountsToGenerate), 
                    b=rep(test_b, numCountsToGenerate)
                )
            )        
            ## distribution may be chunky, 
            ##so some quantiles might correspond to same number.
            countsABQuantileCounts <- unique(
                unname(quantile(countsAB, quantilesToCheck))
            ) 
            obsFs <- sapply(
                countsABQuantileCounts, 
                function(countsABQuantile) {
                    mean(countsAB<=countsABQuantile)
                }
            )
            predFs <- with(testCase, 
                pbetabinom.ab( 
                    q=countsABQuantileCounts, 
                    size=test_size, 
                    shape1=test_a, 
                    shape2=test_b
                )
            )
            testResults <- MBASED:::testQuantiles(
                theoreticalCumDist=predFs, 
                observedCumDist=obsFs, 
                numTotalCounts=numCountsToGenerate, 
                numSEsToCheck=numSEsToCheck, 
                errorMessage=paste('test_vectorizedRbetabinomAB: fail vectorizedRbetabinomAB quantile test case #',testInd, sep='')
            )
        }, BPPARAM=myBPPARAM)
        
        ## check2: vectorization works 
        set.seed(631844)
        countsABSizeScrambleVec <- sample(
            1:(numCountsToGenerate*nrow(testCasesMat)), 
            replace=FALSE
        )
        countsABSizeUnscrambleVec <- order(countsABSizeScrambleVec)
        countsABSizeScrambled <- with(testCasesMat, 
            MBASED:::vectorizedRbetabinomAB(
                n=numCountsToGenerate*nrow(testCasesMat), 
                size=rep(
                    test_size, 
                    each=numCountsToGenerate
                )[countsABSizeScrambleVec],
                a=rep(
                    test_a, 
                    each=numCountsToGenerate
                )[countsABSizeScrambleVec], 
                b=rep(
                    test_b, 
                    each=numCountsToGenerate
                )[countsABSizeScrambleVec]
            )
        )
        testResults <- bplapply(1:nrow(testCasesMat), function(testInd) { 
            testCase <- testCasesMat[testInd,]
            ## check AB counts generation first
            vecStartInd <- (testInd-1)*numCountsToGenerate+1
            vecEndInd <- testInd*numCountsToGenerate
            countsAB <- countsABSizeScrambled[countsABSizeUnscrambleVec]
            countsAB <- countsAB[vecStartInd:vecEndInd]
            ## distribution may be chunky, 
            ## so some quantiles might correspond to same number.
            countsABQuantileCounts <- unique(
                unname(quantile(countsAB, quantilesToCheck))
            ) 
            obsFs <- sapply(
                countsABQuantileCounts, 
                function(countsABQuantile) {
                    mean(countsAB<=countsABQuantile)
                }
            )
            predFs <- with(testCase, 
                pbetabinom.ab( 
                    q=countsABQuantileCounts, 
                    size=test_size, 
                    shape1=test_a, 
                    shape2=test_b
                )
            )
            testResults <- MBASED:::testQuantiles(
                theoreticalCumDist=predFs, 
                observedCumDist=obsFs, 
                numTotalCounts=numCountsToGenerate, 
                numSEsToCheck=numSEsToCheck, 
                errorMessage=paste('test_vectorizedRbetabinomAB: fail vectorizedRbetabinomAB vectorization test case #',testInd, sep='')
            )
        }, BPPARAM=myBPPARAM)
    
        return(TRUE)
    }
}    

if (FULLTESTING) { ## don't want to require package VGAM, unless full testing should be done
    library(VGAM)
    ## test vectorizedRbetabinomMR() function
    test_vectorizedRbetabinomMR <- function() {
        ## check1:  generated counts have quantiles close to what we expect   
        set.seed(913943)
        quantilesToCheck <- seq(0.1, 0.9, by=0.1)
        numCountsToGenerate <- 10^6
        ## will compare to see if observed quantile is within 
        ## this many standard errors of the true value
        numSEsToCheck=5 
        testCasesMat <- expand.grid(
            test_mu=c(0.001, 0.3, 0.5, 0.7, 0.999),
            test_rho=c(0.001, 0.1, 1/3, 0.7, 0.999),
            test_size=c(1,2,10,100)
        )
        testResults <- bplapply(1:nrow(testCasesMat), function(testInd) { 
            testCase <- testCasesMat[testInd,]
            countsMR <- with(testCase, 
                MBASED:::vectorizedRbetabinomMR(
                    n=numCountsToGenerate, 
                    size=rep(test_size, numCountsToGenerate), 
                    mu=rep(test_mu, numCountsToGenerate), 
                    rho=rep(test_rho, numCountsToGenerate)
                )
            )
            countsMRQuantileCounts <- unique(
                unname(quantile(countsMR, quantilesToCheck))
            )
            obsFs <- sapply(
                countsMRQuantileCounts, 
                function(countsMRQuantile) {
                    mean(countsMR<=countsMRQuantile)
                }
            )
            predFs <- with(testCase, 
                pbetabinom( 
                    q=countsMRQuantileCounts, 
                    size=test_size, 
                    prob=test_mu, 
                    rho=test_rho
                )
            )
            testResults <- MBASED:::testQuantiles(
                theoreticalCumDist=predFs, 
                observedCumDist=obsFs, 
                numTotalCounts=numCountsToGenerate, 
                numSEsToCheck=numSEsToCheck, 
                errorMessage=paste('test_vectorizedRbetabinomMR: fail vectorizedRbetabinomMR quantile test case #',testInd, sep='')
            )
        }, BPPARAM=myBPPARAM)
        
        ## check2: vectorization works for beta-binomial mode
        set.seed(497556)
        countsMuRhoSizeScrambleVec <- sample(
            1:(numCountsToGenerate*nrow(testCasesMat)), 
            replace=FALSE
        )
        countsMuRhoSizeUnscrambleVec <- order(countsMuRhoSizeScrambleVec)
        countsMuRhoSizeScrambled <- with(testCasesMat, 
            MBASED:::vectorizedRbetabinomMR(
                n=numCountsToGenerate*nrow(testCasesMat), 
                size=rep(
                    test_size, 
                    each=numCountsToGenerate
                )[countsMuRhoSizeScrambleVec],
                mu=rep(
                    test_mu, 
                    each=numCountsToGenerate
                )[countsMuRhoSizeScrambleVec], 
                rho=rep(
                    test_rho, 
                    each=numCountsToGenerate
                )[countsMuRhoSizeScrambleVec]
            )
        )
        testResults <- bplapply(1:nrow(testCasesMat), function(testInd) { 
            testCase <- testCasesMat[testInd,]
            vecStartInd <- (testInd-1)*numCountsToGenerate+1
            vecEndInd <- testInd*numCountsToGenerate
            countsMR <- countsMuRhoSizeScrambled[countsMuRhoSizeUnscrambleVec]
            countsMR <- countsMR[vecStartInd:vecEndInd]
            countsMRQuantileCounts <- unique(
                unname(quantile(countsMR, quantilesToCheck))
            )
            obsFs <- sapply(
                countsMRQuantileCounts, 
                function(countsMRQuantile) {
                    mean(countsMR<=countsMRQuantile)
                }
            )
            predFs <- with(testCase, 
                pbetabinom( 
                    q=countsMRQuantileCounts, 
                    size=test_size, 
                    prob=test_mu, 
                    rho=test_rho
                )
            )
            testResults <- MBASED:::testQuantiles(
                theoreticalCumDist=predFs, 
                observedCumDist=obsFs, 
                numTotalCounts=numCountsToGenerate, 
                numSEsToCheck=numSEsToCheck, 
                errorMessage=paste('test_vectorizedRbetabinomMR: fail vectorizedRbetabinomMR vectorization test case #',testInd, sep='')
            )
        }, BPPARAM=myBPPARAM)
    
        ## check3: vectorization works for binomial and beta-binomial modes 
        set.seed(327526)
        testCasesMat <- expand.grid(
            test_mu=c(0.001, 0.3, 0.5, 0.7, 0.999),
            test_rho=c(0, 0.1, 1/3,  0.999),
            test_size=c(1,2,100)
        )
        countsMuRhoSizeScrambleVec <- sample(
            1:(numCountsToGenerate*nrow(testCasesMat)), 
            replace=FALSE
        )
        countsMuRhoSizeUnscrambleVec <- order(countsMuRhoSizeScrambleVec)
        countsMuRhoSizeScrambled <- with(testCasesMat, 
            MBASED:::vectorizedRbetabinomMR(
                n=numCountsToGenerate*nrow(testCasesMat), 
                size=rep(
                    test_size, 
                    each=numCountsToGenerate
                )[countsMuRhoSizeScrambleVec],
                mu=rep(
                    test_mu, 
                    each=numCountsToGenerate
                )[countsMuRhoSizeScrambleVec], 
                rho=rep(
                    test_rho, 
                    each=numCountsToGenerate
                )[countsMuRhoSizeScrambleVec]
            )
        )
        testResults <- bplapply(1:nrow(testCasesMat), function(testInd) { 
            testCase <- testCasesMat[testInd,]
            countsMR <- countsMuRhoSizeScrambled[countsMuRhoSizeUnscrambleVec]
            countsMRStartPos <- ((testInd-1)*numCountsToGenerate+1)
            countsMREndPos <- (testInd*numCountsToGenerate)
            countsMR <- countsMR[countsMRStartPos:countsMREndPos]
            countsMRQuantileCounts <- unique(
                unname(quantile(countsMR, quantilesToCheck))
            )
            obsFs <- sapply(
                countsMRQuantileCounts, 
                function(countsMRQuantile) {
                    mean(countsMR<=countsMRQuantile)
                }
            )
            predFs <- with(testCase, 
                if (isTRUE(all.equal(test_rho, 0))) {
                    pbinom(
                        q=countsMRQuantileCounts, 
                        size=test_size, 
                        prob=test_mu, 
                    )
                } else {
                    pbetabinom( 
                        q=countsMRQuantileCounts, 
                        size=test_size, 
                        prob=test_mu, 
                        rho=test_rho
                    )
                }
            )
            testResults <- MBASED:::testQuantiles(
                theoreticalCumDist=predFs, 
                observedCumDist=obsFs, 
                numTotalCounts=numCountsToGenerate, 
                numSEsToCheck=numSEsToCheck, 
                errorMessage=paste('test_vectorizedRbetabinomMR: fail vectorizedRbetabinomMR vectorization test case #',testInd, sep='')
            )
        }, BPPARAM=myBPPARAM)
    
        return(TRUE)
    }
}    


    

## size of round-off error I'm tolerating 
##(quantities with differences of this much or smaller are considered the same)
myPrecision <- .Machine$double.eps^0.5 
FULLTESTING <- FALSE
if (FULLTESTING) {
    myBPPARAM <- MulticoreParam(workers=24)
} else {
    myBPPARAM <- SerialParam()
}

## test MBASEDVectorizedMetaprop() function
## do not want to load packages VGAM, meta, 
## unless full testing mode is on
if (FULLTESTING) { 
    library(VGAM)
    library(meta)
    test_MBASEDVectorizedMetaprop <- function() { 
        ## check1: vectorization works for both a single locus gene 
        ## and multi-loci genes
        set.seed(125450)
        numCases <- 100
        for (numLoci in c(1, 4)) {
            test_ns_mat <- matrix(
                sample(10:20, numCases*numLoci, replace=T), 
                nrow=numLoci, 
                ncol=numCases
            )
            test_xs_mat <- matrix(
                sample(0:10, numCases*numLoci, replace=T), 
                nrow=numLoci, 
                ncol=numCases
            )
            test_mus_mat <- matrix(
                sample(seq(0.1, 0.9, by=0.1), numCases*numLoci, replace=T), 
                nrow=numLoci, 
                ncol=numCases
            )
            test_rhos_mat <- matrix(
                sample(c(0,0.01, 0.3, 0.9), numCases*numLoci, replace=T), 
                nrow=numLoci, 
                ncol=numCases
            )
            for (test_AH in c('greater', 'less', 'two.sided')) {
                individualResults <- bplapply(1:numCases, function(colInd) { 
                    MBASED:::MBASEDVectorizedMetaprop(
                        countsMat=matrix(
                            test_xs_mat[,colInd], 
                            nrow=numLoci, 
                            ncol=1
                        ), 
                        totalsMat=matrix(
                            test_ns_mat[,colInd], 
                            nrow=numLoci, 
                            ncol=1
                        ), 
                        probsMat=matrix(
                            test_mus_mat[,colInd], 
                            nrow=numLoci, 
                            ncol=1
                        ), 
                        rhosMat=matrix(
                            test_rhos_mat[,colInd], 
                            nrow=numLoci, 
                            ncol=1
                        ), 
                        alternative=test_AH
                    )
                }, BPPARAM=myBPPARAM)
                jointResults <- MBASED:::MBASEDVectorizedMetaprop(
                    countsMat=test_xs_mat, 
                    totalsMat=test_ns_mat, 
                    probsMat=test_mus_mat, 
                    rhosMat=test_rhos_mat, 
                    alternative=test_AH
                )
                for (outputName in names(jointResults)) {
                    checkEqualsNumeric(
                        jointResults[[outputName]], 
                        do.call(
                            cbind,
                            lapply(
                                individualResults, 
                                function(el) {
                                    el[[outputName]]
                                }
                            )
                        ), 
                        msg='test_MBASEDVectorizedMetaprop: fail vectorization test'
                    )
                }
            }
        }
            
        ## check2: for large n, reasonable mu/rho (or p, in case of binomial), 
        ## single-locus approach should produce pvalues similar to 
        ## (beta)binomial tests (apart from possibly very small p-values). 
        ## Further, the estimate should be (possibly adjusted) 
        ## back-transformed FT estimate 
        ## (we previously checked the behavior of adjustment 
        ## and back-transformation).
        set.seed(72286)
        test_n <- 10^6
        testCasesMat <- expand.grid(
            test_mu=seq(0.2, 0.8, by=0.1),
            test_rho=c(0, 0.01),
            test_AH=c('greater', 'less', 'two.sided')
        )
        numCountsToGenerate <- 10^6
        testResults <- bplapply(1:nrow(testCasesMat), function(testInd) {
            testCase <- testCasesMat[testInd,]
            testCounts <- with(testCase, 
                MBASED:::vectorizedRbetabinomMR(
                    n=numCountsToGenerate,
                    size=rep(test_n, numCountsToGenerate),
                    mu=rep(test_mu, numCountsToGenerate),
                    rho=rep(test_rho, numCountsToGenerate)
                )
            )
            predEstimates <- MBASED:::unFT(
                z=MBASED:::FTAdjust(
                    x=testCounts, 
                    n=rep(test_n, numCountsToGenerate), 
                    p=rep(testCase$test_mu, numCountsToGenerate)
                ), 
                n=rep(test_n, numCountsToGenerate)
            )
            if (isTRUE(all.equal(testCase$test_rho,0))) { ## binomial setting
                cumProbs <- pbinom(
                    q=testCounts, 
                    size=test_n, 
                    prob=testCase$test_mu
                )
            } else { ## beta-binomial setting
                cumProbs <- pbetabinom(
                    q=testCounts, 
                    size=test_n, 
                    prob=testCase$test_mu, 
                    rho=testCase$test_rho
                )
            }            
            if (testCase$test_AH=='greater') {
                predPvals <- 1-cumProbs
            } else if (testCase$test_AH=='less') {
                predPvals <- cumProbs
            } else {
                predPvals <- pmin(1,2*pmin(cumProbs, 1-cumProbs))
            }
            MBASEDVectorizedMetapropOutput <- with(testCase, 
                MBASED:::MBASEDVectorizedMetaprop(
                    countsMat=matrix(
                        testCounts, 
                        nrow=1, 
                        ncol=numCountsToGenerate
                    ), 
                    totalsMat=matrix(
                        rep(test_n, numCountsToGenerate), 
                        nrow=1, 
                        ncol=numCountsToGenerate
                    ), 
                    probsMat=matrix(
                        rep(test_mu, numCountsToGenerate), 
                        nrow=1, 
                        ncol=numCountsToGenerate
                    ), 
                    rhosMat=matrix(
                        rep(test_rho, numCountsToGenerate), 
                        nrow=1, 
                        ncol=numCountsToGenerate
                    ), 
                    alternative=as.character(test_AH)
                )
            )
            obsEstimates <- as.vector(MBASEDVectorizedMetapropOutput$propFinal)
            checkEqualsNumeric(
                obsEstimates, 
                predEstimates, 
                msg='test_MBASEDVectorizedMetaprop: fail comparison to binom/betabinom test'
            )
            obsPvals <- as.vector(MBASEDVectorizedMetapropOutput$pValue)
            checkTrue(
                all(
                    (pmax(obsPvals, predPvals)<=0.01) |
                    MBASED:::testNumericDiff(
                        queryVals=obsPvals, 
                        targetVals=predPvals, 
                        cutoffFraction=0.2 ## within 20%
                    )
                ),
                msg='test_MBASEDVectorizedMetaprop: fail comparison to binom/betabinom test'
            ) 
        }, BPPARAM=myBPPARAM)
    
    ## check3: should produce same results as package meta 
    ## (except possibly for MAF estimate, since that depends 
    ## on slightly different backtransformation) 
    ## for binomial counts and two-sided alternative.
        set.seed(336924)
        numCases <- 100 ## number of samples to test
        test_AHs <- c('greater', 'less', 'two.sided')
        for (numLoci in c(2,10)) { 
            test_ns_mat <- matrix(
                sample(10:20,  numCases*numLoci, replace=T), 
                nrow=numLoci, 
                ncol=numCases
            )
            test_xs_mat <- matrix(
                sample(0:10,  numCases*numLoci, replace=T), 
                nrow=numLoci, 
                ncol=numCases
            )
            test_ps_mat <- matrix(
                0.5, 
                nrow=numLoci, 
                ncol=numCases
            )
            test_rhos_mat <- matrix(
                0, 
                nrow=numLoci, 
                ncol=numCases
            )
            for (test_AH in c('greater', 'less', 'two.sided')) {
                testResults <- bplapply(1:numCases, function(colInd) { 
                    MBASEDVectorizedMetapropOutputFixed <-
                        MBASED:::MBASEDVectorizedMetaprop(
                            countsMat=test_xs_mat[,colInd, drop=F], 
                            totalsMat=test_ns_mat[,colInd, drop=F],  
                            probsMat=test_ps_mat[,colInd, drop=F],  
                            rhosMat=test_rhos_mat[,colInd, drop=F],  
                            alternative=test_AH
                        )
                    metaOutput <- metaprop(
                        test_xs_mat[,colInd], 
                        test_ns_mat[,colInd], 
                        sm="PFT"
                    )
                    checkEqualsNumeric(
                        MBASEDVectorizedMetapropOutputFixed$hetQ, 
                        metaOutput$Q, 
                        msg='test_MBASEDVectorizedMetaprop: fail meta comparison test'
                    )
                    checkEqualsNumeric(
                        MBASEDVectorizedMetapropOutputFixed$hetPVal, 
                        1-pchisq(metaOutput$Q, metaOutput$df.Q), 
                        msg='test_MBASEDVectorizedMetaprop: fail meta comparison test'
                    )
                    checkEqualsNumeric(
                        MBASEDVectorizedMetapropOutputFixed$TEFinal, 
                        metaOutput$TE.fixed, 
                        msg='test_MBASEDVectorizedMetaprop: fail meta comparison test'
                    )
                    checkEqualsNumeric(
                        MBASEDVectorizedMetapropOutputFixed$seTEFinal, 
                        metaOutput$seTE.fixed, 
                        msg='test_MBASEDVectorizedMetaprop: fail meta comparison test'
                    )
                    MBASEDVectorizedMetaprop_backtransformN <- 
                        weighted.mean(
                            x=test_ns_mat[,colInd], 
                            w=test_ns_mat[,colInd]
                        )
                    metaOutput_backtransformN <- 
                        exp(mean(log(test_ns_mat[,colInd])))
                    checkEqualsNumeric(
                        MBASEDVectorizedMetapropOutputFixed$propFinal, 
                        meta:::asin2p(
                            metaOutput$TE.fixed,
                            MBASEDVectorizedMetaprop_backtransformN
                        ), 
                        msg='test_MBASEDVectorizedMetaprop: fail meta comparison test'
                    )
                    metaOutputPropFixed <- suppressWarnings(
                        meta:::asin2p(
                            metaOutput$TE.fixed, 
                            metaOutput_backtransformN
                        )
                    )
                    diffBetweenEstimates <- abs(
                        MBASEDVectorizedMetapropOutputFixed$propFinal-
                        metaOutputPropFixed
                    )
                    minOfTwoEstimates <- min(c(
                        MBASEDVectorizedMetapropOutputFixed$propFinal,
                        metaOutputPropFixed
                    ))
                    checkTrue( 
                        (abs(
                            MBASEDVectorizedMetapropOutputFixed$propFinal-
                            metaOutputPropFixed
                        )<=0.01) || 
                        MBASED:::testNumericDiff(
                            queryVals=obsPvals, 
                            targetVals=predPvals, 
                            cutoffFraction=0.05 ## within 5%
                        ),
                        msg='test_MBASEDVectorizedMetaprop: fail meta comparison test'
                    )
                    metaOutputZvalFixed <- 
                        (metaOutput$TE.fixed-pi/2)/(metaOutput$seTE.fixed)
                    if (test_AH=='greater') {
                        checkEqualsNumeric(
                            MBASEDVectorizedMetapropOutputFixed$pValue, 
                            1-pnorm(metaOutputZvalFixed), 
                            msg='test_MBASEDVectorizedMetaprop: fail meta comparison test'
                        )
                    } else if (test_AH=='less') {
                        checkEqualsNumeric(
                            MBASEDVectorizedMetapropOutputFixed$pValue, 
                            pnorm(metaOutputZvalFixed), 
                            msg='test_MBASEDVectorizedMetaprop: fail meta comparison test'
                        )
                    } else if (test_AH=='two.sided') {
                        checkEqualsNumeric(
                            MBASEDVectorizedMetapropOutputFixed$pValue, 
                            min(c(
                                1,
                                2*min(c(
                                    pnorm(metaOutputZvalFixed), 
                                    1-pnorm(metaOutputZvalFixed)
                                ))
                            )), 
                            msg='test_MBASEDVectorizedMetaprop: fail meta comparison test')
                    } else {
                        stop('test_MBASEDVectorizedMetaprop: fail meta comparison test: unknown alternative hypothesis')
                    }
                }, BPPARAM=myBPPARAM)    
            }
        }        
        return(TRUE)
    }
}    
    
    

## GENERAL FRAMEWORK FOR TEST CASES FOR
## test_runMBASED1s1aseID() and test_runMBASED1s(): 
## Try out n=10,11,12,..,20, 50, 51, 100, 101, 1000, 1001. 
## For each n, test (when possible) x={0,1,2}(small), 
## {n, n-1, n-2}(large), {floor(n/2-1), floor(n/2), floor(n/2+1)} (mean), 
## and 10 random values.
## For each combination of n and x, try mu={0.4, 0.45, 0.5, 0.55, 0.6}
## For each combination of n, x, mu, try rho={0, 0.01, 0.1}
set.seed(897134)
my_ns <- c(10:20, 50, 51, 100, 101, 1000, 1001)
my_xn_combos <- unlist(lapply(my_ns, function(n) {
    candidate_xs <- c(
        0:2, 
        n-(0:2), 
        floor(n/2-1), 
        floor(n/2), 
        floor(n/2+1), 
        sample(0:n, 10, replace=TRUE)
    )
    candidate_xs <- candidate_xs[candidate_xs>=0 & candidate_xs<=n]
    candidate_xs <- unique(sort(candidate_xs, decreasing=FALSE))
    return(paste(n, candidate_xs, sep='_'))
}))
AllTestCasesMat <- expand.grid(
    test_xn_combo=my_xn_combos,
    test_mu=seq(0.4, 0.6, by=0.05),
    test_rho=c(0, 0.01, 0.1)
)
AllTestCasesMat$test_n <- as.numeric(
    matrix(
        unlist(strsplit(as.character(AllTestCasesMat$test_xn_combo), '_')), 
        ncol=2, 
        byrow=TRUE
    )[,1]
)
AllTestCasesMat$test_x <- as.numeric(
    matrix(
        unlist(strsplit(as.character(AllTestCasesMat$test_xn_combo), '_')), 
        ncol=2, 
        byrow=TRUE
    )[,2]
)
rm(
    my_ns,
    my_xn_combos
)

## helper function to get test cases from the matrix of all test cases
## returns a matrix with test cases of interest spread over a desired matrix
getTestCases <- function(numCases, numLoci) {
    testCasesInds <- sample(
        1:nrow(AllTestCasesMat), 
        numCases*numLoci, 
        replace=TRUE
    )
    test_ns_mat <- matrix(
        AllTestCasesMat$test_n[testCasesInds], 
        nrow=numLoci, 
        ncol=numCases
    )
    test_xs_mat <- matrix(
        AllTestCasesMat$test_x[testCasesInds], 
        nrow=numLoci, 
        ncol=numCases
    )
    test_mus_mat <- matrix(
        AllTestCasesMat$test_mu[testCasesInds], 
        nrow=numLoci, 
        ncol=numCases
    )
    test_rhos_mat <- matrix(
        AllTestCasesMat$test_rho[testCasesInds], 
        nrow=numLoci, 
        ncol=numCases
    )
    return(
        list(
            n=test_ns_mat,
            x=test_xs_mat,
            mu=test_mus_mat,
            rho=test_rhos_mat
        )
    )
}

## helper function to get individual test case (column) 
## from output of getTestCases()
getTestCase <- function(testCasesMats, testInd) {
    return(
        list(
            n=testCasesMats$n[,testInd],
            x=testCasesMats$x[,testInd],
            mu=testCasesMats$mu[,testInd],
            rho=testCasesMats$rho[,testInd]
        )
    )
}


## test behavior of runMBASED1s1aseID() function 
test_runMBASED1s1aseID <- function() { 
    ## check1: for single-locus gene argument isPhased 
    ## has no effect on the output.
    set.seed(898639)
    if (FULLTESTING) {
        numCases <- 1000 ## number of test cases
    } else {
        numCases <- 3 ## number of test cases
    }
    numLoci <- 1 ## number of loci
    testCasesMats <- getTestCases(
        numCases=numCases, 
        numLoci=numLoci
    )
    ## check for all possible values of tieBreakRandom
    for (test_tieBreakRandom in c(TRUE,FALSE)) { 
    	## check for both simulations and no-simulations cases
        for (test_numSim in c(0, 3)) { 
        	## this is to ensure that the same simulations are used 
        	## to produce p-values in case of simulated data
            testIndSeeds <- sample(1:(10^6), numCases, replace=TRUE) 
            testResults <- bplapply(1:numCases, function(testInd) {
                testCase <- getTestCase(
                    testCasesMats=testCasesMats, 
                    testInd=testInd
                )
                test_seed <- testIndSeeds[testInd]
                testOutputs <- lapply(c(TRUE, FALSE), function(test_isPhased) {
                    set.seed(test_seed) 
                    MBASED:::runMBASED1s1aseID(
                        lociAllele1Counts=testCase$x, 
                        lociAllele2Counts=testCase$n-testCase$x, 
                        lociAllele1NoASEProbs=testCase$mu, 
                        lociRhos=testCase$rho, 
                        numSim=test_numSim, 
                        isPhased=test_isPhased, 
                        tieBreakRandom=test_tieBreakRandom
                    )
                })
                checkEquals(
                    testOutputs[[1]], 
                    testOutputs[[2]], 
                    msg='test_runMBASED1s1aseID: failed test to see that isPhased does not affect output'    
                )            
            }, BPPARAM=myBPPARAM)
        }
    }
    rm(
        numCases, 
        numLoci, 
        testCasesMats,
        test_tieBreakRandom,
        test_numSim,
        testIndSeeds,
        testResults
    )

    ## check 2: argument tieBreakRandom does not affect allele frequencies 
    ## or heterogeneity statistic. It does not affect p-values if no simulations 
    ## are performed (some effect will be observed with simulations 
    ## due to random variation)
    set.seed(643129)
    if (FULLTESTING) {
        numCases <- 1000 ## number of test cases
    } else {
        numCases <- 3 ## number of test cases
    }
    for (numLoci in c(1,5)) {## number of loci 
        testCasesMats <- getTestCases(
            numCases=numCases, 
            numLoci=numLoci
        )
        ## check for both simulations and no-simulations cases
        for (test_numSim in c(0, 3)) { 
        	## check for both settings of isPhased
            for (test_isPhased in c(TRUE, FALSE)) { 
                testResults <- bplapply(1: numCases, function(testInd) {
                    testCase <- getTestCase(
                        testCasesMats=testCasesMats, 
                        testInd=testInd
                    )
                    testOutputs <- lapply(
                        c(TRUE, FALSE), 
                        function(test_tieBreakRandom) {
                            MBASED:::runMBASED1s1aseID(
                                lociAllele1Counts=pmax(1,testCase$x), 
                                ## make sure we have ties 
                                lociAllele2Counts=pmax(1,testCase$x), 
                                lociAllele1NoASEProbs=testCase$mu, 
                                lociRhos=testCase$rho, 
                                numSim=test_numSim, 
                                isPhased=test_isPhased, 
                                tieBreakRandom=test_tieBreakRandom
                            )    
                        }
                    )
                    outputNamesToCheck <- setdiff(
                        names(testOutputs[[1]]), 
                        'lociAllele1IsMajor'
                    )
                    if (test_numSim>0) {
                        outputNamesToCheck <- setdiff(
                            outputNamesToCheck, 
                            c('pValueASE', 'pValueHeterogeneity')
                        )
                    }
                    for (outputName in outputNamesToCheck) {
                        checkEqualsNumeric(
                            testOutputs[[1]][[outputName]],
                            testOutputs[[2]][[outputName]],
                            msg='test_runMBASED1s1aseID: failed test to see that tieBreakRandom does not affect output apart from assigning alleles to haplotypes'
                        )
                    }
                }, BPPARAM=myBPPARAM)
            }
        }
    }
    rm(
        numCases, 
        numLoci, 
        testCasesMats,
        test_numSim,
        test_isPhased,
        testResults
    )
        
    ## check 3:  with no simulations return the same result as 
    ## MBASEDVectorizedMetaprop with alternative hypothesis set to
    ## 'two.sided' and with additional step of picking the larger 
    ## of allelic frequencies to be 'major'
    ## use tieBreakRandom=FALSE for simplicity. 
    ## Later will check that tie-breaking works as intended.
    set.seed(136565)
    if (FULLTESTING) {
        numCases <- 1000 ## number of test cases
    } else {
        numCases <- 3 ## number of test cases
    }
    for (numLoci in c(1,5)) { ## number of loci
        testCasesMats <- getTestCases(
            numCases=numCases, 
            numLoci=numLoci
        )
        testResults <- bplapply(1:numCases, function(testInd) {
            testCase <- getTestCase(
                testCasesMats=testCasesMats, 
                testInd=testInd
            )
            for (test_isPhased in c(TRUE, FALSE)) {
                if (!test_isPhased) { ## data will be phased by MBASED
                    test_x_is_major <- MBASED:::isCountMajorFT(
                        x=testCase$x, 
                        n=testCase$n, 
                        p=testCase$mu, 
                        tieBreakRandom=FALSE
                    )
                    test_maj <- ifelse(
                        test_x_is_major, 
                        testCase$x, 
                        testCase$n-testCase$x
                    )
                    test_prob_maj <- ifelse(
                        test_x_is_major, 
                        testCase$mu, 
                        1-testCase$mu
                    )
                } else { ## data will not be phased by MBASED
                	## whether it's really major or not, will be determined later
                    test_maj <- testCase$x 
                    test_prob_maj <- testCase$mu
                }
                MBASEDVectorizedMetapropOutput <- 
                    MBASED:::MBASEDVectorizedMetaprop(
                        countsMat=matrix(
                            test_maj, 
                            nrow=numLoci, 
                            ncol=1
                        ), 
                        totalsMat=matrix(
                            testCase$n, 
                            nrow=numLoci, 
                            ncol=1
                        ), 
                        probsMat=matrix(
                            test_prob_maj,
                            nrow=numLoci, 
                            ncol=1
                        ), 
                        rhosMat=matrix(
                            testCase$rho, 
                            nrow=numLoci, 
                            ncol=1
                        ), 
                        alternative='two.sided'
                    )    
               ## now we can check to see if the supplied allele was major or not
                if (test_isPhased) { 
                    if (MBASEDVectorizedMetapropOutput$propFinal<0.5) {
                        test_x_is_major=rep(FALSE, length(testCase$x))
                    } else {
                        test_x_is_major=rep(TRUE, length(testCase$x))
                    }
                }
                runMBASED1s1aseIDOutput <- 
                    MBASED:::runMBASED1s1aseID(
                        lociAllele1Counts=testCase$x, 
                        lociAllele2Counts=testCase$n-testCase$x, 
                        lociAllele1NoASEProbs=testCase$mu, 
                        lociRhos=testCase$rho, 
                        numSim=0, 
                        isPhased=test_isPhased,
                        tieBreakRandom=FALSE
                    )
                checkEqualsNumeric(
                    as.vector(pmax(
                        MBASEDVectorizedMetapropOutput$propFinal, 
                        1-MBASEDVectorizedMetapropOutput$propFinal)
                    ), 
                    runMBASED1s1aseIDOutput$majorAlleleFrequency, 
                    msg=paste('test_runMBASED1s1aseID: failed comaprison with MBASEDVectorizedMetaprop test')
                )
                checkEqualsNumeric(
                    as.vector(MBASEDVectorizedMetapropOutput$pValue), 
                    runMBASED1s1aseIDOutput$pValueASE, 
                    msg=paste('test_runMBASED1s1aseID: failed comaprison with MBASEDVectorizedMetaprop test')
                )
                checkEqualsNumeric(
                    as.vector(MBASEDVectorizedMetapropOutput$hetQ), 
                    runMBASED1s1aseIDOutput$heterogeneityQ, 
                    msg=paste('test_runMBASED1s1aseID: failed comaprison with MBASEDVectorizedMetaprop test')
                )
                checkTrue(
                    ifelse(
                        numLoci==1,
                        is.na(runMBASED1s1aseIDOutput$heterogeneityQ), 
                        !is.na(runMBASED1s1aseIDOutput$heterogeneityQ)
                    ),
                    msg=paste('test_runMBASED1s1aseID: failed comaprison with MBASEDVectorizedMetaprop test')
                )
                checkEqualsNumeric(
                    as.vector(MBASEDVectorizedMetapropOutput$hetPVal), 
                    runMBASED1s1aseIDOutput$pValueHeterogeneity, 
                    msg=paste('test_runMBASED1s1aseID: failed comaprison with MBASEDVectorizedMetaprop test')
                )
                checkTrue(
                    ifelse(
                        numLoci==1,
                        is.na(runMBASED1s1aseIDOutput$pValueHeterogeneity), 
                        !is.na(runMBASED1s1aseIDOutput$pValueHeterogeneity)
                    ),
                    msg=paste('test_runMBASED1s1aseID: failed comaprison with MBASEDVectorizedMetaprop test')
                )
                checkIdentical(
                    runMBASED1s1aseIDOutput$lociAllele1IsMajor,
                     test_x_is_major, 
                     msg=paste('test_runMBASED1s1aseID: failed comaprison with MBASEDVectorizedMetaprop test')
                )
            }
        }, BPPARAM=myBPPARAM)
    }
    rm(
        numCases, 
        numLoci, 
        testCasesMats,
        testResults
    )
    
    ## check4: breaking ties works as intended.
    set.seed(378473)
    numCases <- 10^3
    tiedVal <- 10
    for (numLoci in c(1, 5)) {
        for (test_numSim in c(0, 3)) {
            noTieBreaking <- unlist(bplapply(1:numCases, function(testInd) {
                MBASED:::runMBASED1s1aseID(
                    lociAllele1Counts=rep(tiedVal, numLoci), 
                    lociAllele2Counts=rep(tiedVal, numLoci), 
                    lociAllele1NoASEProbs=rep(0.5, numLoci), 
                    lociRhos=rep(0, numLoci), 
                    numSim=test_numSim, 
                    isPhased=sample(c(TRUE,FALSE),1), 
                    tieBreakRandom=FALSE
                )$lociAllele1IsMajor
            }, BPPARAM=myBPPARAM))
            checkTrue(
                length(unique(noTieBreaking))==1, 
                msg='test_runMBASED1s1aseID: failed tieBreak test: no simulations, no tie breaks'
            )
            yesTieBreaking <- unlist(bplapply(
                1:numCases, 
                function(testInd) {
                    MBASED:::runMBASED1s1aseID(
                        lociAllele1Counts=rep(tiedVal, numLoci), 
                        lociAllele2Counts=rep(tiedVal, numLoci), 
                        lociAllele1NoASEProbs=rep(0.5, numLoci), 
                        lociRhos=rep(0, numLoci), 
                        numSim=0, 
                        isPhased=sample(c(TRUE,FALSE),1), 
                        tieBreakRandom=TRUE
                    )$lociAllele1IsMajor
                }, BPPARAM=myBPPARAM
            ))
            MBASED:::testQuantiles(
                theoreticalCumDist=0.5, 
                observedCumDist=mean(yesTieBreaking), 
                numTotalCounts=numCases, 
                numSEsToCheck=5, 
                errorMessage='test_runMBASED1s1aseID: failed tieBreak test: no simulations, yes tie breaks'
            )
        }
    }
    rm(
        numLoci,
        numCases,
        test_numSim,
        tiedVal,
        noTieBreaking,
        yesTieBreaking
    )
    
    ## check5: with simulations, MAF estimate and assignment of alleles to haplotypes is the same as without simulations
    set.seed(784069)
    if (FULLTESTING) {
        numCases <- 1000 ## number of test cases
    } else {
        numCases  <- 3 ## number of test cases
    }
    for (numLoci in c(1, 5)) { ## number of loci
        testCasesMats <- getTestCases(
            numCases=numCases, 
            numLoci=numLoci
        )
        ## check for all possible values of tieBreakRandom
        for (test_tieBreakRandom in c(TRUE,FALSE)) { 
            for (test_isPhased in c(TRUE, FALSE)) {
                testIndSeeds <- sample(
                    1:(10^6), 
                    numCases, 
                    replace=TRUE
                )
                testResults <- bplapply(1:numCases, function(testInd) {
                    testCase <- getTestCase(
                        testCasesMats=testCasesMats, 
                        testInd=testInd
                    )
                    test_seed <- testIndSeeds[testInd]
                    testOutputs <- lapply(c(0, 10), function(test_numSim) {
                    	## make sure ties get broken in same way
                        set.seed(test_seed) 
                        MBASED:::runMBASED1s1aseID(
                            lociAllele1Counts=testCase$x, 
                            lociAllele2Counts=testCase$n-testCase$x, 
                            lociAllele1NoASEProbs=testCase$mu, 
                            lociRhos=testCase$rho, 
                            numSim=test_numSim, 
                            isPhased=test_isPhased, 
                            tieBreakRandom=test_tieBreakRandom
                        )
                    })
                    checkEqualsNumeric(
                        testOutputs[[1]]$majorAlleleFrequency, 
                        testOutputs[[2]]$majorAlleleFrequency, 
                        msg='test_runMBASED1s1aseID: failed test checking that MAF estimate is the same for sim and no sim'
                    )
                    checkEquals(
                        testOutputs[[1]]$lociAllele1IsMajor, 
                        testOutputs[[2]]$lociAllele1IsMajor, 
                        msg='test_runMBASED1s1aseID: failed test checking that assignment of alleles to haplotypes is the same for sim and no sim'
                    )
                }, BPPARAM=myBPPARAM)
            }
        }
    }
    rm(
        numCases, 
        numLoci, 
        testCasesMats,
        test_tieBreakRandom,
        test_isPhased,
        testIndSeeds,
        testResults
    )
    
    ## check6: for single-locus gene with simulations, 
    ## results should be similar to those obtained from binomial 
    ## or beta-binomial tests (as long as number of simulations 
    ## is large enough)
    ## no looping over test_isPhased, since this argument 
    ## has no effect on output for single-locus genes
    set.seed(988358)
    ## only want to load package VGAM if full testing mode is on
    if (FULLTESTING) { 
        library(VGAM)
        numCases <- 1000 ## number of test cases
        numLoci <- 1 ## number of loci
        test_numSim <- 10^6 ## number of simulations
        testCasesMats <- getTestCases(
            numCases=numCases, 
            numLoci=numLoci
        )
        ## the following logic is used: if the true p-values are very small, 
        ## we may be prevented from properly assessing them 
        ## due to granularity of empirical p-value estimates 
        ## (smallest p-value we can achieve is 1/test_numSim). 
        ## Such cases are identified in the code below and 
        ## for such instances, p-value comparison is NOT performed.
        
        ## if CI for the predicted p-value is not at least this many SDs 
        ## away from 0 or 1, we will not test that p-value
        numSDsToCheck <- 5 
        testResults <- bplapply(1:numCases, function(testInd) {
            testCase <- getTestCase(
                testCasesMats=testCasesMats, 
                testInd=testInd
            )
            ## NOTE: I am looking at likelihood of observing MAFs, 
            ## and NOT actual count outcomes. In extreme cases 
            ## (e.g., n=17, x=7, mu=0.6, rho=0.3), there may be counts 
            ## yielding higher MAF (after phasing) but also having 
            ## higher likelihood of being observed (the density of counts 
            ## is not modal). In such situations the standard two-sided tests 
            ## (that look at likelihoods of individual counts) 
            ## will give different results.
            runMBASED1s1aseIDOutputMAF <- 
            ## know that MAF is the same under simultions and no-simulations
                MBASED:::runMBASED1s1aseID(
                    lociAllele1Counts=testCase$x, 
                    lociAllele2Counts=testCase$n-testCase$x, 
                    lociAllele1NoASEProbs=testCase$mu, 
                    lociRhos=testCase$rho, 
                    numSim=0, 
                    isPhased=sample(c(TRUE,FALSE),1), 
                    tieBreakRandom=sample(c(TRUE,FALSE),1)
                )$majorAlleleFrequency 
            test_all_AFs <- MBASED:::unFT(
                z=MBASED:::FTAdjust(
                    x=0:(testCase$n), 
                    n=rep(testCase$n, testCase$n+1), 
                    p=rep(testCase$mu, testCase$n+1)
                ), 
                n=rep(testCase$n, testCase$n+1)
            )
            test_all_MAFs <- pmax(
                test_all_AFs, 
                1-test_all_AFs
            )
            predLikelihoods <- dbetabinom(
                x=0:(testCase$n), 
                size=testCase$n, 
                prob=testCase$mu, 
                rho=testCase$rho
            )
            predPval <- sum(
                predLikelihoods[
                    test_all_MAFs>=(runMBASED1s1aseIDOutputMAF-myPrecision)
                 ]
            )
            if (
                isTRUE(all.equal(predPval, 1)) || 
                isTRUE(all.equal(predPval, 0))
            ) {
                obsPval <- MBASED:::runMBASED1s1aseID(
                    lociAllele1Counts=testCase$x, 
                    lociAllele2Counts=testCase$n-testCase$x, 
                    lociAllele1NoASEProbs=testCase$mu, 
                    lociRhos=testCase$rho, 
                    numSim=test_numSim, 
                    isPhased=sample(c(TRUE,FALSE),1), 
                    tieBreakRandom=sample(c(TRUE,FALSE),1)
                )$pValueASE
                checkEqualsNumeric(
                    predPval, 
                    obsPval, 
                    tolerance=myPrecision, 
                    msg='test_runMBASED1s1aseID_singleLocus: 1-sample does not approximate (beta)-binomial p-values'
                ) 
            } else {
                predPvalSD <- sqrt(predPval*(1-predPval)/test_numSim)
                if (
                    (predPval-numSDsToCheck*predPvalSD)>0 && 
                    (predPval+numSDsToCheck*predPvalSD)<1 
                ) {
                    obsPval <- MBASED:::runMBASED1s1aseID(
                        lociAllele1Counts=testCase$x, 
                        lociAllele2Counts=testCase$n-testCase$x, 
                        lociAllele1NoASEProbs=testCase$mu, 
                        lociRhos=testCase$rho, 
                        numSim=test_numSim, 
                        isPhased=sample(c(TRUE,FALSE),1), 
                        tieBreakRandom=sample(c(TRUE,FALSE),1)
                    )$pValueASE
                    checkTrue(
                        (abs(obsPval-predPval)/predPvalSD)<5, 
                        msg='test_runMBASED1s1aseID_singleLocus: 1-sample does not approximate (beta)-binomial p-values'
                    )
                }
            }
        }, BPPARAM=myBPPARAM)
        rm(
            numCases, 
            numLoci, 
            testCasesMats,
            test_numSim,
            numSDsToCheck,
            testResults
        )
    }

    ## check 7: for multi-locus genes, under null hypothesis 
    ## and for reasonable rho, the ASE and heterogeneity p-values 
    ## are approximately uniform. No need to check for single-locus gene: 
    ## there's no heterogeneity and already saw that single-locus 
    ## p-values are close to those from (beta)binomial tests. 
    set.seed(296092)
    ## only do this in full testing mode, otherwise it takes way too long
    if (FULLTESTING) { 
    	## number of test cases
        numCases <- 5
        ## number of loci
        numLoci <- 3 
        ## number of simulations to perform by MBASED
        test_numSim <- 10^4 
        ## number of null p-values to be calculated to assess 
        ## if distribution is close to uniform or not 
        ## (~ 2 min for each set of settings)
        numTests <- 10^4  
        testCasesMats <- getTestCases(
            numCases=numCases, 
            numLoci=numLoci
        )
        quantilesToCheck <- seq(0.1, 0.9, by=0.1)
        ## will compare to see if observed quantile is within 
        ## this many standard errors of the true value. 
        ## Need to have this number relatively high, because of 
        ## a) many tests, 
        ## b) actual chunkiness in observed p-value for smallish n. 
        ## Given current numTests of 10k, the biggest SE I allow 
        ## is for the case of the median (F=0.5, predFSD=0.03), 
        ## which is not super huge
        numSEsToCheck=6 
        ## check for all possible values of test_isPhased
        for (test_isPhased in c(TRUE,FALSE)) { 
        	## check for all possible values of tieBreakRandom
            for (test_tieBreakRandom in c(TRUE,FALSE)) { 
            	## no parallelizing here, because 
            	## parallelizing is done over numTests
                for (testInd in 1:numCases) { 
                    testCase <- getTestCase(
                        testCasesMats=testCasesMats, 
                        testInd=testInd
                    )
                    test_nullResults <- bplapply(1:numTests, function(runInd) {
                        test_x_null <- MBASED:::vectorizedRbetabinomMR(
                            n=length(testCase$n), 
                            size=testCase$n, 
                            mu=testCase$mu, 
                            rho=testCase$rho
                        )
                        MBASED:::runMBASED1s1aseID(
                            lociAllele1Counts=test_x_null, 
                            lociAllele2Counts=testCase$n-test_x_null, 
                            lociAllele1NoASEProbs=testCase$mu, 
                            lociRhos=testCase$rho, 
                            numSim=test_numSim, 
                            isPhased=test_isPhased,
                            tieBreakRandom=test_tieBreakRandom
                        )
                    }, BPPARAM=myBPPARAM)
                    test_null_ASEPvals <- sapply(test_nullResults, function(el) {
                        el$pValueASE
                    })
                    test_null_hetPvals <- sapply(test_nullResults, function(el) {
                        el$pValueHeterogeneity
                    })
                    MBASED:::testQuantiles(
                        theoreticalCumDist=quantilesToCheck, 
                        observedCumDist=sapply(quantilesToCheck, function(el) {
                            mean(test_null_ASEPvals<=(el+myPrecision))
                        }), 
                        numTotalCounts=numTests, 
                        numSEsToCheck=numSEsToCheck, 
                        errorMessage='test_runMBASED1s1aseID_allCases: failed uniformity of ASE p-values test for multi-locus genes'
                    )
                    MBASED:::testQuantiles(
                        theoreticalCumDist=quantilesToCheck, 
                        observedCumDist=sapply(quantilesToCheck, function(el) {
                            mean(test_null_hetPvals<=(el+myPrecision))
                        }), 
                        numTotalCounts=numTests, 
                        numSEsToCheck=numSEsToCheck, 
                        errorMessage='test_runMBASED1s1aseID_allCases: failed uniformity of heterogeneity p-values test for multi-locus genes'
                    )

                }
            }
        }
        rm(
            numCases, 
            numLoci, 
            test_numSim,
            numTests,
            testCasesMats,
            quantilesToCheck,
            numSEsToCheck,
            test_tieBreakRandom,
            test_isPhased,
            testInd,
            testCase,
            test_nullResults
        )
    }
        
    ## Check 8: check that we can detect true signal: 
    ## p-value should be small. 
    set.seed(588586)
    ## only do for full testing, otherwise takes too long
    if (FULLTESTING) { 
    	## number of test cases
        numCases <- 100 
        ## number of loci
        for (numLoci in c(1, 5))  {
        	## number of simulations to perform by MBASED
            test_numSim <- 10^6 
            trueMAF=0.9
            testCasesMats <- getTestCases(
                numCases=numCases, 
                numLoci=numLoci
            )
            ## check for all possible values of isPhased
            for (test_isPhased in c(TRUE,FALSE)) { 
            	## check for all possible values of tieBreakRandom
                for (test_tieBreakRandom in c(TRUE,FALSE)) { 
                    testResults <- bplapply(1:numCases, function(testInd) {
                        testCase <- getTestCase(
                            testCasesMats=testCasesMats, 
                            testInd=testInd
                        )
                        ## make sure we have power to detect ASE
                        testCase$n <- 100*testCase$n 
                        ## trueAF must be a single number
                        test_generating_prob <- MBASED:::getPFinal( 
                            trueAF=trueMAF, 
                            noASEAF=testCase$mu
                        )
                        test_x <- round(test_generating_prob*testCase$n)
                        runMBASED1s1aseIDOutput <- 
                            MBASED:::runMBASED1s1aseID(
                                lociAllele1Counts=test_x, 
                                lociAllele2Counts=testCase$n-test_x, 
                                lociAllele1NoASEProbs=testCase$mu, 
                                lociRhos=testCase$rho, 
                                numSim=test_numSim, 
                                isPhased=test_isPhased,
                                tieBreakRandom=test_tieBreakRandom
                            )
                        checkTrue(
                            runMBASED1s1aseIDOutput$pValueASE <= 0.05, 
                            msg='test_runMBASED1s1aseID: 1-sample does not detect the signal'
                        )
                    }, BPPARAM=myBPPARAM)
                }
            }
        }
        rm(
            numCases, 
            numLoci, 
            test_numSim,
            trueMAF,
            testCasesMats,
            test_isPhased,
            test_tieBreakRandom,
            testResults
        )
    }
    
    ## Check 9: For multi-SNV genes only: check that we can detect 
    ## true SNV-specific ASE: heterogeneity p-value should be small 
    ## (for largish n and smallish rho, otherwise not enough evidence). 
    ## This takes about 10 mins
    set.seed(660289)
    ## only do for full testing, otherwise takes too long
    if (FULLTESTING) { 
    	## number of test cases
        numCases <- 100 
        ## number of loci
        numLoci <- 3 
        ## number of simulations to perform by MBASED
        test_numSim <- 10^6
        trueMAF=0.9
        testCasesMats <- getTestCases(
            numCases=numCases, 
            numLoci=numLoci
        )
         ## check for all possible values of isPhased
        for (test_isPhased in c(TRUE,FALSE)) {
        	## check for all possible values of tieBreakRandom
            for (test_tieBreakRandom in c(TRUE,FALSE)) { 
                testResults <- bplapply(1:numCases, function(testInd) {
                    testCase <- getTestCase(
                        testCasesMats=testCasesMats, 
                        testInd=testInd
                    )
                    whichSNVisASE <- sample(1:length(testCase$n), 1)
                    trueMAFs <- rep(0.5, length(testCase$n))
                    trueMAFs[whichSNVisASE] <- trueMAF
                    ## make sure we have power to detect ASE
                    testCase$n <- 100*testCase$n 
                    test_generating_prob <- sapply(
                        1:length(trueMAFs), 
                        function(MAFInd) {
                        	## trueAF must be a single number
                            MBASED:::getPFinal(
                                trueAF=trueMAFs[MAFInd], 
                                noASEAF=testCase$mu[MAFInd]
                            )
                        }
                    )
                    test_x <- round(test_generating_prob*testCase$n)
                    runMBASED1s1aseIDOutput <- 
                        MBASED:::runMBASED1s1aseID(
                            lociAllele1Counts=test_x, 
                            lociAllele2Counts=testCase$n-test_x, 
                            lociAllele1NoASEProbs=testCase$mu, 
                            lociRhos=testCase$rho, 
                            numSim=test_numSim, 
                            isPhased=test_isPhased,
                            tieBreakRandom=test_tieBreakRandom
                        )
                    checkTrue(
                        runMBASED1s1aseIDOutput$pValueHeterogeneity <= 0.2, 
                        msg='test_runMBASED1s1aseID: 1-sample does not detect the heterogeneity signal '
                    )
                }, BPPARAM=myBPPARAM)
            }
        }
        rm(
            numCases, 
            numLoci, 
            test_numSim,
            trueMAF,
            testCasesMats,
            test_isPhased,
            test_tieBreakRandom,
            testResults
        )
    }
    
    return(TRUE)
}

## test behavior of runMBASED1s() function 
test_runMBASED1s <- function() {
    ## check1: runMBASED1s gives same results as 
    ## performing analysis on each aseID individually.
    ## Complication due to random sampling I employ: 
    ## bplapply messes with random seed, so I need to write 
    ## slightly modified version of functions to directly specificy seeds.
    set.seed(817815)
    runMBASED1s1aseIDTest <- function(
        lociAllele1Counts, 
        lociAllele2Counts,
        lociAllele1NoASEProbs, 
        lociRhos, 
        numSim=0, 
        isPhased=FALSE, 
        tieBreakRandom=FALSE, 
        testSeed
    ) {
        set.seed(testSeed)
        res <- MBASED:::runMBASED1s1aseID(
            lociAllele1Counts=lociAllele1Counts, 
            lociAllele2Counts=lociAllele2Counts, 
            lociAllele1NoASEProbs=lociAllele1NoASEProbs, 
            lociRhos=lociRhos, 
            numSim=numSim, 
            isPhased=isPhased, 
            tieBreakRandom=tieBreakRandom
        )
        return(res)
    }
    runMBASED1sTest <- function(
        lociAllele1Counts, 
        lociAllele2Counts, 
        lociAllele1NoASEProbs, 
        lociRhos, 
        aseIDs, 
        numSim=0, 
        BPPARAM=SerialParam(), 
        isPhased=FALSE, 
        tieBreakRandom=FALSE, 
        testSeeds ## one seed for each aseID
    ) {
        ASEResults <- bplapply(unique(aseIDs), function(aseID) {
            aseIDsubv <- (aseIDs==aseID)
            aseIDInd <- which(unique(aseIDs)==aseID)
            res <- runMBASED1s1aseIDTest(
                lociAllele1Counts=lociAllele1Counts[aseIDsubv],
                lociAllele2Counts=lociAllele2Counts[aseIDsubv],
                lociAllele1NoASEProbs=lociAllele1NoASEProbs[aseIDsubv],
                lociRhos=lociRhos[aseIDsubv],
                numSim=numSim,
                isPhased=isPhased,
                tieBreakRandom=tieBreakRandom,
                testSeed=testSeeds[aseIDInd]
            ) 
            return(res)
        }, BPPARAM=BPPARAM)
        names(ASEResults) <- unique(aseIDs)
        allele1IsMajor <- as.vector(
            unlist(
                lapply(
                    ASEResults, 
                    function(el) el$lociAllele1IsMajor
                )
            )
        )
        lociMAF <- as.vector(
            unlist(
                lapply(
                    ASEResults, 
                    function(el) el$lociMAF
                )
            )
        )
        ASEResults <- lapply(ASEResults, function(el) {
            el$lociAllele1IsMajor <- NULL
            el$lociMAF <- NULL
            return(el)
        })
        ASEResults <- as.data.frame(
            do.call(
                rbind,
                lapply(ASEResults, function(el) unlist(el))
            )
        )
        return(
            list(
                ASEResults=ASEResults, 
                allele1IsMajor=allele1IsMajor,
                lociMAF=lociMAF
            )
        )
    }
    ## actual testing
    if (FULLTESTING) {
    	## number of test cases
        numCases <- 100 
    } else {
    	## number of test cases
        numCases <- 3 
    }
    ## 3 aseIDs, with 1, 3, and 4 loci each
    numLoci_for_aseIDs <- c(1, 3, 4) 
    ## number of total loci
    totalNumLoci <- sum(numLoci_for_aseIDs) 
    testCasesMats <- getTestCases(
        numCases=numCases, 
        numLoci=totalNumLoci
    )
    ## check for all possible values of tieBreakRandom
    for (test_tieBreakRandom in c(TRUE,FALSE)) { 
    	## check for all possible values of test_isPhased
        for (test_isPhased in c(TRUE, FALSE)) { 
        	## try sims and no-sims
            for (test_numSim in c(0, 3)) { 
                testResults <- bplapply(1:numCases, function(testInd) {
                    testCase <- getTestCase(
                        testCasesMats=testCasesMats, 
                        testInd=testInd
                    )
                    test_aseIDs <- rep(
                        paste(
                            'gene',
                            1:length(numLoci_for_aseIDs), 
                            sep=''
                        ), 
                        numLoci_for_aseIDs
                    )
                    test_seeds <- sample(
                        1:(10^6), 
                        length(unique(test_aseIDs))
                    )
                    ## get joint results:
                    jointResults <- runMBASED1sTest(
                        lociAllele1Counts=testCase$x, 
                        lociAllele2Counts=testCase$n-testCase$x, 
                        lociAllele1NoASEProbs=testCase$mu, 
                        lociRhos=testCase$rho, 
                        aseIDs=test_aseIDs,
                        numSim=test_numSim, 
                        BPPARAM=SerialParam(),
                        isPhased=test_isPhased,
                        tieBreakRandom=test_tieBreakRandom,
                        testSeeds=test_seeds
                    )
                    ## get individual results:
                    runMBASED1s1aseIDOutputs <- lapply(
                        unique(test_aseIDs), 
                        function(test_aseID) {
                            test_aseID_subv <- (test_aseIDs==test_aseID)
                            test_aseID_ind <- which(
                                unique(test_aseIDs)==test_aseID
                            )
                            runMBASED1s1aseIDOutput <- 
                                runMBASED1s1aseIDTest(
                                    lociAllele1Counts=testCase$x[
                                        test_aseID_subv
                                    ], 
                                    lociAllele2Counts=(testCase$n-testCase$x)[
                                        test_aseID_subv
                                    ], 
                                    lociAllele1NoASEProbs=testCase$mu[
                                        test_aseID_subv
                                    ], 
                                    lociRhos=testCase$rho[
                                        test_aseID_subv
                                    ], 
                                    numSim=test_numSim, 
                                    isPhased=test_isPhased,
                                    tieBreakRandom=test_tieBreakRandom,
                                    testSeed=test_seeds[
                                       test_aseID_ind
                                    ]
                                )
                            return(runMBASED1s1aseIDOutput)
                        }
                    )
                    individualResults <- list(
                        ASEResults=data.frame(
                            majorAlleleFrequency=sapply(
                                runMBASED1s1aseIDOutputs, 
                                function(el) {
                                    el$majorAlleleFrequency
                                }
                            ),
                            pValueASE=sapply(
                                runMBASED1s1aseIDOutputs, 
                                function(el) {
                                    el$pValueASE
                                }
                            ),
                            heterogeneityQ=sapply(
                                runMBASED1s1aseIDOutputs, 
                                function(el) {
                                    el$heterogeneityQ
                                }
                            ),
                            pValueHeterogeneity=sapply(
                                runMBASED1s1aseIDOutputs, 
                                function(el) {
                                    el$pValueHeterogeneity
                                }
                            ),
                            row.names=unique(test_aseIDs)
                        ),
                        allele1IsMajor=unlist(
                            lapply(
                                runMBASED1s1aseIDOutputs, 
                                function(el) {
                                    el$lociAllele1IsMajor
                                }
                            )
                        ),
                        lociMAF=unlist(
                            lapply(
                                runMBASED1s1aseIDOutputs, 
                                function(el) {
                                    el$lociMAF
                                }
                            )
                        )
                    )
                    checkEquals(
                        jointResults, 
                        individualResults, 
                        msg='test_runMBASED1s: failed test checking that runMBASED1s does the same job as individual calls to runMBASED1s1aseID'
                    )
                }, BPPARAM=myBPPARAM)
            }
        }
    }
    
    return(TRUE)
}    
    

    
    

## size of round-off error I'm tolerating 
## (quantities with differences of this much or smaller 
## are considered the same)
myPrecision <- .Machine$double.eps^0.5 
FULLTESTING <- FALSE
if (FULLTESTING) {
    myBPPARAM <- MulticoreParam(workers=24)
} else {
    myBPPARAM <- SerialParam()
}

test_MBASEDVectorizedPropDiffTest <- function() { 
    ## check1: vectorization works for both a single locus gene 
    ## and multi-loci genes
    set.seed(176907)
    numCases <- 100
    for (numLoci in c(1, 4)) {
        test_ns_mats <- lapply(1:2, function(sampleInd) {
            matrix(
                sample(10:20, numCases*numLoci, replace=T), 
                nrow=numLoci, 
                ncol=numCases
            )
        })
        test_xs_mats <- lapply(1:2, function(sampleInd) {
            matrix(
                sample(0:10, numCases*numLoci, replace=T), 
                nrow=numLoci, 
                ncol=numCases
            )
        })
        test_mus_mats <- lapply(1:2, function(sampleInd) {
            matrix(
                sample(seq(0.1, 0.9, by=0.1), numCases*numLoci, replace=T), 
                nrow=numLoci, 
                ncol=numCases
            )
        })
        test_rhos_mats <- lapply(1:2, function(sampleInd) {
            matrix(
                sample(c(0,0.01, 0.3, 0.9), numCases*numLoci, replace=T), 
                nrow=numLoci, 
                ncol=numCases
            )
        })
        for (test_AH in c('greater', 'less', 'two.sided')) {
            individualResults <- bplapply(1:numCases, function(colInd) { 
                MBASED:::MBASEDVectorizedPropDiffTest(
                    countsMatSample1=matrix(
                        test_xs_mats[[1]][,colInd], 
                        nrow=numLoci, 
                        ncol=1
                    ), 
                    countsMatSample2=matrix(
                        test_xs_mats[[2]][,colInd], 
                        nrow=numLoci, 
                        ncol=1
                    ),
                    totalsMatSample1=matrix(
                        test_ns_mats[[1]][,colInd], 
                        nrow=numLoci, 
                        ncol=1
                    ), 
                    totalsMatSample2=matrix(
                        test_ns_mats[[2]][,colInd], 
                        nrow=numLoci, 
                        ncol=1
                    ), 
                    probsMatSample1=matrix(
                        test_mus_mats[[1]][,colInd], 
                        nrow=numLoci, 
                        ncol=1
                    ), 
                    probsMatSample2=matrix(
                        test_mus_mats[[2]][,colInd], 
                        nrow=numLoci, 
                        ncol=1
                    ), 
                    rhosMatSample1=matrix(
                        test_rhos_mats[[1]][,colInd], 
                        nrow=numLoci, 
                        ncol=1
                    ), 
                    rhosMatSample2=matrix(
                        test_rhos_mats[[2]][,colInd], 
                        nrow=numLoci, 
                        ncol=1
                    ), 
                    alternative=test_AH
                )
            }, BPPARAM=myBPPARAM)
            jointResults <- MBASED:::MBASEDVectorizedPropDiffTest(
                countsMatSample1=test_xs_mats[[1]], 
                countsMatSample2=test_xs_mats[[2]], 
                totalsMatSample1=test_ns_mats[[1]], 
                totalsMatSample2=test_ns_mats[[2]], 
                probsMatSample1=test_mus_mats[[1]], 
                probsMatSample2=test_mus_mats[[2]], 
                rhosMatSample1=test_rhos_mats[[1]], 
                rhosMatSample2=test_rhos_mats[[2]],
                alternative=test_AH
            )
            for (outputName in names(jointResults)) {
                checkEqualsNumeric(
                    jointResults[[outputName]], 
                    do.call(
                        cbind,
                        lapply(
                            individualResults, 
                            function(el) {
                                el[[outputName]]
                            }
                        )
                    ), 
                    msg='test_MBASEDVectorizedPropDiffTest: fail vectorization test'
                )
            }
        }
    }
            
    ## check2: for large n, reasonable p and rho=0 (binomial setting), 
    ## single-locus approach should produce pvalues similar to 
    ## proportion difference test (apart from possibly very small p-values). 
    ## Further, the estimate should be (possibly adjusted) proportion 
    ## difference (we previously checked that the adjustment of 
    ## proportions is meaningful). Here I need to keep test_mu the same 
    ## for two samples since prop.test assumes the underlying 
    ## probabilities of success are the same for both samples.
    set.seed(27567)
    testCasesMat <- expand.grid(
        test_mu=seq(0.2, 0.8, by=0.1),
        test_rho=0,
        test_AH=c('greater', 'less', 'two.sided')
    )
    if (FULLTESTING) {
        numCountsToGenerate <- 10^6
    } else {
        numCountsToGenerate <- 10^3  
    }
    testResults <- bplapply(1:nrow(testCasesMat), function(testInd) {
        testCase <- testCasesMat[testInd,]
        testNs <- lapply(1:2, function(sampleInd) {
            sample((10^4):(10^5), 1, replace=TRUE)
        })
        testCounts <- lapply(1:2, function(sampleInd) {
            MBASED:::vectorizedRbetabinomMR(
                n=numCountsToGenerate,
                size=rep(testNs[[sampleInd]], numCountsToGenerate),
                mu=rep(testCase$test_mu, numCountsToGenerate),
                rho=rep(testCase$test_rho, numCountsToGenerate)
            )
        })
        predEstimatesList <- lapply(1:2, function(sampleInd) {
            MBASED:::shiftAndAttenuateProportions(
                countsMat=matrix(
                    testCounts[[sampleInd]], 
                    nrow=1
                ), 
                totalsMat=matrix(
                    rep(testNs[[sampleInd]], numCountsToGenerate),
                    nrow=1
                ),
                probsMat=matrix(
                    rep(testCase$test_mu, numCountsToGenerate),
                    nrow=1
                ),
                rhosMat=matrix(
                    rep(testCase$test_rho, numCountsToGenerate),
                    nrow=1
                )
            )
        })
        predEstimates <- as.vector(
            predEstimatesList[[1]]$propsShifted- 
            predEstimatesList[[2]]$propsShifted
        )
        predPvals <- sapply(1:numCountsToGenerate, function(countInd) {
            prop.test(
                x=c(
                    testCounts[[1]][countInd], 
                    testCounts[[2]][countInd]
                ),
                n=c(
                    testNs[[1]], 
                    testNs[[2]]
                ),
                alternative=as.character(testCase$test_AH)
            )$p.value
        })
        MBASEDVectorizedPropDiffTestOutput <- 
            MBASED:::MBASEDVectorizedPropDiffTest(
                countsMatSample1=matrix(
                    testCounts[[1]], 
                    nrow=1, 
                    ncol=numCountsToGenerate
                ), 
                countsMatSample2=matrix(
                    testCounts[[2]], 
                    nrow=1, 
                    ncol=numCountsToGenerate
                ), 
                totalsMatSample1=matrix(
                    rep(testNs[[1]], numCountsToGenerate), 
                    nrow=1, 
                    ncol=numCountsToGenerate
                ), 
                totalsMatSample2=matrix(
                    rep(testNs[[2]], numCountsToGenerate), 
                    nrow=1, 
                    ncol=numCountsToGenerate
                ), 
                probsMatSample1=matrix(
                    rep(testCase$test_mu, numCountsToGenerate), 
                    nrow=1, 
                    ncol=numCountsToGenerate
                ), 
                probsMatSample2=matrix(
                    rep(testCase$test_mu, numCountsToGenerate), 
                    nrow=1, 
                    ncol=numCountsToGenerate
                ), 
                rhosMatSample1=matrix(
                    rep(testCase$test_rho, numCountsToGenerate), 
                    nrow=1, 
                    ncol=numCountsToGenerate
                ), 
                rhosMatSample2=matrix(
                    rep(testCase$test_rho, numCountsToGenerate), 
                    nrow=1, 
                    ncol=numCountsToGenerate
                ), 
                alternative=as.character(testCase$test_AH)
            )
        obsEstimates <- as.vector(
            MBASEDVectorizedPropDiffTestOutput$propDifferenceFinal
        )
        checkEqualsNumeric(
            obsEstimates, 
            predEstimates, 
            msg='test_MBASEDVectorizedPropDiffTestOutput: fail comparison to prop.test'
        )
        obsPvals <- as.vector(
            MBASEDVectorizedPropDiffTestOutput$pValue
        )
        checkTrue(
            all(
                (pmax(obsPvals, predPvals)<=0.005) |
                    MBASED:::testNumericDiff(
                    queryVals=obsPvals, 
                    targetVals=predPvals, 
                    cutoffFraction=0.2 ## within 20%
                )
            ),
            msg='test_MBASEDVectorizedPropDiffTestOutput: fail comparison to binom/betabinom test'
        ) 
    }, BPPARAM=myBPPARAM)
    
    
    return(TRUE)
}    
    
    

## GENERAL FRAMEWORK FOR TEST CASES FOR
##  test_runMBASED2s1aseID() and test_runMBASED2s(): 
## Try out n=10,11,12,..,20, 50, 51, 100, 101, 1000, 1001. 
## For each n, test (when possible) x={0,1,2}(small), 
## {n, n-1, n-2}(large), {floor(n/2-1), floor(n/2), floor(n/2+1)} (mean), 
## and 10 random values.
## For each combination of n and x, try mu={0.4, 0.45, 0.5, 0.55, 0.6}
## For each combination of n, x, mu, try rho={0, 0.01, 0.1}
set.seed(554475)
my_ns <- c(10:20, 50, 51, 100, 101, 1000, 1001)
my_xn_combos <- unlist(lapply(my_ns, function(n) {
    candidate_xs <- c(
        0:2, 
        n-(0:2), 
        floor(n/2-1), 
        floor(n/2), 
        floor(n/2+1), 
        sample(0:n, 10, replace=TRUE)
    )
    candidate_xs <- candidate_xs[
        candidate_xs>=0 & candidate_xs<=n
    ]
    candidate_xs <- unique(
        sort(
            candidate_xs, 
            decreasing=FALSE
        )
    )
    return(paste(n, candidate_xs, sep='_'))
}))
AllTestCasesMat <- expand.grid(
    test_xn_combo=my_xn_combos,
    test_mu=seq(0.4, 0.6, by=0.05),
    test_rho=c(0, 0.01, 0.1)
)
AllTestCasesMat$test_n <- as.numeric(
    matrix(
        unlist(
            strsplit(
                as.character(
                    AllTestCasesMat$test_xn_combo
                ), 
                '_'
            )
        ), 
        ncol=2, 
        byrow=TRUE
    )[,1]
)
AllTestCasesMat$test_x <- as.numeric(
    matrix(
        unlist(
            strsplit(
                as.character(
                    AllTestCasesMat$test_xn_combo
                ), 
                '_'
            )
        ), 
        ncol=2, 
        byrow=TRUE
    )[,2]
)
rm(
    my_ns,
    my_xn_combos
)

## helper function to get test cases from the matrix of all test cases
## returns a matrix with test cases of interest 
## spread over a desired matrix
getTestCases <- function(numCases, numLoci) {
    testCasesInds <- sample(
        1:nrow(AllTestCasesMat), 
        numCases*numLoci, 
        replace=TRUE
    )
    test_ns_mat <- matrix(
        AllTestCasesMat$test_n[testCasesInds], 
        nrow=numLoci, 
        ncol=numCases
    )
    test_xs_mat <- matrix(
        AllTestCasesMat$test_x[testCasesInds], 
        nrow=numLoci, 
        ncol=numCases
    )
    test_mus_mat <- matrix(
        AllTestCasesMat$test_mu[testCasesInds], 
        nrow=numLoci, 
        ncol=numCases
    )
    test_rhos_mat <- matrix(
        AllTestCasesMat$test_rho[testCasesInds], 
        nrow=numLoci, 
        ncol=numCases
    )
    return(
        list(
            n=test_ns_mat,
            x=test_xs_mat,
            mu=test_mus_mat,
            rho=test_rhos_mat
        )
    )
}

## helper function to get individual test case (column) from 
## output of getTestCases()
getTestCase <- function(testCasesMats, testInd) {
    return(
        list(
            n=testCasesMats$n[,testInd],
            x=testCasesMats$x[,testInd],
            mu=testCasesMats$mu[,testInd],
            rho=testCasesMats$rho[,testInd]
        )
    )
}



## test behavior of runMBASED2s1aseID() function 
test_runMBASED2s1aseID <- function() {
    ## check 1:  with no simulations return the same result as 
    ## MBASEDVectorizedPropDiffTest with alternative hypothesis 
    ## set to 'two.sided' and with additional step of 
    ## picking the larger of allelic frequencies in sample1 to be 'major'
    ## use tieBreakRandom=FALSE for simplicity. 
    ## Later will check that tie-breaking works as intended.
    if (FULLTESTING) {
    	## number of test cases
        numCases <- 1000 
    } else {
    	## number of test cases
        numCases <- 3 
    }
    ## number of loci
    for (numLoci in c(1,5)) { 
        testCasesMatsSample1 <- getTestCases(
            numCases=numCases, 
            numLoci=numLoci
        )
        testCasesMatsSample2 <- getTestCases(
            numCases=numCases, 
            numLoci=numLoci
        )
        testResults <- bplapply(1:numCases, function(testInd) {
            testCaseSample1 <- getTestCase(
                testCasesMats=testCasesMatsSample1, 
                testInd=testInd
            )
            testCaseSample2 <- getTestCase(
                testCasesMats=testCasesMatsSample2, 
                testInd=testInd
            )
            for (test_isPhased in c(TRUE, FALSE)) {
            	## data will be phased by MBASED based on sample1 only
                test_x_is_major <- MBASED:::runMBASED1s1aseID(
                    lociAllele1Counts=testCaseSample1$x, 
                    lociAllele2Counts=testCaseSample1$n-
                        testCaseSample1$x, 
                    lociAllele1NoASEProbs=testCaseSample1$mu, 
                    lociRhos=testCaseSample1$rho, 
                     ## no need to do simulations: 
                     ## we only require information about which allele is major
                    numSim=0,
                    isPhased=test_isPhased,
                    tieBreakRandom=FALSE
                )$lociAllele1IsMajor
                test_maj_sample1 <- ifelse(
                    test_x_is_major, 
                    testCaseSample1$x, 
                    testCaseSample1$n-testCaseSample1$x
                )
                test_maj_sample2 <- ifelse(
                    test_x_is_major, 
                    testCaseSample2$x, 
                    testCaseSample2$n-testCaseSample2$x
                )
                test_prob_maj_sample1 <- ifelse(
                    test_x_is_major, 
                    testCaseSample1$mu, 
                    1-testCaseSample1$mu
                )
                test_prob_maj_sample2 <- ifelse(
                    test_x_is_major, 
                    testCaseSample2$mu, 
                    1-testCaseSample2$mu
                )
                MBASEDVectorizedPropDiffTestOutput <- 
                    MBASED:::MBASEDVectorizedPropDiffTest(
                        countsMatSample1=matrix(
                            test_maj_sample1, 
                            nrow=numLoci, 
                            ncol=1
                        ), 
                        countsMatSample2=matrix(
                            test_maj_sample2, 
                            nrow=numLoci, 
                            ncol=1
                        ), 
                        totalsMatSample1=matrix(
                            testCaseSample1$n, 
                            nrow=numLoci, 
                            ncol=1
                        ), 
                        totalsMatSample2=matrix(
                            testCaseSample2$n, 
                            nrow=numLoci, 
                            ncol=1
                        ),
                        probsMatSample1=matrix(
                            test_prob_maj_sample1,
                            nrow=numLoci, 
                            ncol=1
                        ), 
                        probsMatSample2=matrix(
                            test_prob_maj_sample2,
                            nrow=numLoci, 
                            ncol=1
                        ), 
                        rhosMatSample1=matrix(
                            testCaseSample1$rho, 
                            nrow=numLoci, 
                            ncol=1
                        ), 
                        rhosMatSample2=matrix(
                            testCaseSample2$rho, 
                            nrow=numLoci, 
                            ncol=1
                        ), 
                        alternative='two.sided'
                    )    
                runMBASED2s1aseIDOutput <- 
                    MBASED:::runMBASED2s1aseID(
                        lociAllele1CountsSample1=testCaseSample1$x, 
                        lociAllele2CountsSample1=testCaseSample1$n-
                            testCaseSample1$x, 
                        lociAllele1CountsSample2=testCaseSample2$x, 
                        lociAllele2CountsSample2=testCaseSample2$n-
                            testCaseSample2$x, 
                        lociAllele1NoASEProbsSample1=testCaseSample1$mu, 
                        lociAllele1NoASEProbsSample2=testCaseSample2$mu, 
                        lociRhosSample1=testCaseSample1$rho, 
                        lociRhosSample2=testCaseSample2$rho,
                        numSim=0, 
                        isPhased=test_isPhased,
                        tieBreakRandom=FALSE
                    )
                checkEqualsNumeric(
                    as.vector(
                        MBASEDVectorizedPropDiffTestOutput$propDifferenceFinal
                    ), 
                    runMBASED2s1aseIDOutput$majorAlleleFrequencyDifference, 
                    msg=paste('test_runMBASED2s1aseID: failed comaprison with MBASEDVectorizedPropDiffTest test')
                )
                checkEqualsNumeric(
                    as.vector(
                        MBASEDVectorizedPropDiffTestOutput$pValue
                    ), 
                    runMBASED2s1aseIDOutput$pValueASE, 
                    msg=paste('test_runMBASED2s1aseID: failed comaprison with MBASEDVectorizedPropDiffTest test')
                )
                checkEqualsNumeric(
                    as.vector(
                        MBASEDVectorizedPropDiffTestOutput$hetQ
                    ), 
                    runMBASED2s1aseIDOutput$heterogeneityQ, 
                    msg=paste('test_runMBASED2s1aseID: failed comaprison with MBASEDVectorizedPropDiffTest test')
                )
                checkTrue(
                    ifelse(
                        numLoci==1,
                        is.na(runMBASED2s1aseIDOutput$heterogeneityQ), 
                        !is.na(runMBASED2s1aseIDOutput$heterogeneityQ)
                    ),
                    msg=paste('test_runMBASED2s1aseID: failed comaprison with MBASEDVectorizedPropDiffTest  test')
                )
                checkEqualsNumeric(
                    as.vector(
                        MBASEDVectorizedPropDiffTestOutput$hetPVal
                    ), 
                    runMBASED2s1aseIDOutput$pValueHeterogeneity, 
                    msg=paste('test_runMBASED2s1aseID: failed comaprison with MBASEDVectorizedPropDiffTest test')
                )
                checkTrue(
                    ifelse(
                        numLoci==1,
                        is.na(runMBASED2s1aseIDOutput$pValueHeterogeneity), 
                        !is.na(runMBASED2s1aseIDOutput$pValueHeterogeneity)
                    ),
                    msg=paste('test_runMBASED2s1aseID: failed comaprison with MBASEDVectorizedPropDiffTest test')
                )
                checkIdentical(
                    runMBASED2s1aseIDOutput$lociAllele1IsMajor,
                    test_x_is_major, 
                     msg=paste('test_runMBASED2s1aseID: failed comaprison with MBASEDVectorizedPropDiffTest test')
                )
            }
        }, BPPARAM=myBPPARAM)
    }
    rm(
        numCases, 
        numLoci, 
        testCasesMatsSample1,
        testCasesMatsSample2,
        testResults
    )
    
    ## check2: breaking ties works as intended .
    if (FULLTESTING) {
    	 ## number of test cases
        numCases <- 1000
    } else {
    	## number of test cases
        numCases <- 100 
    }
    tiedVal <- 10
    for (numLoci in c(1, 5)) {
        for (test_numSim in c(0, 3)) {
            noTieBreaking <- unlist(bplapply(1:numCases, function(testInd) {
                MBASED:::runMBASED2s1aseID(
                    lociAllele1CountsSample1=rep(tiedVal, numLoci), 
                    lociAllele2CountsSample1=rep(tiedVal, numLoci), 
                    lociAllele1CountsSample2=rep(tiedVal, numLoci), 
                    lociAllele2CountsSample2=rep(tiedVal, numLoci),
                    lociAllele1NoASEProbsSample1=rep(0.5, numLoci), 
                    lociAllele1NoASEProbsSample2=rep(0.5, numLoci),
                    lociRhosSample1=rep(0, numLoci), 
                    lociRhosSample2=rep(0, numLoci), 
                    numSim=test_numSim, 
                    isPhased=sample(c(TRUE,FALSE),1), 
                    tieBreakRandom=FALSE
                )$lociAllele1IsMajor
            }, BPPARAM=myBPPARAM))
            checkTrue(
                length(unique(noTieBreaking))==1, 
                msg='test_runMBASED2s1aseID: failed tieBreak test: no simulations, no tie breaks'
            )
            yesTieBreakingNoNeed <- unlist(bplapply(
                1:numCases, 
                function(testInd) {
                    MBASED:::runMBASED2s1aseID(
                        lociAllele1CountsSample1=rep(tiedVal, numLoci), 
                        lociAllele2CountsSample1=rep(2*tiedVal, numLoci), 
                        lociAllele1CountsSample2=rep(tiedVal, numLoci), 
                        lociAllele2CountsSample2=rep(tiedVal, numLoci),
                        lociAllele1NoASEProbsSample1=rep(0.5, numLoci), 
                        lociAllele1NoASEProbsSample2=rep(0.5, numLoci),
                        lociRhosSample1=rep(0, numLoci), 
                        lociRhosSample2=rep(0, numLoci), 
                        numSim=test_numSim, 
                        isPhased=sample(c(TRUE,FALSE),1), 
                        tieBreakRandom=TRUE
                    )$lociAllele1IsMajor
                }, BPPARAM=myBPPARAM
            ))
            checkTrue(
                length(unique(yesTieBreakingNoNeed))==1, 
                msg='test_runMBASED2s1aseID: failed tieBreak test: no simulations, no tie breaks'
            )
            yesTieBreaking <- unlist(bplapply(1:numCases, function(testInd) {
                MBASED:::runMBASED2s1aseID(
                    lociAllele1CountsSample1=rep(tiedVal, numLoci), 
                    lociAllele2CountsSample1=rep(tiedVal, numLoci), 
                    lociAllele1CountsSample2=rep(tiedVal, numLoci), 
                    lociAllele2CountsSample2=rep(tiedVal, numLoci),
                    lociAllele1NoASEProbsSample1=rep(0.5, numLoci), 
                    lociAllele1NoASEProbsSample2=rep(0.5, numLoci),
                    lociRhosSample1=rep(0, numLoci), 
                    lociRhosSample2=rep(0, numLoci), 
                    numSim=test_numSim, 
                    isPhased=sample(c(TRUE,FALSE),1), 
                    tieBreakRandom=TRUE
                )$lociAllele1IsMajor
            }, BPPARAM=myBPPARAM))
            MBASED:::testQuantiles(
                theoreticalCumDist=0.5, 
                observedCumDist=mean(yesTieBreaking), 
                numTotalCounts=numCases, 
                numSEsToCheck=5, 
                errorMessage='test_runMBASED2s1aseID: failed tieBreak test: no simulations, yes tie breaks'
            )
        }
    }
    rm(
        numLoci,
        numCases,
        test_numSim,
        tiedVal,
        noTieBreaking,
        yesTieBreakingNoNeed,
        yesTieBreaking
    )
    
    ## check3: with simulations, MAF difference estimate and 
    ## assignment of alleles to haplotypes is the same 
    ## as without simulations
    if (FULLTESTING) {
    	## number of test cases
        numCases <- 1000 
    } else {
    	## number of test cases
        numCases  <- 3 
    }
     ## number of loci
    for (numLoci in c(1, 5)) {
        testCasesMatsSample1 <- getTestCases(
            numCases=numCases, 
            numLoci=numLoci
        )
        testCasesMatsSample2 <- getTestCases(
            numCases=numCases, 
            numLoci=numLoci
        )
        ## check for all possible values of tieBreakRandom
        for (test_tieBreakRandom in c(TRUE,FALSE)) { 
            for (test_isPhased in c(TRUE, FALSE)) {
                testIndSeeds <- sample(
                    1:(10^6), 
                    numCases, 
                    replace=TRUE
                )
                testResults <- bplapply(1:numCases, function(testInd) {
                    testCaseSample1 <- getTestCase(
                        testCasesMats=testCasesMatsSample1, 
                        testInd=testInd
                    )
                    testCaseSample2 <- getTestCase(
                        testCasesMats=testCasesMatsSample2, 
                        testInd=testInd
                    )
                    test_seed <- testIndSeeds[testInd]
                    testOutputs <- lapply(c(0, 10), function(test_numSim) {
                    	## make sure ties get broken in same way
                        set.seed(test_seed) 
                        MBASED:::runMBASED2s1aseID(
                            lociAllele1CountsSample1=testCaseSample1$x, 
                            lociAllele2CountsSample1=testCaseSample1$n-
                                testCaseSample1$x, 
                            lociAllele1CountsSample2=testCaseSample2$x, 
                            lociAllele2CountsSample2=testCaseSample2$n-
                                testCaseSample2$x, 
                            lociAllele1NoASEProbsSample1=testCaseSample1$mu, 
                            lociAllele1NoASEProbsSample2=testCaseSample2$mu, 
                            lociRhosSample1=testCaseSample1$rho, 
                            lociRhosSample2=testCaseSample2$rho,
                            numSim=test_numSim, 
                            isPhased=test_isPhased, 
                            tieBreakRandom=test_tieBreakRandom
                        )
                    })
                    checkEqualsNumeric(
                        testOutputs[[1]]$majorAlleleFrequencyDifference, 
                        testOutputs[[2]]$majorAlleleFrequencyDifference, 
                        msg='test_runMBASED2s1aseID: failed test checking that MAF difference estimate is the same for sim and no sim'
                    )
                    checkEquals(
                        testOutputs[[1]]$lociAllele1IsMajor, 
                        testOutputs[[2]]$lociAllele1IsMajor, 
                        msg='test_runMBASED2s1aseID: failed test checking that assignment of alleles to haplotypes is the same for sim and no sim'
                    )
                }, BPPARAM=myBPPARAM)
            }
        }
    }
    rm(
        numCases, 
        numLoci, 
        testCasesMatsSample1,
        testCasesMatsSample2,
        test_tieBreakRandom,
        test_isPhased,
        testIndSeeds,
        testResults
    )
    
    ## check 4: under null hypothesis and for reasonable rho, 
    ## the ASE and heterogeneity p-values are approximately uniform. 
    ## The actual distribution will NOT be uniform because 
    ## of the step where MAF gets estimated, resulting in p-values 
    ## being generated based on incorrect (but, hopefully, 
    ## good approximation to ) null distribution. 
    
     ## currently this test is not run: there are cases where test fails 
     ## due to estimate of joint MAF being sufficiently distinct from 
     ## true MAF (here: 0.5), where 'sufficiently' means different things 
     ## for different coverage levels.
    if (FALSE) {
        set.seed(29921)
        ## number of test cases
        numCases <- 5 
        ## number of simulations to perform by MBASED
        test_numSim <- 10^4 
        ## number of null p-values to be calculated to assess if 
        ## distribution is close to uniform or not 
        ## (~ 20 min for each set of settings) 
        numTests <- 10^4 
        ## number of loci
        for (numLoci in c(1,3)) { 
            testCasesMatsSample1 <- getTestCases(
                numCases=numCases, 
                numLoci=numLoci
            )
            testCasesMatsSample2 <- getTestCases(
                numCases=numCases, 
                numLoci=numLoci
            )
            quantilesToCheck <- seq(0.05, 0.95, by=0.05)
            ## check for all possible values of test_isPhased
            for (test_isPhased in c(TRUE,FALSE)) { 
            	## check for all possible values of tieBreakRandom
                for (test_tieBreakRandom in c(TRUE,FALSE)) { 
                	## no parallelizing here, because 
                	## parallelizing is done over numTests
                    for (testInd in 1:numCases) { 
                        testCaseSample1 <- getTestCase(
                            testCasesMats=testCasesMatsSample1, 
                            testInd=testInd
                        )
                        testCaseSample2 <- getTestCase(
                            testCasesMats=testCasesMatsSample2, 
                            testInd=testInd
                        )
                        ## make sure counts are high enough
                        testCaseSample1$n <- sample(200:1000, 1)
                        testCaseSample2$n <- sample(200:1000, 1)
                        test_nullResults <- bplapply(1:numTests, function(runInd) {
                            test_x_null_sample1 <- 
                                MBASED:::vectorizedRbetabinomMR(
                                    n=length(testCaseSample1$n), 
                                    size=testCaseSample1$n, 
                                    mu=testCaseSample1$mu, 
                                    rho=testCaseSample1$rho
                                )
                            test_x_null_sample2 <- 
                                MBASED:::vectorizedRbetabinomMR(
                                    n=length(testCaseSample2$n), 
                                    size=testCaseSample2$n, 
                                    mu=testCaseSample2$mu, 
                                    rho=testCaseSample2$rho
                                )
                            MBASED:::runMBASED2s1aseID(
                                lociAllele1CountsSample1=test_x_null_sample1, 
                                lociAllele2CountsSample1=testCaseSample1$n-
                                    test_x_null_sample1, 
                                lociAllele1CountsSample2=test_x_null_sample2, 
                                lociAllele2CountsSample2=testCaseSample2$n-
                                    test_x_null_sample2, 
                                lociAllele1NoASEProbsSample1=testCaseSample1$mu, 
                                lociAllele1NoASEProbsSample2=testCaseSample2$mu, 
                                lociRhosSample1=testCaseSample1$rho, 
                                lociRhosSample2=testCaseSample2$rho, 
                                numSim=test_numSim, 
                                isPhased=test_isPhased,
                                tieBreakRandom=test_tieBreakRandom
                            )
                        }, BPPARAM=myBPPARAM)
                        test_null_ASEPvals <- sapply(test_nullResults, function(el) {
                            el$pValueASE
                        })
                        obs_ASEPvals <- sapply(
                            quantilesToCheck, 
                            function(quantileToCheck) {
                                mean(test_null_ASEPvals<=quantileToCheck)
                            }
                        )
                        checkTrue(
                            all(
                                abs(quantilesToCheck-obs_ASEPvals)<0.05 | 
                                MBASED:::testNumericDiff(
                                    queryVals=quantilesToCheck, 
                                    targetVals=obs_ASEPvals, 
                                    ## within 20% of each other (e.g, 0.12 vs. 0.1 p-value)
                                    cutoffFraction=0.2 
                                )
                            ),
                            msg='test_runMBASED2s1aseID: fail test for relative uniformity of ASE p-values under null'
                        ) 
                        ## het p-values only defined for multi-locus genes
                        if (numLoci >1) { 
                            test_null_hetPvals <- sapply(
                                test_nullResults, 
                                function(el) {
                                    el$pValueHeterogeneity
                                }
                            )
                            obs_hetPvals <- sapply(
                                quantilesToCheck, 
                                function(quantileToCheck) {
                                    mean(test_null_hetPvals<=quantileToCheck)
                                }
                            )
                            checkTrue(
                                all(
                                    abs(quantilesToCheck-obs_hetPvals)<0.03 |
                                    MBASED:::testNumericDiff(
                                        queryVals=quantilesToCheck, 
                                        targetVals=obs_hetPvals, 
                                        ## within 20% of each other (e.g, 0.12 vs. 0.1 p-value)
                                        cutoffFraction=0.2 
                                    )    
                                ),
                                msg='test_runMBASED2s1aseID: fail test for relative uniformity of heterogeneity p-values under null'
                            )
                        }     
                    }
                }
            }
        }
        rm(
            numCases, 
            numLoci, 
            test_numSim,
            numTests,
            testCasesMats,
            quantilesToCheck,
            numSEsToCheck,
            test_tieBreakRandom,
            test_isPhased,
            testInd,
            testCase,
            test_nullResults
        )
    }
        
    ## Check 5: check that we can detect true signal: 
    ## p-value should be small. 
    ## only do for full testing, otherwise takes too long: ~ 20-25 min
    if (FULLTESTING) { 
        set.seed(433938)
        ## number of test cases
        numCases <- 100 
        ## number of loci
        for (numLoci in c(1, 5))  {
        	## number of simulations to perform by MBASED
            test_numSim <- 10^6 
            trueMAF=0.9
            testCasesMatsSample1 <- getTestCases(
                numCases=numCases, 
                numLoci=numLoci
            )
            testCasesMatsSample2 <- getTestCases(
                numCases=numCases, 
                numLoci=numLoci
            )
            ## check for all possible values of isPhased
            for (test_isPhased in c(TRUE,FALSE)) { 
            	## check for all possible values of tieBreakRandom
                for (test_tieBreakRandom in c(TRUE,FALSE)) { 
                    testResults <- bplapply(1:numCases, function(testInd) {
                    #for (testInd in 1:numCases) {
                        testCaseSample1 <- getTestCase(
                            testCasesMats=testCasesMatsSample1, 
                            testInd=testInd
                        )
                        testCaseSample2 <- getTestCase(
                            testCasesMats=testCasesMatsSample2, 
                            testInd=testInd
                        )
                        ## make sure we have power to detect ASE
                        testCaseSample1$n <- 1000*testCaseSample1$n 
                        ## make sure we have power to detect ASE
                        testCaseSample2$n <- 1000*testCaseSample2$n 
                        ## trueAF must be a single number
                        test_generating_prob_sample1 <- MBASED:::getPFinal( 
                            trueAF=trueMAF, 
                            noASEAF=testCaseSample1$mu
                        )
                        ## trueAF must be a single number
                        test_generating_prob_sample2 <- MBASED:::getPFinal( 
                            trueAF=0.5, 
                            noASEAF=testCaseSample2$mu
                        )
                        test_x_sample1 <- round(
                            test_generating_prob_sample1*testCaseSample1$n
                        )
                        test_x_sample2 <- round(
                            test_generating_prob_sample2*testCaseSample2$n
                        )
                        runMBASED2s1aseIDOutput <- 
                            MBASED:::runMBASED2s1aseID(
                                lociAllele1CountsSample1=test_x_sample1, 
                                lociAllele2CountsSample1=testCaseSample1$n-
                                    test_x_sample1, 
                                lociAllele1CountsSample2=test_x_sample2, 
                                lociAllele2CountsSample2=testCaseSample2$n-
                                    test_x_sample2, 
                                lociAllele1NoASEProbsSample1=testCaseSample1$mu, 
                                lociAllele1NoASEProbsSample2=testCaseSample2$mu, 
                                lociRhosSample1=testCaseSample1$rho, 
                                lociRhosSample2=testCaseSample2$rho,
                                numSim=test_numSim, 
                                isPhased=test_isPhased,
                                tieBreakRandom=test_tieBreakRandom
                            )
                        checkTrue(
                            runMBASED2s1aseIDOutput$pValueASE <= 0.1, 
                            msg='test_runMBASED2s1aseID: 2-sample does not detect the signal'
                        )
                    #}    
                    }, BPPARAM=myBPPARAM)
                }
            }
        }
        rm(
            numCases, 
            numLoci, 
            test_numSim,
            trueMAF,
            testCasesMatsSample1,
            testCasesMatsSample2,
            test_isPhased,
            test_tieBreakRandom,
            testResults
        )
    }
    
    ## Check 6: For multi-SNV genes only: check that we can 
    ## detect true SNV-specific ASE: heterogeneity p-value should be 
    ## small (for largish n and smallish rho, otherwise not enough evidence). 
    ## only do for full testing, otherwise takes too long
    if (FULLTESTING) { 
        set.seed(708872)
        ## number of test cases
        numCases <- 100 
        ## number of loci
        numLoci <- 3 
        ## number of simulations to perform by MBASED
        test_numSim <- 10^6 
        trueMAF=0.99
        testCasesMatsSample1 <- getTestCases(
            numCases=numCases, 
            numLoci=numLoci
        )
        testCasesMatsSample2 <- getTestCases(
            numCases=numCases, 
            numLoci=numLoci
        )
        ## check for all possible values of isPhased
        for (test_isPhased in c(TRUE,FALSE)) { 
        	## check for all possible values of tieBreakRandom
            for (test_tieBreakRandom in c(TRUE,FALSE)) { 
                testResults <- bplapply(1:numCases, function(testInd) {
                    testCaseSample1 <- getTestCase(
                        testCasesMats=testCasesMatsSample1, 
                        testInd=testInd
                    )
                    testCaseSample2 <- getTestCase(
                        testCasesMats=testCasesMatsSample2, 
                        testInd=testInd
                    )
                    whichSNVisASE <- sample(1:length(testCaseSample1$n), 1)
                    trueMAFsSample1 <- rep(0.5, length(testCaseSample1$n))
                    trueMAFsSample2 <- rep(0.5, length(testCaseSample2$n))
                    trueMAFsSample1[whichSNVisASE] <- trueMAF
                    ## make sure we have power to detect ASE
                    testCaseSample1$n <- 1000*testCaseSample1$n 
                    ## make sure we have power to detect ASE
                    testCaseSample2$n <- 1000*testCaseSample2$n 
                    ## make sure we have power to detect ASE
                    testCaseSample1$rho <- testCaseSample1$rho/10 
                    ## make sure we have power to detect ASE
                    testCaseSample2$rho <- testCaseSample2$rho/10  
                    test_generating_prob_sample1 <- sapply(
                        1:length(trueMAFsSample1), 
                        function(MAFInd) {
                        	## trueAF must be a single number
                            MBASED:::getPFinal(
                                trueAF=trueMAFsSample1[MAFInd], 
                                noASEAF=testCaseSample1$mu[MAFInd]
                            )
                        }
                    )
                    test_generating_prob_sample2 <- sapply(
                        1:length(trueMAFsSample2), 
                        function(MAFInd) {
                        	## trueAF must be a single number
                            MBASED:::getPFinal(
                                trueAF=trueMAFsSample2[MAFInd], 
                                noASEAF=testCaseSample2$mu[MAFInd]
                            )
                        }
                    )
                    test_x_sample1 <- round(
                        test_generating_prob_sample1*testCaseSample1$n
                    )
                    test_x_sample2 <- round(
                        test_generating_prob_sample2*testCaseSample2$n
                    )
                    runMBASED2s1aseIDOutput <- 
                        MBASED:::runMBASED2s1aseID(
                            lociAllele1CountsSample1=test_x_sample1, 
                            lociAllele2CountsSample1=testCaseSample1$n-
                                test_x_sample1, 
                            lociAllele1CountsSample2=test_x_sample2, 
                            lociAllele2CountsSample2=testCaseSample2$n-
                                test_x_sample2, 
                            lociAllele1NoASEProbsSample1=testCaseSample1$mu, 
                            lociAllele1NoASEProbsSample2=testCaseSample2$mu, 
                            lociRhosSample1=testCaseSample1$rho, 
                            lociRhosSample2=testCaseSample2$rho,
                            numSim=test_numSim, 
                            isPhased=test_isPhased,
                            tieBreakRandom=test_tieBreakRandom
                       )
                    checkTrue(
                        runMBASED2s1aseIDOutput$pValueHeterogeneity <= 0.25, 
                        msg='test_runMBASED2s1aseID: 1-sample does not detect the heterogeneity signal '
                    )
                }, BPPARAM=myBPPARAM)
            }
        }
        rm(
            numCases, 
            numLoci, 
            test_numSim,
            trueMAF,
            testCasesMatsSample1,
            testCasesMatsSample2,
            test_isPhased,
            test_tieBreakRandom,
            testResults
        )
    }
    
    return(TRUE)
}

## test behavior of runMBASED2s1() function 
test_runMBASED2s <- function() {
    ## check1: runMBASED2s gives same results as 
    ## performing analysis on each aseID individually.
    set.seed(353948)
    ## Complication due to random sampling I employ: bplapply 
    ## messes with random seed, so I need to write slightly modified 
    ## version of functions to directly specificy seeds.
    runMBASED2s1aseIDTest <- function (
        lociAllele1CountsSample1, 
        lociAllele2CountsSample1, 
        lociAllele1CountsSample2, 
        lociAllele2CountsSample2, 
        lociAllele1NoASEProbsSample1, 
        lociAllele1NoASEProbsSample2, 
        lociRhosSample1, 
        lociRhosSample2, 
        numSim=0, 
        isPhased=FALSE, 
        tieBreakRandom=FALSE, 
        testSeed
    ) {
        set.seed(testSeed)
        res <- MBASED:::runMBASED2s1aseID(
            lociAllele1CountsSample1=lociAllele1CountsSample1, 
            lociAllele2CountsSample1=lociAllele2CountsSample1, 
            lociAllele1CountsSample2=lociAllele1CountsSample2, 
            lociAllele2CountsSample2=lociAllele2CountsSample2, 
            lociAllele1NoASEProbsSample1=lociAllele1NoASEProbsSample1, 
            lociAllele1NoASEProbsSample2=lociAllele1NoASEProbsSample2, 
            lociRhosSample1=lociRhosSample1, 
            lociRhosSample2=lociRhosSample2, 
            numSim=numSim, 
            isPhased=isPhased, 
            tieBreakRandom=tieBreakRandom
        )
        return(res)
    }
    runMBASED2sTest <- function (
        lociAllele1CountsSample1, 
        lociAllele2CountsSample1, 
        lociAllele1CountsSample2, 
        lociAllele2CountsSample2, 
        lociAllele1NoASEProbsSample1, 
        lociAllele1NoASEProbsSample2, 
        lociRhosSample1, 
        lociRhosSample2, 
        aseIDs, 
        numSim=0, 
        BPPARAM=SerialParam(), 
        isPhased=FALSE, 
        tieBreakRandom=FALSE, 
        testSeeds ## one seed for each aseID
    ) {
        ASEResults <- bplapply(unique(aseIDs), function(aseID) {
            aseIDsubv <- (aseIDs==aseID)
            aseIDInd <- which(unique(aseIDs)==aseID)
            res <- runMBASED2s1aseIDTest(
                lociAllele1CountsSample1=lociAllele1CountsSample1[
                    aseIDsubv
                ], 
                lociAllele2CountsSample1=lociAllele2CountsSample1[
                    aseIDsubv
                ], 
                lociAllele1CountsSample2=lociAllele1CountsSample2[
                    aseIDsubv
                ], 
                lociAllele2CountsSample2=lociAllele2CountsSample2[
                    aseIDsubv
                ], 
                lociAllele1NoASEProbsSample1=lociAllele1NoASEProbsSample1[
                    aseIDsubv
                ], 
                lociAllele1NoASEProbsSample2=lociAllele1NoASEProbsSample2[
                    aseIDsubv
                ], 
                lociRhosSample1=lociRhosSample1[
                    aseIDsubv
                ], 
                lociRhosSample2=lociRhosSample2[
                    aseIDsubv
                ], 
                numSim=numSim, 
                isPhased=isPhased, 
                tieBreakRandom=tieBreakRandom, 
                testSeed=testSeeds[
                    aseIDInd
                ]
            ) 
            return(res)
        }, BPPARAM=BPPARAM)
        names(ASEResults) <- unique(aseIDs)
        allele1IsMajor <- unname(
            unlist(
                lapply(
                    ASEResults, 
                    function(el) {
                        el$lociAllele1IsMajor
                    }
                )
            )
        )
        lociMAFDifference <- unname(
            unlist(
                lapply(
                    ASEResults, 
                    function(el) {
                        el$lociMAFDifference
                    }
                )
            )
        )
        ASEResults <- lapply(ASEResults, function(el) {
            el$lociAllele1IsMajor <- NULL
            el$lociMAFDifference <- NULL
            return(el)
        })
        ASEResults <- as.data.frame(
            do.call(
                rbind,
                lapply(ASEResults, function(el) {
                    unlist(el)
                })
            )
        )
        return(
            list(
                ASEResults=ASEResults, 
                allele1IsMajor=allele1IsMajor,
                lociMAFDifference=lociMAFDifference
            )
        )
    }
    ## actual testing
    if (FULLTESTING) {
    	## number of test cases
        numCases <- 100 
    } else {
    	## number of test cases
        numCases <- 3 
    }
    ## 3 aseIDs, with 1, 3, and 4 loci each
    numLoci_for_aseIDs <- c(1, 3, 4) 
    ## number of total loci
    totalNumLoci <- sum(numLoci_for_aseIDs) 
    testCasesMatsSample1 <- getTestCases(
        numCases=numCases, 
        numLoci=totalNumLoci
    )
    testCasesMatsSample2 <- getTestCases(
        numCases=numCases, 
        numLoci=totalNumLoci
    )
    ## check for all possible values of tieBreakRandom
    for (test_tieBreakRandom in c(TRUE,FALSE)) { 
    	## check for all possible values of test_isPhased
        for (test_isPhased in c(TRUE, FALSE)) { 
        	## try sims and no-sims
            for (test_numSim in c(0, 3)) { 
                testResults <- bplapply(1:numCases, function(testInd) {
                    testCaseSample1 <- getTestCase(
                        testCasesMats=testCasesMatsSample1, 
                        testInd=testInd
                    )
                    testCaseSample2 <- getTestCase(
                        testCasesMats=testCasesMatsSample2, 
                        testInd=testInd
                    )
                    test_aseIDs <- rep(
                        paste(
                            'gene',
                            1:length(numLoci_for_aseIDs), 
                            sep=''
                        ), 
                        numLoci_for_aseIDs
                    )
                    test_seeds=sample(
                        1:(10^6), 
                        length(unique(test_aseIDs))
                    )
                    ## get joint results:
                    jointResults <- runMBASED2sTest(
                        lociAllele1CountsSample1=testCaseSample1$x, 
                        lociAllele2CountsSample1=testCaseSample1$n-
                            testCaseSample1$x, 
                        lociAllele1CountsSample2=testCaseSample2$x, 
                        lociAllele2CountsSample2=testCaseSample2$n-
                            testCaseSample2$x, 
                        lociAllele1NoASEProbsSample1=testCaseSample1$mu,
                        lociAllele1NoASEProbsSample2=testCaseSample2$mu, 
                        lociRhosSample1=testCaseSample1$rho, 
                        lociRhosSample2=testCaseSample2$rho,
                        aseIDs=test_aseIDs,
                        numSim=test_numSim, 
                        BPPARAM=SerialParam(),
                        isPhased=test_isPhased,
                        tieBreakRandom=test_tieBreakRandom,
                        testSeeds=test_seeds
                    )
                    ## get individual results:
                    runMBASED2s1aseIDOutputs <- lapply(
                        unique(test_aseIDs), 
                        function(test_aseID) {
                            test_aseID_subv <- (test_aseIDs==test_aseID)
                            test_aseID_ind <- which(
                                unique(test_aseIDs)==test_aseID
                            )
                            runMBASED2s1aseIDOutput <- 
                                runMBASED2s1aseIDTest(
                                    lociAllele1CountsSample1=testCaseSample1$x[
                                        test_aseID_subv
                                    ], 
                                    lociAllele2CountsSample1=(
                                        testCaseSample1$n-testCaseSample1$x
                                    )[test_aseID_subv], 
                                    lociAllele1CountsSample2=testCaseSample2$x[
                                        test_aseID_subv
                                    ], 
                                    lociAllele2CountsSample2=(
                                        testCaseSample2$n-testCaseSample2$x
                                    )[test_aseID_subv],
                                    lociAllele1NoASEProbsSample1=testCaseSample1$mu[
                                        test_aseID_subv
                                    ], 
                                    lociAllele1NoASEProbsSample2=testCaseSample2$mu[
                                        test_aseID_subv
                                    ], 
                            lociRhosSample1=testCaseSample1$rho[
                                test_aseID_subv
                            ], 
                            lociRhosSample2=testCaseSample2$rho[
                                test_aseID_subv
                            ],
                            numSim=test_numSim, 
                            isPhased=test_isPhased,
                            tieBreakRandom=test_tieBreakRandom,
                            testSeed=test_seeds[
                                test_aseID_ind
                            ]
                        )
                        return(runMBASED2s1aseIDOutput)
                    })
                    individualResults <- list(
                        ASEResults=data.frame(
                            majorAlleleFrequencyDifference=sapply(
                                runMBASED2s1aseIDOutputs, 
                                function(el) {
                                    el$majorAlleleFrequencyDifference
                                }
                            ),
                            pValueASE=sapply(
                                runMBASED2s1aseIDOutputs, 
                                function(el) {
                                    el$pValueASE
                                }
                            ),
                            heterogeneityQ=sapply(
                                runMBASED2s1aseIDOutputs, 
                                function(el) {
                                    el$heterogeneityQ
                                }
                            ),
                            pValueHeterogeneity=sapply(
                                runMBASED2s1aseIDOutputs, 
                                function(el) {
                                    el$pValueHeterogeneity
                                }
                            ),
                            nullHypothesisMAF=sapply(
                                runMBASED2s1aseIDOutputs, 
                                function(el) {
                                    el$nullHypothesisMAF
                                }
                            ),
                            row.names=unique(test_aseIDs)
                        ),
                        allele1IsMajor=unlist(
                            lapply(
                                runMBASED2s1aseIDOutputs, 
                                function(el) {
                                    el$lociAllele1IsMajor
                                }
                            )
                        ),
                        lociMAFDifference=unlist(
                            lapply(
                                runMBASED2s1aseIDOutputs, 
                                function(el) {
                                    el$lociMAFDifference
                                }
                            )
                        )
                    )
                    checkEquals(
                        jointResults, 
                        individualResults, 
                        msg='test_runMBASED2s: failed test checking that runMBASED1s does the same job as individual calls to runMBASED2s1aseID'
                    )
                }, BPPARAM=myBPPARAM)
            }
        }
    }
    
    return(TRUE)
}    
    

    
    

## size of round-off error I'm tolerating 
## (quantities with differences of this much or smaller are considered the same)
myPrecision <- .Machine$double.eps^0.5 
FULLTESTING <- FALSE
if (FULLTESTING) {
    myBPPARAM <- MulticoreParam(workers=24)
} else {
    myBPPARAM <- SerialParam()
}

## test FT() function
test_FT <- function() {
    ## check1: FT is monotone increasing function of x
    test_n <- 100
    test_FT_values <- MBASED:::FT(
        x=0:test_n, 
        n=rep(test_n, length(0:test_n))
    )
    checkEqualsNumeric(
        1:(test_n+1),
        order(test_FT_values), 
        msg='test_FT: fail FT monotonic test'
    )
    checkTrue(
        MBASED:::FT(x=0,n=1)<MBASED:::FT(x=1,n=1), 
        msg='test_FT: fail FT n=1 test'
    ) ## also tests border case of n=1
    
    ## check2: FT(n/2,n)=pi/2
    test_n <- 100
    checkEqualsNumeric(
        MBASED:::FT(x=(test_n/2), n=test_n), 
        pi/2,
        msg='test_FT: fail FT pi/2 test'
    )
    
    ## check3: vectorization works
    ## test for matrices 
    set.seed(777891)
    numCases <- 100
    numCols <- 5
    numRows <- numCases/numCols
    test_xs <- sample(0:10, numCases, replace=T)
    test_ns <- sample(10:20, numCases, replace=T)
    test_xs_mat <- matrix(
        test_xs, 
        ncol=numCols
    )
    test_ns_mat <- matrix(
        test_ns, 
        ncol=numCols
    )
    individualResults <- matrix(
        NA,
        nrow=numRows, 
        ncol=numCols
    )
    for (i in 1:nrow(individualResults)) {
        for (j in 1:ncol(individualResults)) {
            individualResults[i,j] <- MBASED:::FT(
                x=test_xs_mat[i,j], 
                n=test_ns_mat[i,j]
            )
        }
    }
    jointResults <- MBASED:::FT(
        x=test_xs_mat, 
        n=test_ns_mat
    )
    checkEqualsNumeric(
        individualResults, 
        jointResults,
        msg='test_FT: fail FT vectorization test'
    )
    ## also test for vectors
    individualResults <- sapply(1:numCases, function(ind) {
        MBASED:::FT(
            x=test_xs[ind], 
            n=test_ns[ind]
        )
    })
    jointResults <- MBASED:::FT(
        x=test_xs, 
        n=test_ns
    )
    checkEqualsNumeric(
        jointResults, 
        individualResults, 
        msg='test_FT: fail FT vectorization test'
    )
    
    
    ## check4: if n is large and x~Bin(n,p), 
    ## then FT(x,n) ~ N(2*arcsin(sqrt(p)), 1/(n+0.5))
    test_n <- 10^5
    test_ps <- seq(0.1, 0.9, by=0.1)
    if (FULLTESTING) {
        numCountsToGenerate <- 10^6
    } else {
    	## need this to be high to make quantiles close to truth
        numCountsToGenerate <- 10^6 
    }
    set.seed(443678)
    testResults <- bplapply(1:length(test_ps), function(testInd) {
        test_p <- test_ps[testInd]
        test_counts <- rbinom(
            n=numCountsToGenerate, 
            size=test_n, 
            prob=test_p
        )
        test_FT_values <- MBASED:::FT(
            x=test_counts, 
            n=rep(test_n, length(test_counts))
        )
        ## check mean
        obsMean <- mean(test_FT_values)
        predMean <- 2*asin(sqrt(test_p))
        checkTrue(
            MBASED:::testNumericDiff(
                queryVals=obsMean, 
                targetVals=predMean, 
                cutoffFraction=0.01 ## within 1%
            ),
            msg=paste('test_FT: fail predicted mean test for p=', test_p, sep='')
        ) 
        ## check variance
        obsVar <- var(test_FT_values)
        predVar <- 1/(test_n+0.5)
        checkTrue(
            MBASED:::testNumericDiff(
                queryVals=obsVar, 
                targetVals=predVar, 
                cutoffFraction=0.01 ## within 1%
            ),
            msg=paste('test_FT: fail predicted mean test for p=', test_p, sep='')
        ) 
        ## check normality
        ## exclude 0.5 to avoid quantile value of 0
        quantilesToCheck <- setdiff(seq(0.1, 0.9, by=0.1), 0.5) 
        test_z_values <- (test_FT_values-predMean)/sqrt(predVar)
        obsQuantiles <- unname(quantile(test_z_values, quantilesToCheck))
        predQuantiles <- qnorm(quantilesToCheck)
        checkTrue(
            all(
                MBASED:::testNumericDiff(
                    queryVals=obsQuantiles, 
                    targetVals=predQuantiles, 
                    cutoffFraction=0.05 ## within 5%
                )
            ),
            msg=paste('test_FT: fail normality test for p=', test_p, sep='')
        )
    }, BPPARAM=myBPPARAM)
    
    return(TRUE)
}    
    
## test unFT() function
test_unFT <- function() {    
    ## check1: unFT is the reverse of FT
    test_n <- 100
    testResults <- bplapply(0:test_n, function(testInd) {
        test_x <- testInd
        trueProps <- test_x/test_n
        FTProps <- MBASED:::unFT(
            z=MBASED:::FT(
                x=test_x, 
                n=test_n
            ), 
            n=test_n
        )
        checkEqualsNumeric(
            FTProps, 
            trueProps, 
            msg='test_unFT: fail unFT is reverse of FT test'
        )
    }, BPPARAM=myBPPARAM)
    
    ## check2: unFT handles situations with extreme z values
    test_n <- 100
    maxZ <- MBASED:::FT(
        x=test_n,
        n=test_n
    )
    minZ <- MBASED:::FT(
        x=0,
        n=test_n
    )
    checkEqualsNumeric(
        MBASED:::unFT(
            z=maxZ, 
            n=test_n
        ), 
        MBASED:::unFT(
            z=maxZ+10, 
            n=test_n
        ), 
        msg='test_unFT: fail extreme value test'
    )
    checkEqualsNumeric(
        MBASED:::unFT(
            z=minZ, 
            n=test_n
        ), 
        MBASED:::unFT(
            z=minZ-10, 
            n=test_n
        ), 
        msg='test_unFT: fail extreme value test'
    )

    ## check3: vectorization works
    set.seed(863249)
    ## check for matrices
    numCases <- 1000
    numCols <- 20
    numRows <- numCases/numCols
    test_zs <- runif(numCases, min=(-pi), max=pi)
    test_ns <- sample(10:20, numCases, replace=T)
    test_zs_mat <- matrix(
        test_zs, 
        ncol=numCols
    )
    test_ns_mat <- matrix(
        test_ns, 
        ncol=numCols
    )
    individualResults <- matrix(
        NA,
        nrow=numRows, 
        ncol=numCols
    )
    for (i in 1:nrow(individualResults)) {
        for (j in 1:ncol(individualResults)) {
            individualResults[i,j] <- MBASED:::unFT(
                z=test_zs_mat[i,j], 
                n=test_ns_mat[i,j]
            )
        }
    }
    jointResults <- MBASED:::unFT(
        z=test_zs_mat, 
        n=test_ns_mat
    )
    checkEqualsNumeric(
        jointResults,
        individualResults,
        msg='test_unFT: fail unFT vectorization test'
    ) 
    ## check vectorization for vectors
    individualResults <- unlist(bplapply(1:numCases, function(testInd) {
        MBASED:::unFT(
            z=test_zs[testInd], 
            n=test_ns[testInd]
        )
    }, BPPARAM=myBPPARAM))
    jointResults <- MBASED:::unFT(
        z=test_zs, 
        n=test_ns
    )
    checkEqualsNumeric(
        jointResults,
        individualResults,
        msg='test_unFT: fail unFT vectorization test'
    ) 
    
    return(TRUE)
}
    
## test FTAdjust() function
test_FTAdjust <- function() {        
    ## check1: vectorization works
    ## check for matrices
    set.seed(324515)
    numCases <- 100
    numCols <- 20
    numRows <- numCases/numCols
    test_xs <- sample(0:10, numCases, replace=T)
    test_ns <- sample(10:20, numCases, replace=T)
    test_ps <- sample(seq(0.1, 0.9, by=0.1), numCases, replace=T)
    test_xs_mat <- matrix(
        test_xs, 
        ncol=numCols
    )
    test_ns_mat <- matrix(
        test_ns, 
        ncol=numCols
    )
    test_ps_mat <- matrix(
        test_ps, 
        ncol=numCols
    )
    individualResults <- matrix(
        NA,
        nrow=numRows, 
        ncol=numCols
    )
    for (i in 1:nrow(individualResults)) {
        for (j in 1:ncol(individualResults)) {
            individualResults[i,j] <- MBASED:::FTAdjust(
                x=test_xs_mat[i,j], 
                n=test_ns_mat[i,j], 
                p=test_ps_mat[i,j]
            )
        }
    }
    jointResults <- MBASED:::FTAdjust(
        x=test_xs_mat, 
        n=test_ns_mat, 
        p=test_ps_mat
    )
    checkEqualsNumeric(
        jointResults,
        individualResults,
        msg='test_FTAdjust: fail FTAdjust vectorization test'
    ) 
    ## also check for vectors
    individualResults <- sapply(1:numCases, function(ind) {
        MBASED:::FTAdjust(
            x=test_xs[ind], 
            n=test_ns[ind], 
            p=test_ps[ind]
        )
    })
    jointResults <- MBASED:::FTAdjust(
        x=test_xs, 
        n=test_ns, 
        p=test_ps
    )
    checkEqualsNumeric(
        jointResults,
        individualResults,
        msg='test_FTAdjust: fail FTAdjust vectorization test'
    ) 
    
    ## check2: adjustment is exact when p=0.5
    test_n <- 100
    unadjustedFTs <- MBASED:::FT(
        x=0:test_n, 
        n=rep(test_n, test_n+1)
    )
    adjustedFTs <- MBASED:::FTAdjust(
        x=0:test_n, 
        n=rep(test_n, test_n+1), 
        p=rep(0.5, test_n+1)
    )
    checkEqualsNumeric(
        unadjustedFTs,
        adjustedFTs,
        msg='test_FTAdjust: fail FTAdjust p=0.5 test'
    ) 
    
    ## check3: adjustment actually does what it's supposed to do:
    test_n <- 100
    test_ps <- seq(0.1, 0.9, by=0.1)
    for (test_p in test_ps) {
        for (test_x in 0:test_n) {
            automatedResult <- MBASED:::FTAdjust(
                x=test_x, 
                n=test_n, 
                p=test_p
            )
            manualResult <- MBASED:::FT(
                x=test_x, 
                n=test_n
            )-2*asin(sqrt(test_p))+2*asin(sqrt(0.5))
            checkEqualsNumeric(
                automatedResult, 
                manualResult, 
                msg='test_FTAdjust: fail FTAdjust p!=0.5 test'
            )
        }
    }
    
    ## check4: adjustment works ok for mild levels of 
    ## distorting ps and for high counts
    test_n=10^4
    test_ps=seq(0.4, 0.6, by=0.05)
    test_props=seq(0.1, 0.9, by=0.1)
    for (test_p in test_ps) {
        for (test_prop in test_props) {
        	test_generating_p_num <- test_p*test_prop
        	test_generating_p_denom <- (test_p*test_prop+(1-test_p)*(1-test_prop))
            test_generating_p <- test_generating_p_num/test_generating_p_denom
            predProp <- test_prop
            obsProp <- MBASED:::unFT(
                z=MBASED:::FTAdjust(
                    x=test_n*test_generating_p, 
                    n=test_n, 
                    p=test_p
                ), 
                n=test_n
            )
            checkTrue(
                (abs(obsProp-predProp)<=0.05) ||
                MBASED:::testNumericDiff(
                    queryVals=obsProp, 
                    targetVals=predProp, 
                    cutoffFraction=0.05 ## within 5%
                ),
                msg='test_FTAdjust: fail FTAdjust check if works for reasonable values of distortion'
            ) 
        }
    }
        
    return(TRUE)
}
    
## test isCountMajor() function
test_isCountMajor<- function() {    
    ## check1: vectorization works (no breaking ties randomly)
    set.seed(804225)
    ## check for matrices
    numCases <- 100
    numCols <- 20
    numRows <- numCases/numCols
    test_xs <- sample(0:10, numCases, replace=T)
    test_ns <- sample(10:20, numCases, replace=T)
    test_ps <- sample(seq(0.1, 0.9, by=0.1), numCases, replace=T)
    test_xs_mat <- matrix(
        test_xs, 
        ncol=numCols
    )
    test_ns_mat <- matrix(
        test_ns, 
        ncol=numCols
    )
    test_ps_mat <- matrix(
        test_ps, 
        ncol=numCols
    )
    individualResults <- matrix(
        NA,
        nrow=numRows, 
        ncol=numCols
    )
    for (i in 1:nrow(individualResults)) {
        for (j in 1:ncol(individualResults)) {
            individualResults[i,j] <- MBASED:::isCountMajorFT(
                x=test_xs_mat[i,j], 
                n=test_ns_mat[i,j], 
                p=test_ps_mat[i,j], 
                tieBreakRandom=FALSE
            )
        }
    }
    jointResults <- MBASED:::isCountMajorFT(
        x=test_xs_mat, 
        n=test_ns_mat, 
        p=test_ps_mat, 
        tieBreakRandom=FALSE
    )    
    checkIdentical(
        jointResults,
        individualResults,
        msg='test_isCountMajor: fail isCountMajorFT vectorization test'
    ) 
    ## also check for vectors
    individualResults <- sapply(1:numCases, function(ind) {
        MBASED:::isCountMajorFT(
            x=test_xs[ind], 
            n=test_ns[ind], 
            p=test_ps[ind], 
            tieBreakRandom=FALSE
        )
    })
    jointResults <- MBASED:::isCountMajorFT(
        x=test_xs, 
        n=test_ns, 
        p=test_ps, 
        tieBreakRandom=FALSE
    )
    checkIdentical(
        jointResults,
        individualResults,
        msg='test_isCountMajor: fail isCountMajorFT vectorization test'
    ) 

    ## check2: isCountMajor does what it's supposed to do 
    ## (with possible exception of borderline cases):
    test_ns <- 1:100
    test_ps <- seq(0.1, 0.9, by=0.1)
    for (test_p in test_ps) {
        for (test_n in test_ns) {
        	## the  cases at the breakpoint can go either way 
        	## due to roundoff during adjustment
            test_xs <- setdiff(0:test_n, c(floor(test_p*test_n), ceiling(test_p*test_n))) 
            test_xs_major <- test_xs[test_xs>( test_p*test_n)]
            test_xs_minor <- test_xs[test_xs<( test_p*test_n)]
            test_xs_major_results <- MBASED:::isCountMajorFT(
                x=test_xs_major, 
                n=rep(test_n, length(test_xs_major)), 
                p=rep(test_p, length(test_xs_major)), 
                tieBreakRandom=FALSE
            )
            test_xs_minor_results <- MBASED:::isCountMajorFT(
                x=test_xs_minor, 
                n=rep(test_n, length(test_xs_minor)), 
                p=rep(test_p, length(test_xs_minor)), 
                tieBreakRandom=FALSE
            )
            checkTrue(
                all(test_xs_major_results), 
                msg='test_isCountMajor: fail isCountMajorFT basic functionality test'
            )
            checkTrue(
                all(!test_xs_minor_results), 
                msg='test_isCountMajor: fail isCountMajorFT basic functionality test'
            )
        }
    }
    
    ## check3: the breaking of the ties works
    numCases <- 10^6
    midVal <- 5
    test_results_no_tie_break <- MBASED:::isCountMajorFT(
        x=rep(midVal, numCases), 
        n=rep(2*midVal, numCases), 
        p=rep(0.5, numCases), 
        tieBreakRandom=FALSE
    )
    checkTrue(
        ## all have same assignment
        length(unique(test_results_no_tie_break))==1, 
        msg='test_isCountMajor: fail isCountMajorFT tie-breaking test'
    ) 
    test_results_tie_break <- MBASED:::isCountMajorFT(
        x=rep(midVal, numCases), 
        n=rep(2*midVal, numCases), 
        p=rep(0.5, numCases), 
        tieBreakRandom=TRUE
    ) ## should be about 50% true, 50% false. 
    MBASED:::testQuantiles(
        theoreticalCumDist=0.5, 
        observedCumDist=mean(test_results_tie_break), 
        numTotalCounts=numCases, 
        numSEsToCheck=5, 
        errorMessage='test_isCountMajor: fail isCountMajorFT tie-breaking test'
    ) 
    
    return(TRUE)
}    
    

%\VignetteIndexEntry{MBASED}
%\VignetteDepends{}
%\VignetteKeywords{MBASED}
\documentclass{article}[12pt]
<<style-Sweave, eval=TRUE, echo=FALSE, results=tex>>=
BiocStyle::latex()
@






\begin{document}
\title{MBASED Overview}
\maketitle

\section{MBASED algorithm}
The package MBASED (\textbf{M}eta-analysis-\textbf{B}ased
\textbf{A}llele-\textbf{S}pecific \textbf{E}xpression
\textbf{D}etection) implements an algorithm for identifying instances
of allele-specific gene expression in RNA count data. In one-sample analyses, MBASED
identifies within-sample deviations from the null hypothesis
of equal allele expression, while for two-sample analyses, significant differences in allelic ratios between samples with the same
haplotypes are detected. This means that the comparison is meaningful
for samples from the same individual, but not necessarily for 
samples from different individuals. MBASED uses principles of meta-analysis to combine information across 
loci within a single unit of expression (which we call \texttt{aseID}, e.g., a gene,
a transcript, or an individual SNV), without relying on \emph{a priori}
knowledge of phased haplotypes. The informative loci are usually heterozygous SNVs, but
could also be aggregations of SNVs or other variants that have been resolved into the
same haplotype. In the extreme case of complete phasing, loci could be
genes themselves, and the approach presented here reduces to a
(beta-)binomial test of difference between reads mapping to different
haplotypes. In the following discussion, we
will use `gene' in place of aseID and `SNV' in place of `locus', as
these are the units we typically use in
practice.

The details of the statistical approach implented by MBASED can be
found in the accompanying paper. Here we briefly mention a few items
pertaining to the interpretation of MBASED output.


\subsection{1-Sample analysis}

For each gene $g$ with at least one expressed heterozygous locus, we test the null hypothesis
$p_{hap1,g}=p_{hap2,g}=0.5$, where $p_{hap1,g}$ and $p_{hap2,g}$ denote
the underlying fractions of transcribed copies of gene $g$, specific to
each haplotype. Note that we assume that gene $g$ is represented by
exactly two, and not more, haplotypes. The alternative hypothesis is $p_{hap1,g} \neq
p_{hap2,g}$. The beta-binomial statistical model used by MBASED is
flexible and allows ASE assessment in
presence of pre-existing allelic bias (e.g., over-representation of reference
allele-supporting reads due to enrichment protocols even in absence of
any underlying ASE)
and overdispersion. We show examples of this flexibility below, and the user is referred to the accompanying paper for
the details of the algorithm used by MBASED. For each gene $g$ the output of MBASED includes 
\begin{enumerate}
  \item Estimate of the underlying RNA major haplotype (allele)
    frequency (\texttt{majorAlleleFrequency}, MAF). 
  \item P-value for the test of null hypothesis of no ASE (\texttt{pValueASE}). Note that the null
    hypothesis can be reparametrized in terms of major haplotype
    frequency as $H_0: MAF>0.5$. The reported p-values are not
    adjusted for multiple hypothesis testing, and such adjustment should be
    carried out by the user when looking for statistical significance
    across multiple genes.
      \item P-value for test of null hypothesis of no inter-SNV variability of ASE in the gene
        (only for genes with $>1$ tested SNVs, \texttt{pValueHeterogeneity}). Small p-values
        correspond to significantly inconsistent ASE measurements at individual SNVs within
        a gene. If the unit of expression is a gene with multiple
        transcript isoforms, the observed inconsitency might indicate
        isoform-specific ASE. Alternatively, SNVs for such genes might
        exhibit background variability of ASE measures in excess of
        what is specified by the user (MBASED requires the user to
        specify the level of variability in the data, see below).
  \end{enumerate}



\subsection{2-Sample analysis}
\label{sec:2sample}
For each gene $g$ with at least one heterozygous locus expressed in
both samples, we test the null hypothesis
$p_{hap1,g, sample1}=p_{hap2,g, sample2}=p_{hap,1}$, where $p_{hap1,g, sample1}$
and $p_{hap1,g, sample1}$ denote
the underlying fractions of transcribed copies of gene $g$, specific to
haplotype 1 in each sample. No requirement is imposed that
$p_{hap1,g,sample1}=0.5$, since we are interested in differences in ASE
pattern between the two samples, not in whether they both exhibit
ASE. Just as in 1-sample analysis, we assume that gene $g$ is represented by
exactly two, and not more, haplotypes, and we further require that
these haplotypes be the same in both samples. The alternative hypothesis is $p_{hap1,g, sample1} \neq
p_{hap1,g, sample2}$. For each gene $g$ the output of MBASED includes 
\begin{enumerate}
   \item Estimate of underlying major haplotype frequency difference,
     $p_{hap_{maj},g,sample1} - p_{hap_{maj},g,sample2}$, where
     $hap_{maj}$ is the major of the two haplotypes in sample 1 (\texttt{majorAlleleFrequencyDifference}). This
     is our measure of between-sample allelic imblance (the 2-sample ASE). Note
     that assignment of haplotypes to `major' and `minor' is based
     exclusively on sample 1, since the 2-sample analysis is designed
     to look for ASE specific to sample 1. If ASE specific to sample 2
     is of interest, the roles of the samples should be reversed.  
  \item P-value for the test of null hypothesis of no differential ASE (\texttt{pValueASE}). Analogous to 1-sample
    analysis, the reported p-values are not
    adjusted for multiple hypothesis testing, and such adjustment should be
    carried out by the user when looking for statistical significance
    across multiple genes.
   \item P-value for test test of null hypothesis of no inter-SNV variability of ASE in the gene
        (only for genes with $>1$ tested SNVs, \texttt{pValueHeterogeneity}). Small p-values
        correspond to significantly inconsistent 2-sample ASE measurements at individual SNVs within
        a gene. If the unit of expression is a gene with multiple
        transcript isoforms, the observed inconsitency might indicate
        isoform-specific allelic imbalance between the two samples.
  \end{enumerate}

\section{Caveat Emptor}
MBASED operates on read counts from heterozygous expressed SNVs. The
onus is on the user to make sure that the supplied counts do in fact
correspond to heterozygous SNVs. Any read counts coming from a
homozygous SNV will by definition result in the detection of
monoallelic expression. Further, it is up to the user to pre-filter
SNVs for any known artifacts that might give rise to spurious ASE calls.

The p-values returned by MBASED are not adjusted for multiple
hypothesis testing, and it is left to the user to choose the
appropriate adjustment procedure and significance cutoff.  

Further, to ensure the sufficient power for ASE detection, we strongly
recommend that only SNVs with sufficient read coverage be retained for
the analysis. What constitutes `sufficient coverage' will depend on
the multiple hypothesis testing adjustment procedure and cutoffs
chosen by the user to employ on the p-values reported by MBASED. In
our work, we required the depth of coverage of at least
10 reads, and higher cutoffs may be employed with more deeply
sequenced samples.

Finally, while MBASED is designed to detect instances of statistically
significant ASE, it is up to the user to decide what constitutes
\emph{biologically significant} ASE. Apropriate cutoffs on the
reported measures of ASE (\texttt{majorAlleleFrequency} in case of
1-sample analysis, \texttt{majorAlleleFrequencyDifference} in case of
2-sample analysis) should then be employed to define the set of ASE
genes for follow-up.

MBASED allows the user to provide information about pre-existing
allelic bias and extra-binomial dispersion of read counts at
individual loci (see examples later in the vignette), but currently
does not provide explicit functionality for estimating these quantities.

See the accompanying paper for further discussion of these and other issues.


\section{Examples}
ASE assessment is performed by function runMBASED(). Please check the help page for a full list of arguments.
Here we show some examples of its use. We start by discussing simple
examples of both 1-sample and 2-sample analyses, and then show some
examples of advanced usage, including adjusting for pre-existing allelic bias
and extra-binomial dispersion in the data.

\subsection{Input/Output format}
The input and output of runMBASED() function are RangedSummarizedExperiment
objects, defined in R package 'SummarizedExperiment'. Please see the
RangedSummarizedExperiment help page for details. Briefly, the input object
has rows corresponding to individual SNVs and columns corresponding to
samples. In 1-sample analysis, there is a single column. In 2-sample
analysis, there are 2 columns, one for each sample, with first column
corresponding to `sample1' and second column corresponding to
`sample2' in the language of section \ref{sec:2sample}. The output is also a
RangedSummarizedExperiment object, with rows corresponding to individual
aseIDs and a single column. MBASED output at the level of individual
SNV is stored as metadata on the output object. The examples
below will illustrate the usage.

\subsection{1-sample analysis}
Suppose we are looking at 2 genes, one of which has 1 SNV and the
other has 3 SNVs:
\begin{table}[h]
  \centering
  \begin{tabular}{|c|c|c|c|c|c|}
    \hline
    locus & location & refAllele & altAllele & refCount & altCount \\
    \hline
   gene1:SNV1 & chr1:100 & G & T & 25 & 20\\
    \hline
   gene2:SNV1 & chr2:1000 & A & C & 10 & 16\\
    \hline
   gene2:SNV2 & chr2:1100 & C & T & 22 & 15\\
    \hline
   gene2:SNV3 & chr2:1200 & A & G & 14 & 16\\
    \hline
  
    
  \end{tabular}
  \caption{1-Sample example}
  \label{tab:ex1s}
\end{table}

If we know the true underlying haplotypes of the gene, we can run
MBASED as follows (assuming all reference alleles are on the same haplotype):

<<label=example1s_sim_phased, eval=TRUE, echo=TRUE>>=
set.seed(988482)
library(MBASED)
##a quick look at the main function
args(runMBASED)
## create GRanges object for SNVs of interest.
## note: the only required column is 'aseID'
mySNVs <- GRanges(
  seqnames=c('chr1', 'chr2', 'chr2', 'chr2'),
  ranges=IRanges(start=c(100, 1000, 1100, 1200), width=1),
  aseID=c('gene1', rep('gene2', 3)),
  allele1=c('G', 'A', 'C', 'A'),
  allele2=c('T', 'C', 'T', 'G')	
)
names(mySNVs) <- c('gene1_SNV1', 'gene2_SNV1', 'gene2_SNV2', 'gene2_SNV3')
## create input RangedSummarizedExperiment object
mySample <- SummarizedExperiment(
  assays=list(
    lociAllele1Counts=matrix(
      c(25, 10, 22, 14),
      ncol=1,
      dimnames=list(
       names(mySNVs), 
       'mySample'
      )
    ),
    lociAllele2Counts=matrix(
      c(20,16,15,16),
      ncol=1, 
      dimnames=list(
       names(mySNVs), 
       'mySample'
      )
    )
  ),
  rowRanges=mySNVs
)

##example of use
ASEresults_1s_haplotypesKnown <- runMBASED(
  ASESummarizedExperiment=mySample,
  isPhased=TRUE,
  numSim=10^6,
  BPPARAM = SerialParam()
)

## explore the return object
class(ASEresults_1s_haplotypesKnown)
names(assays(ASEresults_1s_haplotypesKnown))
assays(ASEresults_1s_haplotypesKnown)$majorAlleleFrequency
assays(ASEresults_1s_haplotypesKnown)$pValueASE
assays(ASEresults_1s_haplotypesKnown)$pValueHeterogeneity
rowRanges(ASEresults_1s_haplotypesKnown)
names(metadata(ASEresults_1s_haplotypesKnown))
class(metadata(ASEresults_1s_haplotypesKnown)$locusSpecificResults)
names(assays(metadata(ASEresults_1s_haplotypesKnown)$locusSpecificResults))
assays(metadata(ASEresults_1s_haplotypesKnown)$locusSpecificResults)$allele1IsMajor
assays(metadata(ASEresults_1s_haplotypesKnown)$locusSpecificResults)$MAF
rowRanges(metadata(ASEresults_1s_haplotypesKnown)$locusSpecificResults)

## define function to print out the summary of ASE results
summarizeASEResults_1s <- function(MBASEDOutput) {
  geneOutputDF <- data.frame(
   majorAlleleFrequency=assays(MBASEDOutput)$majorAlleleFrequency[,1],
   pValueASE=assays(MBASEDOutput)$pValueASE[,1],  
   pValueHeterogeneity=assays(MBASEDOutput)$pValueHeterogeneity[,1]
  )   
  lociOutputGR <- rowRanges(metadata(MBASEDOutput)$locusSpecificResults)
  lociOutputGR$allele1IsMajor <- assays(metadata(MBASEDOutput)$locusSpecificResults)$allele1IsMajor[,1]
  lociOutputGR$MAF <- assays(metadata(MBASEDOutput)$locusSpecificResults)$MAF[,1]
  lociOutputList <- split(lociOutputGR, factor(lociOutputGR$aseID, levels=unique(lociOutputGR$aseID))) 
  return(
   list(
     geneOutput=geneOutputDF,
     locusOutput=lociOutputList
   )
  )
}
summarizeASEResults_1s(ASEresults_1s_haplotypesKnown)
@

The output of \texttt{runMBASED()} is a RangedSummarizedExperiment object
with 3 single-column assay matrices. The rows of the matrices
correspond to individual aseIDs, in our case `gene1' and
`gene2'. The matrices are majorAlleleFrequency (MBASED estimate of
gene-level MAF), pValueASE (the coresponding p-value), and
pValueHeterogeneity (the inter-SNV variability p-values). Note that heterogeneity p-value is \texttt{NA} for gene1,
since this gene
only has 1 tested SNV. The metadata slot of the return object contains a
single element, `locusSpecificResults', which is a
RangedSummarizedExperiment object with information on MBASED results at the
level of individual SNV. The assay matrices specify whether at a given
locus allele1 belongs to the major (gene-level) haplotype
(`allele1IsMajor'), and what the allele frequency is at that SNV of
the allele belonging to the major (gene-level) haplotype (`MAF'). Since assignment
of 'major' status to a haplotypes is based on gene-wide
information, there may be cases when the locus-specific MAF (frequency
of `major' gene haplotype at the locus) is $< 0.5$, as is the case for
the second locus of gene2 in the previous example.

When true haplotypes are unknown, MBASED assigns alleles to `major'
and `minor' haplotypes based on observed read counts, assigning the
allele with higher than expected (under conditions of no ASE) read counts
to the same `major' haplotype. The following example illustrates this
approach using the same data as before, by setting argument `isPhased'
to FALSE:

<<label=example1s_sim_unphased, eval=TRUE, echo=TRUE>>=
summarizeASEResults_1s(
  runMBASED(
    ASESummarizedExperiment=mySample,
    isPhased=FALSE,
    numSim=10^6,
    BPPARAM = SerialParam()
  )
)
@

Note that the pseudo-phasing based`major' haplotype of gene2 consists
of the reference allele at SNV2 and alternative alleles at SNV1
and SNV3. Also note that by design, the gene-level estimate of MAF for
the multi-locus gene2 is higher in
the case of unphased data (0.58 vs. 0.505) and the SNV-level estimates are all $\geq 0.5$. We rely on properly calibrated p-values to
prevent these higher estimates from resulting in spurious ASE calls
due to pseudo-phasing. This is accomplished by employing simulations
(argument \texttt{numSim}) to obtain an approximation to null distribution of
MAF estimates. We used $10^6$ simulations in the previous example and we
recommend at least this many simulations in practice. If parallel architecture is
available (see argument \texttt{BPPARAM} and documentation for
function \texttt{bplapply} in \texttt{R} package \texttt{BiocParallel}), it can be
employed when many genes are tested simulatneously (parallelization is
done over \emph{genes (aseIDs)}, and not \emph{simulations}).  

To illustrate the need for simulations, we show how the results are
affected by bias introduced during the pseudo-phasing step:

<<label=example1s_noSim, eval=TRUE, echo=TRUE>>=

##re-run analysis without simulations
summarizeASEResults_1s(
  runMBASED(
    ASESummarizedExperiment=mySample,
    isPhased=FALSE,
    numSim=0,
    BPPARAM = SerialParam()
  )
)$geneOutput

@

Notice the 3-fold decrease in pValueASE for
gene2 when we skipped the simulations. See
the accompanying paper for further discussion of the internal
simulations used by MBASED. 

The use of parallelization is illustrated in
the example below (not evaluated):
<<label=example1s_parallel, eval=FALSE, echo=TRUE>>=
##re-run analysis while parallelizing computations
## results are same as before 
## with some random flactuations due to simulations
summarizeASEResults_1s(
  runMBASED(
    ASESummarizedExperiment=mySample,
    isPhased=FALSE,
    numSim=10^6,
    BPPARAM = MulticoreParam()
  )
)$geneOutput

## Number of seconds it takes to run results without parallelizing:
system.time(runMBASED(
  ASESummarizedExperiment=mySample,
  isPhased=FALSE,
  numSim=10^6,
  BPPARAM = SerialParam()
))['elapsed'] ## ~ 15 sec on our machine
## Number of seconds it takes to run results with parallelizing:
system.time(runMBASED(
 ASESummarizedExperiment=mySample,
  isPhased=FALSE,
  numSim=10^6,                        
  BPPARAM = MulticoreParam()
))['elapsed'] ## ~9 sec on our machine

@

We also note that for a single-locus gene1, the phasing plays no role,
and the simulation-based p-values are very close to each other
(there's some variability due to random nature of simulations) and are
approximately equal to the analytical p-value based on the binomial test:

<<label=binomTestIllustration, echo=TRUE, eval=TRUE>>=
binom.test(25, 45, 0.5, 'two.sided')$p.value
@ 

Finally, let's consider a case of isoform-specific ASE.  Suppose that
the 3 SNVs in gene2 correspond to 3 different exons, and that 2
transcript isoforms of gene 2 exist: isoform1 uses all 3 exons, and
isoform2 uses only the last 2 exons.  Further, let us assume that 
\begin{itemize}
  \item both isoforms are present in 50/50 ratio
    \item isoform1 shows no ASE
      \item isoform2 shows complete silencing of one of the alleles
        (monoallelic expression, an extreme form of ASE).
  \end{itemize}
Here is an example of data one could observe under this toy scenario:

\begin{table}[h]
  \centering
  \begin{tabular}{|c|c|c|c|}
    \hline
    locus & location & refCount & altCount \\
    \hline
   gene2:SNV1 & chr2:1000 & 23& 26 \\
    \hline
   gene2:SNV2 & chr2:1100 & 65 & 25 \\
    \hline
   gene2:SNV3 & chr2:1200 & 30 & 70 \\
    \hline
  \end{tabular}
  \caption{Example of isoform-specific ASE}
  \label{tab:ex1sIsoformSpecific}
\end{table}

Notice that SNV1 shows lower coverage than the other 2 SNVs, since it
is only expressed by isoform1. Also note that alternative allele at SNV2
and reference allele at SNV3 are silenced in isoform2.  Overall, each
isoform is represented by approximately 50 reads at each SNV that is
a part of that isoform.

<<label=isoform_specific, eval=TRUE, echo=TRUE>>=
isoSpecificExampleSNVs <- mySNVs[2:4,]	
## create input RangedSummarizedExperiment object
isoSpecificExample <- SummarizedExperiment(
  assays=list(
    lociAllele1Counts=matrix(
      c(23, 65, 30),
      ncol=1,
      dimnames=list(
       names(isoSpecificExampleSNVs), 
       'mySample'
      )
    ),
    lociAllele2Counts=matrix(
      c(26,25,70),
      ncol=1, 
      dimnames=list(
       names(isoSpecificExampleSNVs), 
       'mySample'
      )
    )
  ),
  rowRanges=isoSpecificExampleSNVs
)

summarizeASEResults_1s(
  runMBASED(
    ASESummarizedExperiment=isoSpecificExample,
    isPhased=FALSE,
    numSim=10^6,
    BPPARAM = MulticoreParam()
  )
)

@ 

We see that MBASED reports major allele frequency of 0.675 for this
gene. Since the true MAF is 0.5 for isoform1 and 1.0 for isoform2,
the reproted value represents an average of sorts. The small value of
heterogeneity p-value (0.003) indicates that there is strong evidence that ASE
estimates are inconsistent across individual SNVs and that the
reported MAF value might be misleading (it is an aggregate of
isoform-specific values). Also note that the reported ASE p-value is
0. In practice, given the restricitions imposed by the number of
simulations, this means that we estimate $p_{ASE} \leq
\frac{1}{N_{sim}}$. In this instance, we should interpret the outcome
as p-value $< 10^{-6}$. 


\subsection{2-sample analysis}
Next, we show an example of 2-sample ASE analysis using
MBASED. Suppose we want to identify instances of tumor-specifc ASE and
observe the following data:

\begin{table}[h]
  \centering
  \begin{tabular}{|c|c|c|c|c|c|}
    \hline
    locus & location & refCountTumor & altCountTumor & refCountNormal
    & altCountNormal \\
    \hline
   gene1:SNV1 & chr1:100 & 25 & 20 & 18 & 23\\
    \hline
   gene2:SNV1 & chr2:1000 & 10 & 29 & 17 & 19\\
    \hline
   gene2:SNV2 & chr2:1100 & 35 & 15 & 21 & 24\\
    \hline
   gene2:SNV3 & chr2:1200 & 14 & 40 & 25 & 31\\
    \hline
    gene3:SNV1 & chr3:2000 & 35 & 9 & 40 & 10 \\
    \hline
  
    
  \end{tabular}
  \caption{2-Sample example}
  \label{tab:ex2s}
\end{table}

Visual examination reveals that gene1 doesn't exhibit ASE in either
sample, gene2 shows signs of ASE in tumor sample only, and gene3 shows
signs of ASE in both samples.

<<label=example2s, eval=TRUE, echo=TRUE>>=
mySNVs_2s <- GRanges(
  seqnames=c('chr1', 'chr2', 'chr2', 'chr2', 'chr3'),
  ranges=IRanges(start=c(100, 1000, 1100, 1200, 2000), width=1),
  aseID=c('gene1', rep('gene2', 3), 'gene3'),
  allele1=c('G', 'A', 'C', 'A', 'T'),
  allele2=c('T', 'C', 'T', 'G', 'G')	
)
names(mySNVs_2s) <- c('gene1_SNV1', 'gene2_SNV1', 'gene2_SNV2', 'gene2_SNV3', 'gene3_SNV1')
## create input RangedSummarizedExperiment object
myTumorNormalExample <- SummarizedExperiment(
  assays=list(
    lociAllele1Counts=matrix(
      c(
        c(25,10,35,14,35),
        c(18,17,21,25,40)
      ),
      ncol=2,
      dimnames=list(
       names(mySNVs_2s), 
       c('tumor', 'normal')
      )
    ),
    lociAllele2Counts=matrix(
      c(
        c(20,29,15,40,9),
        c(23,19,24,31,10)
      ),
      ncol=2, 
      dimnames=list(
       names(mySNVs_2s), 
       c('tumor', 'normal')
      )
    )
  ),
  rowRanges=mySNVs_2s
)

##example of use
ASEresults_2s <- runMBASED(
  ASESummarizedExperiment=myTumorNormalExample,
  isPhased=FALSE,
  numSim=10^6,
  BPPARAM = SerialParam()
)

## explore the return object
class(ASEresults_2s)
names(assays(ASEresults_2s))
assays(ASEresults_2s)$majorAlleleFrequencyDifference
assays(ASEresults_2s)$pValueASE
assays(ASEresults_2s)$pValueHeterogeneity
rowRanges(ASEresults_2s)
names(metadata(ASEresults_2s))
class(metadata(ASEresults_2s)$locusSpecificResults)
names(assays(metadata(ASEresults_2s)$locusSpecificResults))
assays(metadata(ASEresults_2s)$locusSpecificResults)$allele1IsMajor
assays(metadata(ASEresults_2s)$locusSpecificResults)$MAFDifference
rowRanges(metadata(ASEresults_2s)$locusSpecificResults)

## define function to print out the summary of ASE results
summarizeASEResults_2s <- function(MBASEDOutput) {
  geneOutputDF <- data.frame(
   majorAlleleFrequencyDifference=assays(MBASEDOutput)$majorAlleleFrequencyDifference[,1],
   pValueASE=assays(MBASEDOutput)$pValueASE[,1],  
   pValueHeterogeneity=assays(MBASEDOutput)$pValueHeterogeneity[,1]
  )   
  lociOutputGR <- rowRanges(metadata(MBASEDOutput)$locusSpecificResults)
  lociOutputGR$allele1IsMajor <- assays(metadata(MBASEDOutput)$locusSpecificResults)$allele1IsMajor[,1]
  lociOutputGR$MAFDifference <- assays(metadata(MBASEDOutput)$locusSpecificResults)$MAFDifference[,1]
  lociOutputList <- split(lociOutputGR, factor(lociOutputGR$aseID, levels=unique(lociOutputGR$aseID))) 
  return(
   list(
     geneOutput=geneOutputDF,
     locusOutput=lociOutputList
   )
  )
}
summarizeASEResults_2s(ASEresults_2s)

@ 

Analogous to 1-sample analysis, the output of \texttt{runMBASED()} for 2-sample
analysis is a RangedSummarizedExperiment object
with 3 single-column assay matrices. The matrices are are similar to those in
1-sample case, except our measure of ASE is the difference in major
allele frequency between the two samples. For example, for a
single-SNV gene1, this difference is
$\frac{25}{25+20}-\frac{18}{18+23}=0.1165$. Notice that which allele
is `major' and which is `minor' is determined entirely by read counts
in the first sample (tumor, in this case). 

We would like to emphasize that the 2-sample MBASED algorithm is
designed to find instances of sample1-specific ASE (whatever sample1
may be) and is \emph{not} symmetric with respect to the 2 samples.
Therefore, if we were interested in cases of normal-specific ASE
(e.g., loss of imprinting in cancer), we would re-run MBASED using
normal sample as sample1 and tumor sample as sample2. The following
examples illustrate this important point.

<<label=two_sample_asymmetric, eval=TRUE, echo=TRUE>>=
## single-SNV gene with strong ASE in tumor (25 vs. 5 reads) 
## and no ASE in normal (22 vs. 23 reads):
mySNV <- GRanges(
  seqnames=c('chr1'),
  ranges=IRanges(start=c(100), width=1),
  aseID=c('gene1'),
  allele1=c('G'),
  allele2=c('T')	
)
names(mySNV) <- c('gene1_SNV1')
summarizeASEResults_2s(
  runMBASED(
    ASESummarizedExperiment=SummarizedExperiment(
      assays=list(
        lociAllele1Counts=matrix(
          c(
            c(25),
            c(22)
          ),
          ncol=2,
          dimnames=list(
           names(mySNV), 
           c('tumor', 'normal')
          )
        ),
        lociAllele2Counts=matrix(
          c(
            c(5),
            c(23)
          ),
          ncol=2, 
          dimnames=list(
           names(mySNV), 
           c('tumor', 'normal')
          )
        )
      ),
      rowRanges=mySNV
    ),
    isPhased=FALSE,
    numSim=10^6,
    BPPARAM=SerialParam()
  )
)
## MBASED detects highly significant ASE.
##
## Now, suppose that the normal sample had the two allele counts 
## exchanged (due to chance variation), :
summarizeASEResults_2s(
  runMBASED(
    ASESummarizedExperiment=SummarizedExperiment(
      assays=list(
        lociAllele1Counts=matrix(
          c(
            c(25),
            c(23) ## used to be 22
          ),
          ncol=2,
          dimnames=list(
           names(mySNV), 
           c('tumor', 'normal')
          )
        ),
        lociAllele2Counts=matrix(
          c(
            c(5),
            c(22) ## used to be 23
          ),
          ncol=2, 
          dimnames=list(
           names(mySNV), 
           c('tumor', 'normal')
          )
        )
      ),
      rowRanges=mySNV
    ),
    isPhased=FALSE,
    numSim=10^6,
    BPPARAM=SerialParam()
  )
)
## We get virtually the same results
##
## Now, suppose we treated normal as sample1 and tumor as sample2
## Let's use original normal sample allele counts
summarizeASEResults_2s(
  runMBASED(
    ASESummarizedExperiment=SummarizedExperiment(
      assays=list(
        lociAllele1Counts=matrix(
          c(
            c(22),
            c(25) 
          ),
          ncol=2,
          dimnames=list(
           names(mySNV), 
           c('normal', 'tumor')
          )
        ),
        lociAllele2Counts=matrix(
          c(
            c(23),
            c(5) 
          ),
          ncol=2, 
          dimnames=list(
           names(mySNV), 
           c('normal', 'tumor')
          )
        )
      ),
      rowRanges=mySNV
    ),
    isPhased=FALSE,
    numSim=10^6,
    BPPARAM=SerialParam()
  )
)
## We appear to have recovered the same result: highly significant MAF difference
## (but note that allele2 is now 'major', since allele classification into 
## major/minor is based entirely on sample1)
## BUT: consider what happens if by chance the allelic
## ratio in the normal was 23/22 instead of 22/23:
summarizeASEResults_2s(
  runMBASED(
    ASESummarizedExperiment=SummarizedExperiment(
      assays=list(
        lociAllele1Counts=matrix(
          c(
            c(23), ## used to be 22
            c(25) 
          ),
          ncol=2,
          dimnames=list(
           names(mySNV), 
           c('normal', 'tumor')
          )
        ),
        lociAllele2Counts=matrix(
          c(
            c(22), ## used to be 23
            c(5) 
          ),
          ncol=2, 
          dimnames=list(
           names(mySNV), 
           c('normal', 'tumor')
          )
        )
      ),
      rowRanges=mySNV
    ),
    isPhased=FALSE,
    numSim=10^6,
    BPPARAM=SerialParam()
  )
)
## MAF difference is large in size but negative and the finding is no longer 
## significant (MBASED uses a 1-tailed significance test).
##
## We therefore strongly emphasize that the proper way to detect normal-specific ASE
## would be to treat normal sample as sample1 and tumor sample as sample2.
@ 




\subsection{Adjusting for pre-exiting allelic bias}

In a given sample, MBASED models the detected haplotype 1 allele
counts $X_{hap1, SNV}$ at each SNV within gene $g$ as
independent random variables with 
\begin{equation}
  \label{eq:betaBinomModel}
  X_{hap1, SNV} \sim BetaBin(n=n_{SNV},\mu=f_{hap1,SNV}(p_{hap1,g}),\rho=\rho_{SNV})
  \end{equation}
where 
\begin{equation}
  E(X_{hap1,SNV})=n\mu
  \end{equation}
 and 
\begin{equation}
  var(X_{hap1,SNV})={\mu}(1-\mu){\rho}n(n-1+frac{1}{\rho})
  \end{equation}
If dispersion parameter $\rho_{SNV}=0$ (this is the default model assumed by MBASED), the model reduces to the binomial model
\begin{equation}
  \label{eq:binomModel}
  X_{hap1, SNV} \sim Bin(n=n_{SNV}, p=f_{hap1,SNV}(p_{hap1,g}))
  \end{equation}
We will now assume the no-overdispersion binomial model (\ref{eq:binomModel}) and will
describe extensions to non-zero dispersions in the next section. By default, MBASED assumes that
\begin{equation}
  f_{hap1,SNV}(p_{hap1,g})=p_{hap1,g}
  \end{equation}
In other words, the underlying frequency of observed haplotype
1-supporting reads is equal to the frequency of haplotype 1
transcripts in the cell. In practice, this may not be the case.  For
example, the sample might undergo some enrichment procedure that results
in global over-representation of reference allele-supporting reads. Or
the aligner used to map reads to reference genome might favor one or
the other allele at some SNVs due to the presence of a homologous region
elsewhere in the genome.  In such cases, 
\begin{equation}
f_{hap1,SNV}(p_{hap1,g}) \neq p_{hap1,g}
\end{equation}
We refer to the situation where one allele is favored over another in
the read data, even in absence of ASE, as `pre-existing allelic bias'.
MBASED assumes that $f_{hap1,SNV}(p_{hap1,g})$ satisfies the following
functional constraint:
\begin{equation}
  f_{hap1,SNV}(p_{hap1,g})=\frac{f_{hap1,SNV}(0.5) \times
  p_{hap1,g}}{f_{hap1,SNV}(0.5) \times p_{hap1,g} + f_{hap2,SNV}(0.5)
  \times p_{hap2,g}}
  \end{equation}
In words, $f_{hap1,SNV}(p_{hap1,g})$ is proportional to both
$p_{hap1,g}$ and $f_{hap1,SNV}(0.5)$ (the underlying frequency of
observed haplotype 1-supporting reads under conditions of no ASE) and
is uniquely determined by these two frequencies. MBASED adjusts its
estimates of ASE and corresponding statistical significance, when
supplied with values of probabilities of observing allele 1-supporting
reads under conditions of no ASE, $f_{hap1,SNV}(0.5)$ in our
notation. As an example, consider a hypothetical case of known
reference allele bias, where under conditions of no ASE
($p_{hap1,g}=p_{hap2,g}=0.5$) the frequency of observed reference
allele-supporting reads is 60\% ($f_{ref,SNV}(0.5)=0.6$ and
$f_{alt,SNV}(0.5)=0.4$) for all SNVs. 
Suppose we observe the following read counts:
\begin{table}[h]
  \centering
  \begin{tabular}{|c|c|c|c|c|}
    \hline
    locus & location & refCount & altCount & fractionRef \\
    \hline
   gene1:SNV1 & chr1:100 & 20 & 25 & 0.49 \\
    \hline
   gene2:SNV1 & chr2:1000 & 17 & 9 & 0.65 \\
    \hline
   gene2:SNV2 & chr2:1100 & 22 & 15 & 0.59 \\
    \hline
   gene2:SNV3 & chr2:1200 & 20 & 10 & 0.67 \\
    \hline
  
    
  \end{tabular}
  \caption{Example of reference bias in the data}
  \label{tab:ex1sRefBias}
\end{table}

Notice that gene2 is exhibiting 60/40 ratio of reference to
alternative allele read counts, which is what we expect of genes with
no ASE under the reference allele bias described above. In contrast, gene1 shows
overexpression of alternative allele, which may actually be seen as evidence \emph{for}
ASE. MBASED allows one to specify the extent of pre-existing allelic
bias by providing a corresponding matrix in the assays of the input
RangedSummarizedExperiment object. By default, MBASED assumes that the background (no ASE) allelic
ratio is 50/50:

<<label=example1s_refBias_no_adjustment, eval=TRUE, echo=TRUE>>=
mySNVs
## run MBASED with default values:
summarizeASEResults_1s(
  runMBASED(
    SummarizedExperiment(
      assays=list(
        lociAllele1Counts=matrix(
          c(20,17,15,20),
          ncol=1,
          dimnames=list(
           names(mySNVs), 
           'mySample'
          )
        ),
        lociAllele2Counts=matrix(
          c(25,9,22,10),
          ncol=1, 
          dimnames=list(
           names(mySNVs), 
           'mySample'
          )
        )
      ),
      rowRanges=mySNVs
    ),
    isPhased=FALSE,
    numSim=10^6,
    BPPARAM=SerialParam()
  )
)
## we get the same results by explicitly specifying 50/50 pre-existing allelic probability
summarizeASEResults_1s(
  runMBASED(
    SummarizedExperiment(
      assays=list(
        lociAllele1Counts=matrix(
          c(20,17,15,20),
          ncol=1,
          dimnames=list(
           names(mySNVs), 
           'mySample'
          )
        ),
        lociAllele2Counts=matrix(
          c(25,9,22,10),
          ncol=1, 
          dimnames=list(
           names(mySNVs), 
           'mySample'
          )
        ),
        lociAllele1CountsNoASEProbs=matrix(
          rep(0.5, 4),
          ncol=1, 
          dimnames=list(
           names(mySNVs), 
           'mySample'
          )
        )
      ),
      rowRanges=mySNVs
    ),
    isPhased=FALSE,
    numSim=10^6,
    BPPARAM=SerialParam()
  )
)
 
@

Note that we labeled 3 out of 4 reference alleles as allele1 and the corresponding
alternative alleles as allele2 (the sole exception is SNV2 of gene2,
where alternative allele is allele1). As can be expected, not accounting for pre-existing alleic bias results in
gene2 showing strong evidence of ASE (p-value=0.04, all reference
alleles are assigned to major haplotype). We can fix the
problem by changing the value of \texttt{lociAllele1CountsNoASEProbs}
assay matrix to  the correct values of probabilites
of observing allele1 under the conditions of no ASE:

<<label=example1s_refBias_adjustment, eval=TRUE, echo=TRUE>>=
##run the analysis adjusting for pre-existing allelic bias
summarizeASEResults_1s(
  runMBASED(
    SummarizedExperiment(
      assays=list(
        lociAllele1Counts=matrix(
          c(20,17,15,20),
          ncol=1,
          dimnames=list(
           names(mySNVs), 
           'mySample'
          )
        ),
        lociAllele2Counts=matrix(
          c(25,9,22,10),
          ncol=1, 
          dimnames=list(
           names(mySNVs), 
           'mySample'
          )
        ),
        lociAllele1CountsNoASEProbs=matrix(
          c(0.6, 0.6, 0.4, 0.6),
          ncol=1, 
          dimnames=list(
           names(mySNVs), 
           'mySample'
          )
        )
      ),
      rowRanges=mySNVs
    ),
    isPhased=FALSE,
    numSim=10^6,
    BPPARAM=SerialParam()
  )
)

@

Notice that the estimate of MAF for gene2 went down from 0.63 to 0.54,
and the p-value went up from 0.04 to 0.86.  In contrast, MAF for gene1
went up from 0.56 to 0.66 and the p-value dropped from 0.55 to 0.05
(as we are much less likely to observe overexpression of alternative
allele if the bias in the data favors the reference allele). 

When 2-sample analysis is performed, the second column of \texttt{lociAllele1CountsNoASEProbs} specifies no-ASE allelic probabilities for the same alleles in sample 2,
(and thus MBASED allows for possibility that pre-existing allelic biases are
different in the two samples). 

In our own work, we assumed that the no-ASE probability of observing
reference allele-supporting read was the same across all heterozygous loci within
each sample (global reference bias) and estimated it for our data to be
approximately 0.52 (see the accompanying paper for the details of the
estimation procedure). A better approach would be to estimate this
probability separately at each SNV based on a large number of samples
known to not exhibit ASE at that locus (and keeping the
protocol/sequencing/alignment pipeline constant). Currently MBASED
provdies no functionality for estimating the extent of pre-existing
allelic bias and the user is advised to investigate their data prior
to changing the default values of the relevent function
arguments. 



\subsection{Adjusting for overdispersion}
By default, MBASED assumes that dispersion parameter $\rho$ in
model \ref{eq:betaBinomModel} is 0, leading to binomial model
\ref{eq:binomModel}. In practice, extra-binomial dispersion may be
present in the sequencing read count data and needs to be taken into
account in order to assign proper statistical significance to observed
levels of ASE. Below we generate some counts from beta-binomial
distribution and show how model misspecification (assuming data to be
binomial) affects ASE calling.  We use our earlier total read
counts for single-SNV gene1 and 3-SNV gene2. We also use the same
value of overdispersion parameter $\rho=0.02$ at each SNV.  

<<label=overdispersion_example, eval=TRUE, echo=TRUE>>=
set.seed(5) ## we chose this seed to get a 'significant' result
totalAlleleCounts=c(45, 26, 37, 30)
## simulate allele1 counts
allele1Counts <- MBASED:::vectorizedRbetabinomMR(
  n=4,
  size=totalAlleleCounts,
  mu=rep(0.5, 4), 
  rho=rep(0.02, 4)
)
## run MBASED without accounting for overdispersion
summarizeASEResults_1s(
  runMBASED(
    SummarizedExperiment(
      assays=list(
        lociAllele1Counts=matrix(
          allele1Counts,
          ncol=1,
          dimnames=list(
           names(mySNVs), 
           'mySample'
          )
        ),
        lociAllele2Counts=matrix(
          totalAlleleCounts-allele1Counts,
          ncol=1, 
          dimnames=list(
           names(mySNVs), 
           'mySample'
          )
        )
      ),
      rowRanges=mySNVs
    ),
    isPhased=FALSE,
    numSim=10^6,
    BPPARAM=SerialParam()
  )
)

## this is the same as explicitly setting dispersion parameters to 0.
summarizeASEResults_1s(
  runMBASED(
    SummarizedExperiment(
      assays=list(
        lociAllele1Counts=matrix(
          allele1Counts,
          ncol=1,
          dimnames=list(
           names(mySNVs), 
           'mySample'
          )
        ),
        lociAllele2Counts=matrix(
          totalAlleleCounts-allele1Counts,
          ncol=1, 
          dimnames=list(
           names(mySNVs), 
           'mySample'
          )
        ),
        lociCountsDispersions=matrix(
          rep(0, 4),
          ncol=1, 
          dimnames=list(
           names(mySNVs), 
           'mySample'
          )
        )
      ),
      rowRanges=mySNVs
    ),
    isPhased=FALSE,
    numSim=10^6,
    BPPARAM=SerialParam()
  )
)


## now re-run MBASED supplying the correct dispersion values:
summarizeASEResults_1s(
  runMBASED(
    SummarizedExperiment(
      assays=list(
        lociAllele1Counts=matrix(
          allele1Counts,
          ncol=1,
          dimnames=list(
           names(mySNVs), 
           'mySample'
          )
        ),
        lociAllele2Counts=matrix(
          totalAlleleCounts-allele1Counts,
          ncol=1, 
          dimnames=list(
           names(mySNVs), 
           'mySample'
          )
        ),
        lociCountsDispersions=matrix(
          rep(0.02, 4),
          ncol=1, 
          dimnames=list(
           names(mySNVs), 
           'mySample'
          )
        )
      ),
      rowRanges=mySNVs
    ),
    isPhased=FALSE,
    numSim=10^6,
    BPPARAM=SerialParam()
  )
)

@

We observe that after taking overdispersion into account, gene1 had
its ASE p-value increase from 0.55 to 0.67, and gene2 had the pvalue
increase from 0.05 to 0.19. In practice, not taking overdispersion
into account leads to a number of false positive ASE calls, with the
number of false positives rising as the extent of overdispersion
increases. Therefore it is important to have a good grasp of how much
dispersion is present in the data. Also note a slight change in the
estimate of major allele frequency for gene2, which results from
incorporation of extra-variability into the estimate during
the meta-analytic integration of ASE information from multiple SNVs within that gene.

When 2-sample analysis is performed, the second column of
\texttt{lociCountsDispersions} specifies dispersion parameter values
for the same SNVs in sample 2,
(and thus MBASED allows for possibility that the extent of overdispersion is
different in the two samples). 

In our own work, we assumed that the dispersion was the same across all loci within
each sample and estimated it for our data to be
approximately 0.004  (see the accompanying paper for the details of the
estimation procedure). A better approach would be to estimate the dispersion separately at each SNV based on a large number of samples
known to not exhibit ASE at that locus (and keeping the
protocol/sequencing/alignment pipeline constant). Currently MBASED
provdies no functionality for estimating the extent the dispersion and the user is advised to investigate their data prior
to changing the default values of the relevent function arguments. 


\section{Session Info}
<<label=session_info, eval=TRUE, echo=TRUE>>=
sessionInfo()
@ 

\end{document}
